
1000 ReturnStackSize !
2000 StackSize !
8000 ScreenStackSize !
9999 MemorySize !

Use Crt.frl
Use KbdCodes.frl
Use DOS.frl

Variable COMPFLAG

Create SETUP
80 Allot                   \   0 - External Editor Name
80 Allot                   \  80 - External Assembler Name
80 Allot                   \ 160 - Work File Name
80 Allot                   \ 240 - Command Line
80 Allot                   \ 320 - External Linker Name

Here Setup - Constant SETUPLENGTH
Setup CodeSegment SetupLength 0 MFill

: FILLSETUP
   a" edit %f.%e" Setup 000 + 0 79 Copy*
   a" tasm %f.%e" Setup 080 + 0 79 Copy*
   a" noname.frt" Setup 160 + 0 79 Copy*
   a" tlink %f/t" Setup 320 + 0 79 Copy*
;

FillSetup
Forget FILLSETUP

128 Constant COMMANDLINE

Variable LASTITEM

Variable KEYBUFF
Variable KEYCOUNT
Variable MACROFLAG

Variable ADDR
Variable ADDR2
Variable ADDR3

Variable @BUFF1
Variable @BUFF2

: BUFFER1 @BUFF1 @ ;
: BUFFER2 @BUFF2 @ ;

" COMSPEC=" ASCIIz COMSPEC

Variable @SHELL

: SHELL
   @Shell @
;

0 Constant FIRST&LAST
1 Constant FIRST
2 Constant LAST
3 Constant MIDDLE

Variable CURRENTPROC

: COMPARE2 ( Off1 Seg1 Off2 Seg2 Count --> EqualFlag )
   0 Do
      2Over Swap i + Swap
      2Over Swap i + Swap ac@
      Rot Rot ac@ =
      IfNot
         r> r> r> 2Drop 2Drop 2Drop Drop False Exit
      Then
   Loop
   2Drop 2Drop
   True
;

: SEARCH4COMMAND
   $ 2c @ Addr !
   0 Addr2 !
   Begin
      Addr2 @ Addr @ a@
   While
      Addr2 @ Addr @ ComSpec CodeSegment ComSpec ASCIIzLen Compare2
      If
         ComSpec ASCIIzLen Addr2 @ + Addr2 !
         Shell Addr3 !
         Begin
            Addr2 @ Addr @ ac@ Dup
         While
            Addr3 @ c!
            Addr2 1+!
            Addr3 1+!
         Repeat
         Drop
         Exit
      Else
         Begin
            Addr2 1+!
            Addr2 @ Addr @ ac@ 0=
         Until
         Addr2 @ Addr @ a@ If Addr2 1+! Then
      Then
   Repeat
;

Variable LASTKEY

: GETKEY
   KeyCount @
   If
      $ 1221 Span !
      KeyBuff @
      KeyCount 1-!
      KeyCount @
      IfNot
         0 Span !
      Then
   Else
      0 Span !
      Key
   Then
   Dup LastKey !
   MacroFlag @
   If
      Case
         Alt+F5 Of
            27
         EndOf
         27 Of
            0 LastKey !
            27
         EndOf
         Alt+X Of
            27 LastKey !
            27
         EndOf
      EndCase
   Then
;

Variable TIMEX
Variable TIMEY

Registers REGS

: FULLSCREEN
   0 0 79 24 SetWindow
;

: OUTFILENAME ( --> )
   PushState
   0 24 67 24 SetWindow
   0 7 Color
   ClearWindow
   3 24 GotoXY
   Setup 160 +
   .ASCIIz
   PopState
;

: OUTFREEMEM ( --> )
   PushState
   $ 4800 Regs !
   -1 Regs BX !
   Regs FDOS
   Regs BX @ 16/ u2/ u2/
   0 7 Color
   FullScreen
   68 24 GotoXY
   3 .r ."  K free"
   PopState
;

: VMENU ( HighAttr --> ItemNo )
   >r
   0 TimeX !
   Begin
      GetWindow MakeWindow
      GetWindow 2Drop TimeX @ +
      GetWindow Drop Press Swap - 1+
      r@ HighLight
      Key
      RemoveWindow
      Case
         27 Of
            -1 r> Drop Exit
         EndOf
         Down Of
            GetWindow 2Drop Press TimeX @ +
            GetWindow Press Press Press =
            If
               0 TimeX !
            Else
               TimeX 1+!
            Then
         EndOf
         Up Of
            TimeX @
            If
               TimeX 1-!
            Else
               GetWindow Press Swap - Press TimeX !
            Then
         EndOf
         13 Of
            TimeX @ r> Drop Exit
         EndOf
            Drop
      EndCase
   Again
;

: SETKEY ( KeyCode KeyCount --> )
   KeyCount ! KeyBuff !
;

: SHADOW ( --> )
   GetWindow
   >r Swap >r >r Drop
   176 7 r> 1- r> 1+ Over 1+ r> FillWindow
   GetWindow
   >r >r Drop >r
   176 7 r> 2+ r> r> Swap Over FillWindow
   GetWindow 2 1 d-
   SetWindow
;

: DRAWPIC
   CursorOff
   177 7 0 0 79 24 FillWindow
   Bl $ 70 0 0 79 0 FillWindow
   0 7 Color
   a"  Info   File   Edit   Compile   Run   Assemble   Optimize   Setup"
   3 69 0 Center
   Bl $ 70 0 24 79 24 FillWindow
   OutFreeMem
   OutFileName
;

: MESSAGE ( ASCIIzString --> )
   0 24 79 24 MakeWindow
   0 7 Color
   ClearWindow
   0 79 24 Center
;

Create STRUCT
0 , 78 , 11 c, 7 c, 70 c, $ 30 c, 0 c, 255 c, 0 , 0 c, 2 c, 27 , 13 ,

: EDITLINE ( StringAddress --> )
   Dup Struct !
   Buffer2 0 80 Copy*
   ['] Key Struct 10 + !
   CursorOn
   Struct EditString
   CursorOff
   Struct 12 + c@ IfNot Buffer2 Struct @ 0 80 Copy* Then
;

: ?ESC
   Struct 12 + c@ IfNot r> Drop Exit Then
;

: SETEDITLINE ( ASCIIzSayLine --> )
   3 8 76 14 MakeWindow
   Shadow
   8 9 1 StdBorder
   15 1 Color
   ClearWindow
   Cr 3 Spaces .ASCIIz
   a" Use %f for current file name without extension, %e for extension" Message
   6 11 71 11 SetWindow
   0 3 Color
   ClearWindow
;

: INFO
   10 8 69 15 MakeWindow
   Shadow
   8 11 3 StdBorder
   14 3 Color
   ClearWindow
   ." \r\n             GP-Forth Shell. Version "
   $ 103 c@ . c" . Emit $ 104 c@ . ." \r\n"
   ."   Copyright (C), 1993 by The Golden Porcupine Software\r\n"
   ."                   * * * * * * * * * *\r\n"
   Key Drop
   RemoveWindow
;

: BYE
   RemoveWindow
   Bye
;

: ?EXIT ( --> ItemNo )
   13 8 65 15 MakeWindow
   Shadow
   8 12 4 StdBorder
   14 4 Color
   ClearWindow
   a" Exit GP-Forth Shell?" 10 65 10 Center
   15 4 Color
   a" ^Exit^to^DOS^ ^Cancel^ ^Save^setup^&^exit^"
   ['] Key $ 70 13 65 12 HMenu
   IfNot Drop 1 Then
   RemoveWindow
;

: GETFULLNAME ( --> ASCIIzAddress )
   Here 0!
   Here Addr !
   $ 2c @ Addr2 !
   0 Addr3 !
   Begin
      Addr3 @ Addr2 @ a@
   While
      Addr3 1+!
   Repeat
   Addr3 2+!
   Addr3 @ Addr2 @ a@ 1 =
   If
      Addr3 2+!
      Here TimeX !
      Begin
         Addr3 @ Addr2 @ ac@ Dup
         TimeX @ c!
      While
         Addr3 1+!
         TimeX 1+!
      Repeat
   Then
   Here
;

: CHANGEFULLNAME ( ASCIIzNewName --> Buffer1=ResultASCIIz )
   TimeY !
   GetFullName Drop
   TimeX 0!
   Begin
      Here a" \\" TimeX @ Pos* Dup 0<
      If
         Drop
         True
      Else
         1+ TimeX !
         False
      Then
   Until
   Here TimeX @ + 0!
   Here Buffer1 0 80 Copy*
   Buffer1 TimeY @ Buffer1 Concat*
   Buffer1
;

: SAVESETUP
   GetFullName Buffer1 0 80 Copy*

   3 8 76 14 MakeWindow
   Shadow
   8 9 1 StdBorder
   15 1 Color
   ClearWindow
   ." \r\n   Enter new shell name to save setup:"
   6 11 71 11 SetWindow
   0 3 Color
   ClearWindow
   Buffer1 EditLine
   RemoveWindow

   ?ESC

   GetFullName
   Buffer1 0 FCreate
   If
      $ 109 @ >r $ 10d @ $ 109 !
      Dup Addr ! 256 CodeSegment $ 10d @ 256 - FWrite
      r> $ 109 !
      If
         $ 10d @ 256 - =
         If
            Addr @ FClose
            IfNot
               a"   Cannot close file FSELL.COM  " Error
            Then
         Else
            a"   Cannot write. May be, FSELL.COM is compessed...  " Error
         Then
      Else
         a"   Disk write error  " Error
      Then
   Else
      a"   Cannot save setup. Disk is write protected?  " Error
   Then
;

: QUITTODOS
   ?Exit
   Case
      0 Of
         Bye
      EndOf
      2 Of
         SaveSetup
         Bye
      EndOf
         Drop
   EndCase
;

: ?DOSERR
   $ 4d00 Regs !
   Regs FDOS
\   Regs @
   True
;

: ERROR ( ASCIIzError --> )
   Dup >r ASCIIzLen Dup 80 Swap - u2/ 2- 2-
   Swap Over + 7 + 9 Swap 15 MakeWindow
   Shadow
   8 12 4 StdBorder
   14 4 Color
   ClearWindow
   r> 0 77 11 Center
   0 7 Color
   a"  Ok " 0 77 13 Center
   Begin Key Dup 13 = Swap 27 = Or Until
   RemoveWindow
;

: ENTERDOSCOMMAND ( ASCIIzCommand --> SuccessFlag )
   >r
   [ c" c 256 * c" / + ] Literal CommandLine !
   0 CommandLine 2+ c!
   CommandLine r> CommandLine Concat*
   CommandLine ASCIIz>
   CurrentProc @ Dup First = Swap First&Last = Or
   If
      RemoveWindow
   Then
   Shell CommandLine 0 Exec Drop
   CurrentProc @ Dup Last = Swap First&Last = Or
   If
      (InitCrt)
      0 0 79 24 MakeWindow
      DrawPic
   Then
   ?DOSERR
;

: %F ( --> Buffer2=ASCIIzFileName )
   TimeX 0!
   Begin
      Setup 160 + a" \\" TimeX @ Pos* Dup 0<
      If
         Drop
         True
      Else
         1+ TimeX !
         False
      Then
   Until
   Setup 160 + a" ." TimeX @ Pos* Dup 0<
   If
      Drop
      Setup 160 + ASCIIzLen
   Then
   >r
   Setup 160 + Buffer2 0 r> Copy*
   Buffer2
;

: %E ( --> Buffer2=ASCIIzFileName )
   TimeX 0!
   Begin
      Setup 160 + a" \\" TimeX @ Pos* Dup 0<
      If
         Drop
         True
      Else
         1+ TimeX !
         False
      Then
   Until
   Setup 160 + a" ." TimeX @ Pos* Dup 0<
   If
      Drop
      80
   Else
      1+
   Then
   >r
   Setup 160 + Buffer2 r> 80 Copy*
   Buffer2
;

: MAKECOMMANDLINE ( ASCIIzProgram --> Buffer1=ExpandedCommandLine )
   Buffer1 0 80 Copy*
   Begin
      Buffer1 a" %f" 0 Pos* Dup 0<
      If
         Drop
         True
      Else
         Addr2 !
         Buffer1 Dup Addr2 @ 2 Delete*
         Buffer1 Dup %f Addr2 @ Insert*
         False
      Then
   Until
   Begin
      Buffer1 a" %e" 0 Pos* Dup 0<
      If
         Drop
         True
      Else
         Addr2 !
         Buffer1 Dup Addr2 @ 2 Delete*
         Buffer1 Dup %e Addr2 @ Insert*
         False
      Then
   Until
   Buffer1
;

: OPEN
;

: NEW
   False CompFlag !
   3 8 76 14 MakeWindow
   Shadow
   8 9 1 StdBorder
   15 1 Color
   ClearWindow
   ." \r\n   Enter work file name:"
   6 11 71 11 SetWindow
   0 3 Color
   ClearWindow
   Setup 160 + EditLine
   RemoveWindow
   OutFileName
;

: DOSSHELL
   RemoveWindow
   14 0 Color
   ." \r\nType EXIT to return GP-Forth Shell"
   7 0 Color Cr
   Shell NullString 0 Exec Drop
   (InitCrt)
   0 0 79 24 MakeWindow
   DrawPic
;

: SETVMENU ( X1 Y1 X2 Y2 --> )
   MakeWindow
   Shadow
   GetWindow >r >r 1+ r> r> SetWindow
   "        " 0 7 MakeBorder
   0 7 Color
   ClearWindow
   GetWindow >r >r >r 1+ r> r> 1- r> SetWindow
   Home Cr Home
;

: ?SEARCH
   Here 0 80 Copy*
   80 0
   Do
      Here i + c@ Bl =
      If Here i + 0! Then
   Loop
   Here FindFirst
;

: FILE
   10 0 27 6 SetVMenu
   ."  New\r\n DOS Shell\r\n Exit"
   7 VMenu
   RemoveWindow
   Case
      0 Of
         New
      EndOf
      1 Of
         DOSShell
      EndOf
      2 Of
         QuitToDOS
      EndOf
         Drop
   EndCase
;

: EDIT
\   Setup ?Search
\   IfNot
\      a"   Editor not found  " Error Exit
\   Then
   False CompFlag !
   First&Last CurrentProc !
   Setup MakeCommandLine EnterDOSCommand
   IfNot
      a"   Edit failure  " Error
   Then
;

: COMPILE
   First&Last CurrentProc !
   a" forth.com" ChangeFullName a"  %f.%e" Buffer2 Concat*
   Buffer2 MakeCommandLine EnterDOSCommand
   If
      True CompFlag !
   Else
      a"   Forth compiler not found  " Error
   Then
;

: RUNPROGRAM
   First&Last CurrentProc !
   CompFlag @
   IfNot
      First CurrentProc !
      a" forth.com" ChangeFullName a"  %f.%e" Buffer2 Concat*
      Buffer2 MakeCommandLine EnterDOSCommand
      If
         True CompFlag !
      Else
         a"   Forth compiler not found  " Error
      Then
      Last CurrentProc !
   Then
   a" %f.com " Setup 240 + Buffer1 Concat*
   Buffer1 MakeCommandLine EnterDOSCommand
   IfNot
      a"   Executable file not found  " Error
   Then
   $ f00 Regs !
   $ 10 Regs Intr
   Vram @ $ b000 =
   If 7 Else 3 Then Dup >R Regs c@ =
   If
      R> Drop
   Else
      Key Drop
      R> Regs !
      $ 10 Regs Intr
   Then
;

: ENTERCOMMANDLINE
   a" Enter command line:"
   SetEditLine
   Setup 240 + EditLine
   RemoveWindow
   RemoveWindow
;

: RUN
   34 0 59 5 SetVMenu
   ."  Run program\r\n Enter command line"
   7 VMenu
   RemoveWindow
   Case
      0 Of
         RunProgram
      EndOf
      1 Of
         EnterCommandLine
      EndOf
         Drop
   EndCase
;

: ASSEMBLE
   First CurrentProc !
   Setup 80 + MakeCommandLine EnterDOSCommand
   IfNot
      (InitCrt)
      0 0 79 24 MakeWindow
      DrawPic
      a"   Assembler failure  " Error Exit
   Then
   Last CurrentProc !
   Setup 320 + MakeCommandLine EnterDOSCommand
   IfNot
      a"   Linker failure  " Error
   Then
;

: OPTIMIZE
   First&Last CurrentProc !
   a" opt.com" ChangeFullName a"  %f" Buffer2 Concat*
   Buffer2 MakeCommandLine EnterDOSCommand
   If
      True CompFlag !
   Else
      a"   Forth code optimizer not found  " Error
   Then
;

: EDITOR
   a" Select which editor to use for \ea\30;Edit\ea\31;:"
   SetEditLine
   Setup EditLine
   RemoveWindow
   RemoveWindow
;

: COMPILER
;

: ASSEMBLER
   a" Select which assembler to use for \ea\30;Assemble\ea\31;:"
   SetEditLine
   Setup 80 + EditLine
   RemoveWindow
   RemoveWindow
;

: LINKER
   a" Select which linker to use for \ea\30;Assemble\ea\31;:"
   SetEditLine
   Setup 320 + EditLine
   RemoveWindow
   RemoveWindow
;

: INSTALL
   59 0 77 7 SetVMenu
   ."  Editor\r\n Assembler\r\n Linker\r\n Save setup"
   7 VMenu
   RemoveWindow
   Case
      0 Of
         Editor
      EndOf
      1 Of
         Assembler
      EndOf
      2 Of
         Linker
      EndOf
      3 Of
         SaveSetup
      EndOf
         Drop
   EndCase
;

: MENU ( --> )
   0 7 Color
   CursorOff
   Right LastItem @ SetKey
   True MacroFlag !
   a" ^Info^ ^File^ ^Edit^ ^Compile^ ^Run^ ^Assemble^ ^Optimize^ ^Setup^"
   ['] GetKey 7 3 71 0 HMenu
   False MacroFlag !
   If
      Dup LastItem !
      Case
         0 Of
            Info
         EndOf
         1 Of
            File
         EndOf
         2 Of
            Edit
         EndOf
         3 Of
            Compile
         EndOf
         4 Of
            Run
         EndOf
         5 Of
            Assemble
         EndOf
         6 Of
            Optimize
         EndOf
         7 Of
            Install
         EndOf
            Drop
      EndCase
   Else
      LastKey @ 27 =
      If
         Drop
         QuitToDOS
      Else
         LastItem !
         RemoveWindow
         Key Drop
         0 0 79 24 MakeWindow
         DrawPic
      Then
   Then
;

: MAIN
   False CompFlag !
   1 LastItem !
   Here @Shell !
   80 Allot
   Here @BUFF1 !
   80 Allot
   Here @BUFF2 !
   80 Allot
   Shell CodeSegment 240 0 MFill
   Search4Command
   0 0 79 24 MakeWindow
   DrawPic
   Info
   Begin
      Menu
      DropAll
   Again
;

False Messages !
' BYE ErrorProc !
True Debug !

Build 4th.com 4th.map
