
Use Cr.frl

Variable ESC

Variable 8FLAG 8Flag 0!

\ : EMIT ( Char --> )
\    255 And
\    Case
\       8 Of
\          8 Emit
\          8Flag @ 0= 8Flag !
\       EndOf
\       9 Of
\          8Flag @
\          If
\             9 Emit
\             8Flag 0!
\          Else
\             Begin
\                WhereX GetWindow Drop 2Drop - 7 And
\             While
\                Bl Emit
\             Repeat
\          Then
\       EndOf
\          Emit
\          8Flag 0!
\    EndCase
\ ;

: INKEY
   ?Key Dup
   If Drop Then
;

: HOME
   12 Emit
;

: PUSHSTATE ( --> )
   ." \ees"
;

: POPSTATE ( --> )
   ." \eel"
;

: CURSOROFF ( --> )
   ." \ec\0;"
;

: CURSORON ( --> )
   ." \ec\1;"
;

: SELECTCURSOR ( Driver# --> )
   ." \ec" Emit
;

: SCROLLUP ( --> )
   ." \edu"
;

: SCROLLDOWN ( --> )
   ." \edd"
;

: SCROLLLEFT ( --> )
   ." \edl"
;

: SCROLLRIGHT ( --> )
   ." \edr"
;

: SETBIOSOUT ( --> )
   3 SelectCursor
;

: MOVEUP ( --> )
   ." \euu"
;

: MOVEDOWN ( --> )
   ." \eud"
;

: MOVELEFT ( --> )
   ." \eul"
;

: MOVERIGHT ( --> )
   ." \eur"
;

: CLEARWINDOW ( --> )
   ." \ede\12;"
;

: SETCURSORLINES ( Start End --> )
   ." \ec\1;\eb" 15 And Swap 15 And 16 * + Emit
;

: SETCURSORCOLOR ( CursorColor CharUnderCursorColor --> )
   ." \ec\2;\eb" 15 And Swap 15 And 16 * + Emit
;

: EMITSPEC ( SpecCharacter --> )
   ." \ef" Emit
;

: MAKEWINDOW ( x1 y1 x1 y2 -- > )
   PushState
   SetWindow
   GetWindow
   PushWindow
   PushState
   12 Emit
;

: REMOVEWINDOW ( --> )
   PopState
   GetWindow
   2drop PopWindow
   PopState
;

: GOTOXY ( X Y --> )
   ." \eg" Swap Emit Emit
;

: MAKEBORDER ( String Color Back --> )
   16 * +
   >r >r GetWindow r> r> Border
   GetWindow >r >r >r 1+ r> 1+ r> 1- r> 1- SetWindow
;

: STDBORDER ( Border# Color Back --> )
   Rot
   Case
      1 Of
         " ͻͼ"
      EndOf
      2 Of
         " Ŀ"
      EndOf
      3 Of
         " κ"
      EndOf
      4 Of
         " ų"
      EndOf
      5 Of
         " \254;\254;\254;\254;\254;\254;\254;\254;"
      EndOf
      6 Of
         " \220;\220;\220;\221;\222;\223;\223;\223;"
      EndOf
      7 Of
         " \222;\223;\221;\222;\221;\222;\220;\221;"
      EndOf
      8 Of
         " \219;\223;\219;\219;\219;\219;\220;\219;"
      EndOf
      9 Of
         " \4;\4;\4;\4;\4;\4;\4;\4;"
      EndOf
      10 Of
         " \15;\15;\15;\15;\15;\15;\15;\15;"
      EndOf
      11 Of
         " \7;\7;\7;\7;\7;\7;\7;\7;"
      EndOf
      12 Of
         " \4;\14;\4;\17;\16;\4;\15;\4;"
      EndOf
         Drop
         "         "
   EndCase
   Rot Rot MakeBorder
;


( Structure format :                                            )
(                                                               )
( Offset Length Field                                           )
(   0      2      ASCIIz String                                 )
(   2      2      Picture String or MAX Length                  )
(   4      1      Screen - Y                                    )
(   5      1      Screen - X1                                   )
(   6      1      Screen - X2                                   )
(   7      1      Screen Attribute                              )
(   8      1      *************************                     )
(   9      1      Insert mode flag                              )
(  10      2      Key Procedure                                 )
(  12      1      Exit Key Number                               )
(  13      1      N=Exit Keys Count                             )
(  14     N*2     Exit Keys                                     )
(                                                               )
Variable STRUCT
Variable LEFT
Variable SX
Variable LASTKEY
: (PUTEDIT)
   Struct @@ CodeSegment SX @ False False
   Struct @ 2+ 2+ 1+ c@ Struct @ 2+ 2+ c@
   Over Struct @ 2+ 2+ 2+ c@ Swap - 1+ 1
   Struct @ 7 + c@ ShowText
   ." \eg" Left @ SX @ - Struct @ 2+ 2+ 1+ c@ + Emit
   Struct @ 2+ 2+ c@ Emit
;
: (CALCSX)
   Span @ Struct @ 2+ 2+ 2+ c@ Struct @ 2+ 2+ 1+ c@ - <
   If
      0 SX !
   Else
      Left @ Struct @ 2+ 2+ 2+ c@ Struct @ 2+ 2+ 1+ c@ - <
      If
         0 SX !
      Else
         Left @ Struct @ 2+ 2+ 2+ c@ Struct @ 2+ 2+ 1+ c@ - - SX !
      Then
   Then
;
: ?FULL
   Struct @ 2+ @ Span @ =
;
: EDITSTRING ( Structure --> )
   Dup Struct !
   @ ASCIIzLen Dup Left ! Span !
   Struct @@ Span @ + CodeSegment Struct @ 2+ @ Span @ - 0 MFill
   Begin
      (CalcSX)
      (PutEdit)
      Struct @ 10 + @ Execute Dup LastKey ! 27 = ESC !
      Struct @ 13 + c@ 0
      Do
         Struct @ 14 + i 2* + @ LastKey @ =
         If
            i Struct @ 12 + c!
            r> r> r> Drop Drop Drop
            Exit
         Then
      Loop
      LastKey @
      Case
         8 Of
            Left @
            If
               Left 1-!
            Then
            Left @ Span @ <
            If
               Span 1-!
            Then
            Struct @@ Dup Left @ 1 Delete*
         EndOf
         [ c" M 256 * ] Literal Of
            Left @ Span @ <
            If
               Left 1+!
            Then
         EndOf
         [ c" K 256 * ] Literal Of
            Left @
            If
               Left 1-!
            Then
         EndOf
         [ c" G 256 * ] Literal Of
            0 Left !
         EndOf
         [ c" O 256 * ] Literal Of
            Span @ Left !
         EndOf
         [ c" R 256 * ] Literal Of
            Struct @ 9 + Dup c@ 0= Swap c!
         EndOf
         [ c" S 256 * ] Literal Of
            Left @ Span @ <
            If
               Span 1-!
            Then
            Struct @@ Dup Left @ 1 Delete*
         EndOf
            256 <
            If
               Struct @ 9 + c@
               If
                  ?Full
                  IfNot
                     Struct @@ Dup LastKey Left @ Insert*
                     Left 1+! Span 1+!
                  Then
               Else
                  ?Full Left @ Span @ = And 0=
                  If
                     LastKey @ Struct @@ Left @ + c!
                     Left @ Span @ =
                     If
                        Span 1+!
                     Then
                     Left 1+!
                  Then
               Then
            Then
      EndCase
   Again
;

Variable HIGHATTR
Variable (KEY)
: REFRESH
   SX @ Left @ GotoXY
   LastKey @
   Begin
      1+ Dup 1- c@ Dup Dup c" ^ = If Drop Bl Then Emit 0=
   Until
   Drop
;
Variable N
Create ARRAY 40 Allot
: HMENU ( ASCIIz KeyProc HighAttribute ScreenX1 ScreenX2 ScreenY --> ItemNo CrFlag/NoESC/ )
   Left ! N ! SX !
   HighAttr !
   (Key) !
   LastKey !
   N @ SX @ - 1+ LastKey @ ASCIIzLen - u2/ SX +!

   0 Struct ! 0 N !
   Begin
      Struct @ LastKey @ + c@
   While
      Struct @ LastKey @ + c@ Bl =
      If
         Struct 1+!
      Else
         Struct @ Array N @ 2* + !
         Begin
            Struct @ LastKey @ + c@ Bl >
         While
            Array N @ 2* + 1+ c@ 1+ Array N @ 2* + 1+ c!
            Struct 1+!
         Repeat
         N 1+!
      Then
   Repeat

   PushState 0 0 79 24 SetWindow

   ReFresh
   0 Struct !
   Begin
      Struct @ 2* Array + c@ SX @ + Left @
      Span @ $ 1221 =
      IfNot
         Struct @ 2* Array + 1+ c@ HighAttr @ HighLight
      Then
      (Key) @ Execute
      Case
         13 Of
            ReFresh
            PopState
            Struct @ True
            Exit
         EndOf
         27 Of
            ReFresh
            PopState
            Struct @ False
            Exit
         EndOf
         [ c" M 256 * ] Literal Of
            ReFresh
            Struct 1+!
            Struct @ N @ =
            If
               0 Struct !
            Then
         EndOf
         [ c" K 256 * ] Literal Of
            ReFresh
            Struct @
            IfNot
               N @ Struct !
            Then
            Struct 1-!
         EndOf
            Drop
      EndCase
   Again
;

: CENTER ( ASCIIz X1 X2 Y --> )
   PushState
   Struct ! N ! Left ! LastKey !
   N @ Left @ - 1+ LastKey @ ASCIIzLen - u2/ Left +!
   ." \eg" Left @ Emit Struct @ Emit LastKey @ .ASCIIz
   PopState
;

: TITLE ( ASCIIz --> )
   GetWindow
   Drop Swap
   Center
;

Create STR 0 , 0 , 0 , 0 , $ ff00 , 0 , 512 , 13 , 27 ,

: EXPECT ( BuffAddr MaxLength --> )
   Str 2+ !
   Dup 0 Swap c! Str !
   WhereY Str 2+ 2+ c!
   WhereX Str 2+ 2+ 1+ c!
   GetWindow Drop Str 2+ 2+ 2+ c! 2Drop
   GetColor 16 * + Str 7 + c!
   0 Str 8 + c!
   ['] Key Str 10 + !
   Str EditString
;

: INITCRT
   (InitCrt)
   Begin
      Option ?Dup
   While
      Case
         c" A Of
            " FORGET PUTCHAR" Load
            ." \rGP-Forth CRT module : only ASCIIz functions loaded\r\n"
            Exit
         EndOf
            ." \rGP-Forth CRT module : Invalid option\r\n"
      EndCase
   Repeat
   " RENAME EMIT #### ( SMUDGE EMIT ) REPLACE EMIT #### RENAME #### EMIT" Load
   " RENAME KEY ### REPLACE KEY ### RENAME ### KEY" Load
   " RENAME EXPECT ###### REPLACE EXPECT ###### RENAME ###### EXPECT" Load
   " RENAME ?KEY #### REPLACE ?KEY #### RENAME #### ?KEY" Load
   ." \rGP-Forth CRT module : Loaded Ok\r\n"
   " FORGET INITCRT" Load
;

Smuge STR \ <---  㤠 ப,  --> ८। ᫮...
Smuge (KEY)
Smuge N
Smuge ARRAY
Smuge REFRESH
Smuge HIGHATTR
Smuge STRUCT
Smuge SX
Smuge LEFT
Smuge (CALCSX)
Smuge (PUTEDIT)
Smuge ?FULL
Smuge LASTKEY
Smudge 8FLAG

MakeUnit crt.frl
