
Use Crt.frl
Use DOS.frl
Use kbdcodes.frl

Variable FSEG

Variable @FNAME
: FNAME @Fname @ ;

Variable HANDLE
Variable FLENGTH

Variable PREVNFA
Variable OFFSET
Variable FIRSTNFA
Variable STARTNFA

: CCL ( Attr1 --> b&wAttr )
   Vram @ $ b000 =
   If
      Case
         $ 30 Of $ 0f EndOf
         $ b Of $ 70 EndOf
      EndCase
   Then
;

: READFILE ( --> )
   Handle @ 0 FSeg @ 32767 FRead
   If
      Dup FLength ! 32767 =
      If
         ." File too large : " FName .ASCIIz Cr Bye
      Then
   Else
      ." Cannot read file : " FName .ASCIIz Cr Bye
   Then
;

: TESTFILE
   FLength @ 2- FSeg @ a@ $ 1231 =
   IfNot
      3 FSeg @ ac@ Dup 91 > Swap 4 = Or
      If
         4 FSeg @ ac@ 13 <
         If
            11 FSeg @ a@
            If
               FLength @ StartNFA !
               256 Offset !
               11 FSeg @ a@ 256 - FirstNFA !
               Exit
            Else
               ." No NFA's found in file : " FName .ASCIIz Cr Bye
            Then
         Then
      Then
      ." Invalid file format : " FName .ASCIIz Cr Bye
   Then
   FLength @ 8 - Dup StartNFA !
   FSeg @ a@ Offset !
   FLength @ 6 - FSeg @ a@ FirstNFA !
;

Variable ADDR
Variable POS
Variable LIST
Variable WORDS
Variable TIMEX
Variable CY
Variable SY

Variable ATTR $ 1b Attr !
Variable HATTR $ 1e HAttr !

Create BUFF 80 Allot

: ATCHAR And If c" * Else c" . Then ;

: ?HIDDEN ( Word# --> HiddenFlag )
   2* List @ + @ 1+ FSeg @ ac@ Bl =
;

Variable HIDDEN

: FILESHOW ( Number NFA Position --> )
   Pos ! Dup >r Addr !
   Buff CodeSegment 80 Bl MFill
   S>D 4 RStr Count
   >r CodeSegment Buff 1+ CodeSegment r> ACMove         \ *************** NUMBER
   Addr @ 1+ FSeg @ Buff 7 + CodeSegment               \ ***************** NAME
   Addr @ FSeg @ ac@ 16 UMin ACMove

   Addr @ 1+ FSeg @ ac@ Bl =
   If \ Hidden word
      a" > Hidden word < " CodeSegment Buff 7 +
      CodeSegment 16 ACMove
      True
   Else
      False
   Then
   Hidden !

   Addr @ FSeg @ ac@ Addr @ + 1+ Addr !                \ ***************** TYPE
   Addr @ FSeg @ ac@ 1 And
   If a" Forth" Else a" Code " Then CodeSegment
   Buff 25 + CodeSegment 5 ACMove
   PrevNFA @ r@ - r@ FSeg @ ac@ 4 + - S>D 5 RStr Count \ *************** LENGTH
   >r CodeSegment Buff 33 + CodeSegment r> ACMove
   r@ Offset @ + 0 Hex 4 0Str Count >r CodeSegment   \ ****************** NFA
   Buff 40 + CodeSegment r> ACMove
   r@ FSeg @ ac@ 4 + r@ +                              \ ****************** CFA
   Offset @ + 0 4 0Str Count >r CodeSegment
   Buff 46 + CodeSegment r> ACMove
   Addr @ FSeg @ ac@ S>D 2 0Str Count >r CodeSegment   \ ***************** ATTR
   Buff 52 + CodeSegment r> ACMove
   Decimal
   Addr @ FSeg @ ac@ u2/ 7 And                          \ ***************** TAIL
   Case
      0 Of a" None       " EndOf
      1 Of a" Number     " EndOf
      2 Of a" Long number" EndOf
      3 Of a" String     " EndOf
      4 Of a" ASCIIz     " EndOf
      5 Of a" Long String" EndOf
      6 Of a" Byte       " EndOf
      7 Of a" Offset     " EndOf
         Drop
   EndCase
   CodeSegment Buff 57 + CodeSegment 11 ACMove
   Addr @ FSeg @ ac@ 128 AtChar Buff 70 + c!           \ ************** I P S N
   Addr @ FSeg @ ac@  64 AtChar Buff 72 + c!
   Addr @ FSeg @ ac@  32 AtChar Buff 74 + c!
   Addr @ FSeg @ ac@  16 AtChar Buff 76 + c!
   r> PrevNFA !
   Buff CodeSegment 0 0 0 1 Pos @ 1+ 78 1
   Hidden @ If HAttr Else Attr Then @

   Pos @ CY @ = If Vram @ $ b800 = If 15 And Else Drop $ 70 Then Then

   ShowText
;

: ?WORD ( --> CurrentWord )
   SY @ CY @ +
;

: SHOWFILES ( StartFile Count --> )
   Swap TimeX !

   Attr @ >r

   0 Do
      TimeX @ i + 2* 2- List @ + @ PrevNFA !
      i CY @ = If $ 0b CCL Else $ 1b Then Attr !
      TimeX @ i + Dup 1+ Swap 2* List @ + @ i FileShow
   Loop

   r> Attr !
;

: GO
   FirstNFA @ Addr !
   0 Words !
   StartNFA @ ,
   Here LIST !
   True
   Begin
   While
      Words 1+!
      Addr @ ,
      Addr @ FSeg @ ac@ Addr @ + 2+ Dup FSeg @ a@ Dup >r + 2+ Addr !
      r>
   Repeat
;

: REMOVECURSOR
   1 CY @ 1+ 78
   ?Word ?Hidden If HAttr Else Attr Then @
   $ 10 Or
   HighLight
;

: PUTCURSOR
   1 CY @ 1+ 78
   ?Word ?Hidden If HAttr Else Attr Then @ 15 And
   CCL HighLight
;

: GPTEXT
   ." \r\n      GP-Forth .FRL format Viewer. Version "
   $ 103 c@ . c" . Emit $ 104 c@ . ." \r\n"
   ." Copyright (C), 1992 by The Golden Porcupine Software\r\n"
   ."                 * * * * * * * * * *\r\n\r\n"
;

: INFO
   10 8 69 15 MakeWindow
   10 8 67 14 SetWindow
   8 11 3 StdBorder
   14 3 Color
   ClearWindow
   12 15 58 7 HighLight
   16 9
   Do
      68 i 2 7 HighLight
   Loop
   14 3 Color
   GetWindow >r >r >r 2+ r> 1+ r> r> 2+ SetWindow Home
   GPTEXT
   Key Drop
   RemoveWindow
;

: VIEW
   0 SY !
   0 CY !
   0 23 Words @ UMin ShowFiles
   Begin
      DropAll
      Key
      Case
         Up Of
            CY @
            If
               RemoveCursor
               CY 1-!
               PutCursor
            Else
               SY @
               If
                  RemoveCursor
                  SY 1-!
                  11 0 Color
                  $ 0b CCL Attr !
                  1 1 78 23 SetWindow ScrollDown
                  CY @ SY @ + 2* 2- List @ + @ PrevNFA !
                  SY @ Dup 1+ Swap 2* List @ + @ 0 FileShow
                  PutCursor
               Then
            Then
         EndOf
         Down Of
            SY @ CY @ + 1+ Words @ <
            If
               CY @ 22 <
               If
                  RemoveCursor
                  CY 1+!
                  PutCursor
               Else
                  RemoveCursor
                  SY 1+!
                  11 0 Color
                  $ 0b CCL Attr !
                  1 1 78 23 SetWindow ScrollUp
                  CY @ SY @ + 2* 2- List @ + @ PrevNFA !
                  SY @ 22 + Dup 1+ Swap 2* List @ + @ 22 FileShow
                  PutCursor
               Then
            Then
         EndOf
         PageDown Of
            CY @ SY @ + 1+ Words @ <
            If
               CY @ 22 =
               If
                  Words @ 23 >
                  If
                     SY @ 45 + Words @ <
                     If
                        SY @ 23 + SY !
                     Else
                        Words @ 23 - SY !
                     Then
                     SY @ 23 Words @ UMin ShowFiles
                  Then
               Else
                  Words @ 22 >
                  If
                     RemoveCursor
                     22 CY !
                     PutCursor
                  Else
                     CY @ 1+ Words @ <
                     If
                        RemoveCursor
                        Words @ 1- CY !
                        PutCursor
                     Then
                  Then
               Then
            Then
         EndOf
         PageUp Of
            CY @
            If
               RemoveCursor
               0 CY !
               PutCursor
            Else
               SY @ 23 <
               If
                  SY @
                  If
                     RemoveCursor
                     0 SY !
                     SY @ 23 Words @ UMin ShowFiles
                  Then
               Else
                  RemoveCursor
                  SY @ 23 - SY !
                  SY @ 23 Words @ UMin ShowFiles
               Then
            Then
         EndOf
         Home Of
            SY @
            If
               0 SY !
               0 CY !
               SY @ 23 Words @ UMin ShowFiles
            Else
               CY @
               If
                  RemoveCursor
                  0 CY !
                  PutCursor
               Then
            Then
         EndOf
         End Of
            SY @ CY @ + 1+ Words @ <
            If
               RemoveCursor
               Words @ 22 >
               If
                  22 CY !
                  Words @ 23 - SY !
                  SY @ 23 Words @ UMin ShowFiles
               Else
                  Words @ 1- CY !
                  PutCursor
               Then
            Then
         EndOf
         27 Of
            Exit
         EndOf
         F1 Of
            Info
         EndOf
         F10 Of
            Exit
         EndOf
            Drop
      EndCase
   Again
;

: MAIN
   Here @FName !
   >In @ >r Bl Word c@ r> >In !
   If
      Bl Word Dup >ASCIIz CodeSegment Over ASCIIzLen 1+ Dup
      >r Here Swap 50 + Allot CodeSegment r> ACMove
      FName a" ." 0 Pos* 0<
      If
         FName a" .frl" FName ConCat*
      Then
      FName 0 FOpen
      If
         Handle !
         4096 Malloc
         If
            FSeg !
            ReadFile
            Handle @ FClose Drop
            TestFile
            Go

            0 0 79 24 MakeWindow
            CursorOff
            Bl $ 1b 0 1 79 23 FillWindow
            Bl $ 30 CCL 0 0 79 0 FillWindow
            0 24 GotoXY
            11 1 Do
               7 0 Color i 10 Mod .
               0 3 Color i
               Case
                  1 Of
                     ."  Info "
                  EndOf
                  10 Of
                     ."  Quit "
                  EndOf
                     Drop ."       "
               EndCase
               i 10 <
               If
                  7 0 Color Space
               Then
            Loop
            0 0 GotoXY
            ."     No  Word              Type   Length  NFA   CFA  Attr  Tail         I P S N"

            View
            RemoveWindow
         Else
            ." Not enough memory to view file : " FName .ASCIIz Cr
         Then
      Else
         ." File not found : " FName .ASCIIz Cr
      Then
   Else

      GPText

      ." Usage : frlview filename[.frl]\r\n"
      ."    or : frlview filename.com\r\n"
   Then
;

False Messages !
' BYE ErrorProc !
True Debug !

Build frlview.com frlview.map
