
Use Grb.frl

 1 Constant TEXT40*25
 3 Constant TEXT80*25
 4 Constant GRAPH320*200*4
 6 Constant GRAPH640*200*2
 7 Constant TEXT80*25MONO
 8 Constant GRAPH720*348
 8 Constant HGCGRAPH
13 Constant GRAPH320*200*16
14 Constant GRAPH640*200*16
16 Constant GRAPH640*350*16
16 Constant GRAPH640*350*4
17 Constant GRAPH640*480*2
18 Constant GRAPH640*480*16
19 Constant GRAPH320*200*256

 0 Constant BLACK               \ 
 1 Constant BLUE                \ 㡮
 2 Constant GREEN               \ 
 3 Constant CYAN                \ 
 4 Constant RED                 \ 
 5 Constant MAGENTA             \ 
 6 Constant BROWN               \ 筥
 7 Constant LIGHTGRAY           \ ⫮-
 8 Constant DARKGRAY            \ -
 9 Constant LIGHTBLUE           \ ⫮-㡮
10 Constant LIGHTGREEN          \ ⫮-
11 Constant LIGHTCYAN           \ ⫮-
12 Constant LIGHTRED            \ ⫮-
13 Constant LIGHTMAGENTA        \ ⫮-
14 Constant YELLOW              \ 
15 Constant WHITE               \ 

Variable X1
Variable Y1
Variable X2
Variable Y2
Variable CL

Variable D
Variable DX
Variable DY
Variable AINCR
Variable BINCR
Variable YINCR

: LINE ( X1 Y1 X2 Y2 Color --> )
   Cl ! Y2 ! X2 ! Y1 ! X1 !
   X1 @ X2 @ = Y1 @ Y2 @ = And If X1 @ Y1 @ Cl @ PutPixel Exit Then
   Y1 @ Y2 @ - Abs X1 @ X2 @ - Abs >
   If
      X1 Y1 Exchange
      X2 Y2 Exchange
      X1 @ X2 @ >
      If
         X1 X2 Exchange
         Y1 Y2 Exchange
      Then
      Y2 @ Y1 @ >
      If
         1
      Else
         True
      Then
      Yincr !
      X2 @ X1 @ - DX !
      Y2 @ Y1 @ - Abs DY !
      DY @ 2* DX @ - D !

      DY @ DX @ - 2* Aincr !
      DY @ 2* Bincr !

      Y1 @ X1 @ Cl @ PutPixel

      X2 @ 1+ X1 @ 1+
      Do
         D @ 0<
         If
            Bincr @ D +!
         Else
            Yincr @ Y1 +!
            Aincr @ D +!
         Then
         Y1 @ i Cl @ PutPixel
      Loop
   Else
      X1 @ X2 @ >
      If
         X1 X2 Exchange
         Y1 Y2 Exchange
      Then
      Y2 @ Y1 @ >
      If
         1
      Else
         True
      Then
      Yincr !
      X2 @ X1 @ - DX !
      Y2 @ Y1 @ - Abs DY !
      DY @ 2* DX @ - D !
   
      DY @ DX @ - 2* Aincr !
      DY @ 2* Bincr !
   
      X1 @ Y1 @ Cl @ PutPixel

      X2 @ 1+ X1 @ 1+
      Do
         D @ 0<
         If
            Bincr @ D +!
         Else
            Yincr @ Y1 +!
            Aincr @ D +!
         Then
         i Y1 @ Cl @ PutPixel
      Loop
   Then
;

Variable X1
Variable X2
Variable Y1
Variable Y2
Variable CL

: BOX ( X1 Y1 X2 Y2 Color --> )
   Cl ! Y2 ! X2 ! Y1 ! X1 !
   X1 @ Y1 @ X1 @ Y2 @ Cl @ Line
   X1 @ Y1 @ X2 @ Y1 @ Cl @ Line
   X1 @ Y2 @ X2 @ Y2 @ Cl @ Line
   X2 @ Y1 @ X2 @ Y2 @ Cl @ Line
;

: BOXFULL ( X1 Y1 X2 Y2 Color --> )
   Cl ! Y2 ! X2 ! Y1 ! X1 !
   Y2 @ 1+ Y1 @
   Do
      X1 @ i X2 @ i Cl @ Line
   Loop
;

: (PLOTC)
   DX @ X1 @ + Y1 @ DY @ + Cl @ PutPixel
   DX @ X1 @ + Y1 @ DY @ - Cl @ PutPixel
   X1 @ DX @ - Y1 @ DY @ + Cl @ PutPixel
   X1 @ DX @ - Y1 @ DY @ - Cl @ PutPixel
   
   X1 @ DY @ + Y1 @ DX @ + Cl @ PutPixel
   X1 @ DY @ + Y1 @ DX @ - Cl @ PutPixel
   X1 @ DY @ - Y1 @ DX @ + Cl @ PutPixel
   X1 @ DY @ - Y1 @ DX @ - Cl @ PutPixel
;

: CIRCLE ( X Y Radius Color --> )
   Cl !
   Dup DY !
   2* 3 Swap - D !
   Y1 ! X1 !
   DX 0!
   Begin
      DX @ DY @ <
   While
      (PlotC)
      D @ 0<
      If
         DX @ 2* 2* 6 + D +!
      Else
         DX @ DY @ - 2* 2* 10 + D +!
         DY 1-!
      Then
      DX 1+!
   Repeat
   DY @
   If
      DY @ DX ! (PlotC)
   Then
;

Variable  GRAPHX
Variable  GRAPHY
1 InitVar GRAPHSCALE
Variable  GRAPHCOLOR

Variable ADDR

: NEXT.
   Addr @ c@
   Addr 1+!
   Dup
   IfNot
      r> 2Drop
   Then
;

Create XTABLE.
39  ,   39  ,   79  ,   79  ,
319 ,   319 ,   639 ,   79  ,
719 ,   -1  ,   -1  ,   -1  ,
-1  ,   319 ,   639 ,   639 ,
639 ,   639 ,   639 ,   639 ,

Create YTABLE.
24  ,   24  ,   24  ,   24  ,
199 ,   199 ,   199 ,   24  ,
347 ,   -1  ,   -1  ,   -1  ,
-1  ,   199 ,   199 ,   349 ,
349 ,   479 ,   479 ,   479 ,

Create CTABLE.
15  ,   15  ,   15  ,   15  ,
3   ,   3   ,   1   ,   15  ,
1   ,   -1  ,   -1  ,   -1  ,
-1  ,   15  ,   15  ,   2   ,
15  ,   1   ,   15  ,   255 ,

: MAXX
   GetVideoMode 2*
   XTable. + @
;

: MAXY
   GetVideoMode 2*
   YTable. + @
;

: MAXCOLOR
   GetVideoMode 2*
   CTable. + c@
;

: PUT.
   GraphX @ GraphY @ GraphColor @ PutPixel
;

: MOVETO ( X Y --> )
   GraphY !
   GraphX !
;

: DRAW ( ASCIIz --> )
   Addr !
   Begin
      Next.
      Dup c" a c" z WithIn
      If
         $ 5f And
      Then
      Case
         c" S Of
            Next. GraphScale !
         EndOf
         c" C Of
            Next. GraphColor !
         EndOf
         c" M Of
            Next. B>W GraphScale @ * Next. B>W GraphScale @ *
            2Dup GraphX @ GraphY @ GraphColor @ Line
            GraphY +! GraphX +!
         EndOf
         c" I Of
            GraphX @ GraphY @ Next. GraphScale @ * GraphColor @ Circle
         EndOf
         c" B Of
            Next. B>W GraphScale @ * GraphX +!
            Next. B>W GraphScale @ * GraphY +!
         EndOf
         c" N Of
            1 GraphScale !
            MaxColor GraphColor !
            MaxX 2/ GraphX !
            MaxY 2/ GraphY !
         EndOf
         c" U Of
            Next. GraphScale @ * 0
            Do
               GraphY 1-!
               Put.
            Loop
         EndOf
         c" D Of
            Next. GraphScale @ * 0
            Do
               GraphY 1+!
               Put.
            Loop
         EndOf
         c" L Of
            Next. GraphScale @ * 0
            Do
               GraphX 1-!
               Put.
            Loop
         EndOf
         c" R Of
            Next. GraphScale @ * 0
            Do
               GraphX 1+!
               Put.
            Loop
         EndOf
         c" E Of
            Next. GraphScale @ * 0
            Do
               GraphY 1-!
               GraphX 1+!
               Put.
            Loop
         EndOf
         c" F Of
            Next. GraphScale @ * 0
            Do
               GraphY 1+!
               GraphX 1+!
               Put.
            Loop
         EndOf
         c" G Of
            Next. GraphScale @ * 0
            Do
               GraphY 1+!
               GraphX 1-!
               Put.
            Loop
         EndOf
         c" H Of
            Next. GraphScale @ * 0
            Do
               GraphY 1-!
               GraphX 1-!
               Put.
            Loop
         EndOf
            Drop
      EndCase
   Again
;

: INIT
   ." \rGP-Forth GRAPH module : Loaded Ok\r\n"
   " FORGET INIT" Load
;

Smuge (PLOTC)

Smuge X1
Smuge X2
Smuge Y1
Smuge Y2
Smuge CL
Smuge X1
Smuge X2
Smuge Y1
Smuge Y2
Smuge CL
Smuge D
Smuge DX
Smuge DY
Smuge AINCR
Smuge BINCR
Smuge YINCR

Smuge ADDR
Smuge NEXT.
Smuge PUT.
Smuge XTABLE.
Smuge YTABLE.
Smuge CTABLE.

MakeUnit Graph.frl
