
16384 ReturnStackSize !
16384 MemorySize !

Use DOS.frl
Use Search.frl
Use crt.frl /a

Variable SOURCE
Variable DEST

Variable SS
Variable DS
Variable TS

Variable SLEN
Variable DLEN

Variable WORDS
Variable LASTWORD
Variable LIST

Variable CALL
Variable NEXT
Variable "[']"

23 Constant MAXERROR

$ 124f Constant PASSWORD

Variable INT#

Hex

Create JMPNEXT ff c, 26 c, 105 ,

Create NEXT1 fc c, ac c, b4 c, 0 c, d1 c, e0 c, 8b c, 1e c, 144 ,
             3 c, d8 c, ff c, 27 c,

14 Constant LEN1

Create NEXT2 fc c, ac c, a c, c0 c, 74 c, c c, b4 c, 0 c, d1 c, e0 c,
             8b c, 1e c, 144 , 3 c, d8 c, ff c, 27 c, b4 c, 1 c, ac c,
             eb c, f1 c,

23 Constant LEN2

Create NEXT3 fc c, ac c, a c, c0 c, 74 c, c c, b4 c, 0 c, d1 c, e0 c,
             8b c, 1e c, 144 , 3 c, d8 c, ff c, 27 c, ad c, eb c, f3 c,

21 Constant LEN3

Decimal

\ For each word :
\               - NFA                   2
\               - CFA                   2
\               - Code Length           2
\               - Call Counter          2

: --> ( A N --> ) Words @ 8 * + TS @ a! ;

: CODEERR
   ." \r\nInternal error : The code is corrupted\r\n"
   Bye
;

: PASS1
   ." Pass #1 "
   0 "[']" !
   $ 105 SS @ a@ Next !
   Next @ 6 - Call !
   Call @ SS @ a@ $ 4d4d =
   IfNot
      ." \r\nInternal error : cannot found CALL entry point\r\n"
      Bye
   Then
   $ 10b SS @ a@ LastWord !
   0 Words !
   $ 109 SS @ a@ 0 -->
   LastWord @
   If
      1 Words !
      Begin
         LastWord @ SS @ a@ [ 3 c" [ 256 * + ] Literal =
         LastWord @ 2+ SS @ a@ [ c" ' c" ] 256 * + ] Literal = And
         If
            LastWord @ SS @ ac@ LastWord @ + 2+ 2+ "[']" !
         Then
         DropAll
         0 6 -->
         LastWord @ Dup 0 -->
         SS @ ac@ 2+ LastWord @ +
         Dup 2+ Dup 2 -->
         Swap SS @ a@ Dup Rot + LastWord !
      While
         Words 1+!
      Repeat
  Else
     ." \r\nNo words found in source file\r\n"
     Bye
  Then
  Words @ 0
  Do
     i 8 * TS @ a@
     i 1+ 8 * 2+ TS @ a@ -
     i 1+ 8 * 2+ 2+ TS @ a!
  Loop
  ."  - " Words @ 5 .r ."  words found\r\n"
;

Variable TIMEX
Variable TIMEXX
Variable TIMEY
Variable TIMEZ
Variable TIMEZZ
Variable TIMET
Variable DI
Variable SI

: SEARCH ( CFA --> Word# )
   TS @ Words @ Rot Search
   Dup -1 =
   If
      Drop ." \r\nInternal error : Word not found\r\n"
      Bye
   Then
;

: ?TAIL ( TailCode Addr --> TailLength )
   Swap
   Case
      0 Of Drop 0 EndOf
      1 Of Drop 2 EndOf
      2 Of Drop 4 EndOf
      3 Of SS @ ac@ 1+ EndOf
      4 Of Dup Begin Dup 1+ Swap SS @ ac@ 0= Until Swap - EndOf
      5 Of SS @ a@ 2+ EndOf
      6 Of Drop 1 EndOf
      7 Of Drop 2 EndOf
         Drop
         ." \r\nInternal error : Invalid tail\r\n"
         Bye
   EndCase
;

Variable CALLS

: .CALLS
   Calls @ 5 .r ." \b\b\b\b\b"
;

: PASS2
   ." Pass #2  -     0 calls processed\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b"
   0 Calls !
   Words @ 1+ 1
   Do
      i 8 * 2+ TS @ a@ 3 - SS @ ac@ 1 And
      If
         i 8 * 2+ TS @ a@ SS @ ac@ $ e8 =
         IfNot
            CodeErr
         Then
         i 8 * 2+ TS @ a@ 1+ Dup 2+ Swap SS @ a@ +
         Dup Next @ =
         If
            Drop
         Else
            Dup Call @ =
            If
               i 8 * 2+ TS @ a@ 3 + TimeX !
               i 8 * 2+ 2+ TS @ a@ 3 - TimeY !
               Begin
                  TimeY @ 0>
               While
                  Calls 1+!
                  Calls @ 15 And
                  IfNot .Calls Then
                  TimeX @ SS @ a@
                  Dup >r Search 8 * 6 + Dup
                  TS @ a@ 1+ Swap TS @ a! r>
                  TimeX 2+! TimeY 2-!
                  3 - SS @ ac@ u2/ 7 And TimeX @ ?Tail
                  Dup TimeX @ + TimeX !
                  TimeY @ Swap - TimeY !
               Repeat
            Else
               Search Drop
            Then
         Then
      Then
   DropAll
   Loop
   .Calls Cr
;

: MOVEBLOCK ( Length --> )
   ?Dup
   If
      Dup >r
      SI @ SS @ DI @ DS @ r@ ACMove
      r@ SI @ + SI !
      r> DI @ + DI !
   Then
;

: STOSW ( Word --> )
   DI @ DS @ a!
   DI 2+!
;

: STOSB ( Byte --> )
   DI @ DS @ ac!
   DI 1+!
;

: STOSO ( Addr --> )
   DI @ - 2- Stosw
;

: STOSP ( Word# --> )
   Int# @
   Case
      1 Of Stosb EndOf
      2 Of Dup 256 < If Stosb Else 0 Stosb Stosb Then EndOf
      3 Of Dup 256 < If Stosb Else 0 Stosb Stosw Then EndOf
         ." \r\nInternal Error : Invalid interpreter type\r\n"
         Bye
   EndCase
;

Variable WORD#

Variable DESTTABLE

: ?COMPNAME
\   Word# @ 8 * 2+ TS @ a@ 3 -
   Word# @ 8 * TS @ a@ Dup SS @ ac@ + 1+
   SS @ ac@ 16 And
   If
      DI @ >r
      Word# @ 8 * TS @ a@ Dup SI ! SS @ ac@ 2+ MoveBlock
      $ 10b DS @ a@
      If
         $ 10b DS @ a@ Stoso
      Else
         0 Stosw
      Then
      r> $ 10b DS @ a!
   Then
;

: STORECFA
   DI @ Word# @ 8 * 6 + TS @ a!
;

: COMPCODE
   \ Compile CODE word
   ?CompName
   StoreCFA
   Word# @ 8 * 2+ Dup TS @ a@ SI !
   2+ TS @ a@ MoveBlock
;

Variable UPLIST

: ?DEST
   Here UpList @ - u2/ u2/ u2/
   ?Dup
   If
      0 Do
\         i 8 * UpList @ + @ 2+ TimeX @ =
         i 8 * UpList @ + 2+ @ TimeX @ =
         If
            DI @ i 8 * UpList @ + 6 + !
\            r> r> r> Drop Drop Drop Exit
         Then
      Loop
   Then
;

: ?SOURCE
   Here UpList @ - u2/ u2/ u2/
   ?Dup
   If
      0 Do
         i 8 * UpList @ + @ TimeX @ =
         If
            DI @ i 8 * UpList @ + 2+ 2+ !
\            r> r> r> Drop Drop Drop Exit
         Then
      Loop
   Then
;

: RESOLVE
   Here UpList @ - u2/ u2/ u2/
   ?Dup
   If
      0 Do
         i 8 * 6 + UpList @ + @
         i 8 * 2+ 2+ UpList @ + @ - 2-
         i 8 * 2+ 2+ UpList @ + @ DS @ a!
      Loop
   Then
;

Variable CALLSP
: .CALLSP
   CallsP @ 5 .r ." \b\b\b\b\b"
;

Variable PREVCODE

: COMPWORD ( CFA --> )
   TimeX !
   DropAll
   Word# @ 8 * 2+ TS @ a@ TimeX @ =
   If
      Exit \ Rucurse CALL
   Then
   TimeX @ Search Dup Word# ! 8 * 6 + TS @ a@

   IfNot

      Word# @ 8 * 2+ 2+ TS @ a@ TimeY !
      TimeX @ 3 - SS @ ac@ 1 And
      If
         TimeX @ SS @ ac@ $ e8 =
         If
            TimeX @ 1+ Dup 2+ Swap SS @ a@ +
            Dup Call @ =
            If
               \ Compile CALL word

               Here UpList !

               TimeX @ 3 + TimeX !
               TimeY @ 3 - TimeY !
               Begin
                  TimeY @ 0>
               While
                  TimeX @ SS @ a@
                  Dup >r TimeX @ >r TimeY @ >r Word# @ >r UpList @ >r
                  Recurse
                  r> UpList ! r> Word# ! r> 2- TimeY ! r> 2+ TimeX ! r>
                  3 - SS @ ac@ u2/ 7 And
                  Dup 7 =
                  If
                     TimeX @ ,
                     TimeX @ SS @ a@ TimeX @ + 2+
                     , 0 , 0 ,
                  Then
                  TimeX @ ?Tail
                  Dup TimeX @ + TimeX !
                  TimeY @ Swap - TimeY !
               Repeat

               Word# @ 8 * 2+ Dup TS @ a@ 3 + TimeX ! 2+ TS @ a@ 3 - TimeY !
               ?CompName
               StoreCFA
               $ e8 Stosb
               Call @ Stoso
               0 PrevCode !

               Begin
                  TimeY @ 0>
               While
                  ?Dest
                  PrevCode @ Dup "[']" @ = And
                  If
                     TimeX @ SS @ a@
                     Search 8 * 6 + TS @ a@ Stosw
                     TimeX 2+!
                     TimeY 2-!
                     0 PrevCode !
                  Else
                     TimeX @ SS @ a@
                     Search Dup >r Stosp r> 8 * 2+ TS @ a@ PrevCode !
                     CallsP 1+!
                     CallsP @ 15 And
                     IfNot
                        .CallsP
                     Then
                     TimeX @ SS @ a@
                     TimeX 2+! TimeY 2-!
                     ?Source
                     3 - SS @ ac@ u2/ 7 And TimeX @ ?Tail
                     TimeX @ SI !
                     Dup TimeX @ + TimeX !
                     Dup TimeY @ Swap - TimeY !
                     MoveBlock
                  Then
               Repeat

               Resolve
               UpList @ Here - Allot
            Else
               Dup Next @ =
               If
                  \ Compile NEXT word

                  ?CompName
                  StoreCFA
                  $ e8 Stosb
                  $ 105 DS @ a@ Stoso
                  TimeX @ 3 + SI !
                  TimeY @ 3 - MoveBlock
               Else
                  \ Compile DOES word
                  Dup >r
                  TimeX @ >r Word# @ >r TimeY @ >r
                  Recurse
                  r> TimeY ! r> Word# ! r> TimeX !
                  ?CompName
                  StoreCFA
                  TimeX @ 1+ 2+ SI !
                  $ e8 Stosb
                  r> Search 8 * 6 + TS @ a@ Stoso
                  TimeY @ 3 - MoveBlock
               Then
            Then
         Else
            CodeErr
         Then
      Else
         CompCode
      Then
   Then
;

: PASS3
   ." Pass #3  -     0 calls optimized\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b"
   0 CallsP !
   \ Select Interperter Type
   1 Int# !
   Words @ 255 >
   If Int# 1+! Then
   Words @ 511 >
   If Int# 1+! Then

   JmpNext CodeSegment Next @ SS @ 4 ACMove
   $ 100 Dup DI ! SI !
   Next @ 252 - MoveBlock
   $ 152 SS @ a@
   If
      Next @ 4 + MaxError @ 2* + SS @ a@
      Begin
         Dup c@ 1 = 0=
      While
         1+
      Repeat
      Next @ 4 + - MoveBlock
   Then
   DI @ DestTable !
   Words @ 1+ 2* DI @ + DI !
   DestTable @ $ 144 DS @ a!

   \ Compile Address Interpreter
   DI @ $ 105 DS @ a!
   Int# @
   Case
      1 Of Next1 Len1 EndOf
      2 Of Next2 Len2 EndOf
      3 Of Next3 Len3 EndOf
         Drop Bye
   EndCase
   >r CodeSegment DI @ DS @ r@ ACMove
   r> DI @ + DI !

   PassWord 6 TS @ a!
   True 2 TS @ a!

   Words @ 1+ 1
   Do
      0 i 8 * 6 + TS @ a!
   Loop

   0 $ 10b DS @ a!
   0 Word# !
   $ 107 SS @ a@ CompWord

   Words @ 1+ 1
   Do
      i 8 * TS @ a@ Dup SS @ ac@ + 1+
      SS @ ac@ 16 And
      If
         i 8 * 2+ TS @ a@ CompWord
      Then
   Loop

   $ 12d SS @ a@ CompWord

   $ 107 SS @ a@ Search 8 * 6 + TS @ a@ $ 107 DS @ a!

   $ 12d SS @ a@ Search 8 * 6 + TS @ a@ $ 12d DS @ a!

   Words @ 1+ 0
   Do
      i 8 * 6 + TS @ a@ i 2* DestTable @ + DS @ a!
   Loop

   DI @ $ 109 DS @ a! \ Set HERE Pointer

   .CallsP Cr
;

: TITLE
   ." \r\n        Forth Code Optimizer   Version "
   $ 103 c@ . c" . Emit $ 104 c@ .
   ." \r\nCopyright (C), 1992 by The Golden Porcupine Software"
   ." \r\n                * * * * * * * * * *\r\n\r\n"
;

: USAGE
   ." Usage : opt source[.com] [dest.com [mapfile.map]]\r\n"
   Bye
;

Variable @BUFF
: BUFFER @Buff @ ;

: PS ( String --> )
   Dest @ Over c@ >r Swap 1+ CodeSegment r@ FWrite
   IfNot
      ." .MAP file write error\r\n"
      Bye
   Then
   r> =
   IfNot
      ." Disk full\r\n"
   Then
;

Variable $$$

: PUTWORD
   Buffer 1+ CodeSegment 38 Bl MFill
   Dup $$$ ! 8 * TS @ a@
   Dup SS @ ac@ Over 1+ SS @ ac@ Bl =
   IfNot
      16 UMin >r
      1+ SS @ Buffer 2+ CodeSegment r> ACMove
      $$$ @ 8 * 2+ TS @ a@ Search 2* Debug DS @ a@ + DS @ a@
      s>d Hex 4 0Str 1+ CodeSegment
      Buffer 20 + CodeSegment 4 ACMove Decimal
      $$$ @ 8 * 2+ 2+ TS @ a@ s>d 5 RStr 1+ CodeSegment
      Buffer 26 + CodeSegment 5 ACMove
      $$$ @ 8 * 2+ TS @ a@ 1- 2- SS @ ac@ 1 And
      If a" Forth" Else a" Code " Then CodeSegment
      Buffer 33 + CodeSegment 5 ACMove
      Buffer PS
   Then
;

: MAKEMAP
  "  Word              CFA   Length Type  \r\n======================================\r\n"
  PS
  Words @ 1+ 1
  Do
     DropAll
     i PutWord
  Loop
;

Variable @FN
: FNAME @FN @ ;

: MAIN
   Here @FN !
   80 Allot
   Here @BUFF !
   40 c, Bl c,
   37 Allot 13 c, 10 c,
   Title
   Bl Word c@
   IfNot Usage Then
   128 SetStream
   Bl Word Dup >ASCIIz CodeSegment FName CodeSegment 80 ACMove
   FName a" ." 0 Pos* -1 =
   If
      FName a" .com" FName ConCat*
   Then
   FName 0 FOpen
   If
      Source !
      ." Processing file : " FName .ASCIIz Cr
         4096 Malloc
         If
            SS !
            4096 Malloc
            If
               DS !
               4096 Malloc
               If
                  TS !
                  \ ( 65536 - 256 = 65280 ) - 1 = 65279
                  Source @ $ 100 SS @ 65279 FRead
                  IfNot
                     ." Source file read error\r\n"
                     Bye
                  Then
                  Dup
                  65279 =
                  If
                     ." Source file too large\r\n"
                     Bye
                  Then
                  SLen !
                  0 DLen !
                  $ 103 SS @ ac@ Dup 91 > Swap 4 = Or
                  $ 104 SS @ ac@ 13 < And
                  IfNot
                     ." Source file is not a forth program\r\n"
                     Bye
                  Then
                  Debug SS @ a@
                  IfNot
                     ." No debug information in source file\r\n"
                     Bye
                  Then
                  Debug SS @ a@ True =
                  IfNot
                     Debug SS @ a@ SS @ a@ PassWord =
                     If
                        ." Source file already optimized\r\n"
                        Bye
                     Then
                  Then

                  \ ********************************* Begin
                  Pass1
                  Pass2
                  Pass3
                  DI @ $ 100 - DLen !
                  \ ********************************* End
                  Source @ FClose Drop

                  SLen @ DLen @ <
                  If
                     ." This file could not be optimized\r\n"
                     Bye
                  Then

                  Bl Word Dup >ASCIIz
                  Dup c@
                  IfNot
                     Drop
                     FName
                  Then
                  0 FCreate
                  IfNot
                     ." Cannot create destination file\r\n"
                     Bye
                  Then
                  Dest !
                  Dest @ $ 100 DS @ DLen @ FWrite
                  IfNot
                     ." Destination file write error\r\n"
                     Bye
                  Then
                  DLen @ =
                  IfNot
                     ." No disk space to save destination file\r\n"
                     Bye
                  Then
                  Dest @ FClose
                  IfNot
                     ." Cannot close destination file\r\n"
                     Bye
                  Then

                  Bl Word Dup c@
                  If
                     Dup >ASCIIz
                     0 FCreate
                     IfNot
                        ." Cannot create .MAP file\r\n
                        Bye
                     Then
                     Dest !
                     MakeMap
                     Dest @ FClose
                     IfNot
                        ." Cannot close .MAP file\r\n"
                     Then
                  Then
                  Cr
                  ." Original Size  : " SLen @ 5 .r ."  bytes\r\n"
                  ." Optimized Size : " DLen @ 5 .r ."  bytes\r\n"
                  ." Ratio          : " SLen @ Dup DLen @ - Swap 10000 Swap */ 100 /Mod 2 .r ." ." 2 0. ."  %\r\n"
                  Bye
               Then
            Then
         Then
         ." Not enough memory\r\n"
   Else
      ." Source file not found\r\n"
   Then
;

True Debug !
False Messages !
' BYE ErrorProc !

Build opt.com opt.map
