
: DELAY ( n --> )
   0 Do
      $ 46c 0 ac@
      Begin
         $ 46c 0 ac@ Over = 0=
      Until
      Drop
   Loop
;

: SWITCH ( Case# CaseCount --> )
   r> Dup Rot 2* + >r Swap 2* + @ Execute
;

: U/
   0 Swap DS/Mod 2Drop
;

: .ASCIIZ ( ASCIIzString --> )
   Begin
      1+ Dup 1- c@ Dup If Dup Emit Then 0=
   Until
   Drop
;

: CONSTANT
   Create , Does> @
;

: 2CONSTANT
   Create 2, Does> 2@
;

: M/ ( D1 S --> D2 )
   DS/Mod Drop
;

Variable HLD

: PAD
   Here 100 +
;

: HOLD
   Hld 1-! Hld @ c!
;

: <#
   Pad Hld !
;

: #
   Base @ DS/Mod
   Dup 9 >
   If
      7 +
   Then
   c" 0 +
   Hold
;

: #S
   Begin
      # 2Dup D0=
   Until
;

: #>
   2Drop
   Hld @ Pad Over -
;

: SIGN
   0<
   If
      c" - Hold
   Then
;

: STR ( D --> String )
   2Dup DAbs
   <#
      #S
      Rot
      Sign
   #>
   Rot Drop
   Swap 1- Dup >r
   c! r>
;

: E.
   S>D Str Dup >ASCIIz  EPrint
;

: D.
   Str Print
;

: .
   S>D D.
;

: USTR
   2Dup
   <#
      #S
      Rot
      Drop
   #>
   Rot Drop
   Swap 1- Dup >r
   c! r>
;

: UD.
   UStr Print
;

: U.
   0 UD.
;

: RSTR ( D N --> String )
   >r 2Dup DAbs
   <#
      #S
      Rot
      Sign
      Begin
         Pad Hld @ - r@ <
      While
         Bl Hold
      Repeat
   #>
   Rot r> 2Drop
   Swap 1- Dup >r
   c! r>
;

: D.R
   RStr Print
;

: .R
   >r S>D r> D.R
;

: 0STR ( D N --> String )
   >r 2Dup
   <#
      #S
      Rot
      Drop
      Begin
         Pad Hld @ - r@ <
      While
         c" 0 Hold
      Repeat
   #>
   Rot r> 2Drop
   Swap 1- Dup >r
   c! r>
;

: D0.
   0Str Print
;

: 0.
   >r S>D r> D0.
;

: 16/
   u2/ u2/ u2/ u2/
;

: .HEX
   Base @ >r Hex
   Dup 16/ 16/ 16/ .
   Dup 16/ 16/ 15 And .
   Dup 16/ 15 And .
   15 And .
   r> Base !
;

: .HBYTE
   Base @ >r Hex
   Dup 16/ 15 And .
   15 And .
   r> Base !
;

: LPRINT
   Count LType
;

: PUSH ( N Regs --> )
   >r
   r@ SP 2-!
   r@ SP @ r> SS @ a!
;

: POP ( Regs --> N )
   >r
   r@ SP @ r@ SS @ a@
   r> SP 2+!
;

: ENDINTPROC
   IntRegs Dup Flags @ Swap Push
   IntRegs Dup CS    @ Swap Push
   IntRegs Dup IP    @ Swap Push
    8 StackSegment a@ IntRegs IP !
   10 StackSegment a@ IntRegs CS !
   FinishInt
;

: TRACEOFF
   4 0 a@ 6 0 a@ 2Dup a@ >r
   2Dup $ cf Rot Rot a!

   (TraceOff)
   r> Rot Rot a!
;

: FORTHERR
   ErrNo @ True =
   IfNot
      Cr
      Base @ >r Decimal
      Lines @ True = 0=
      If
         a" Line #" EPrint Lines @ E. a"    " Eprint
      Then
      a" Error #" EPrint ErrNo @ E. a"    " EPrint
      r> Base !

      ?Messages
      If
         ErrNo @ ErrorMessage EPrint
      Then
   Then
   Bye
;

' ForthErr ErrorProc !

Save forth.com
