
Use 256color.frl
Use Graph.frl

Registers REGS

Variable IMAGE
Variable PALETTE
Variable IMAGESEG

2Variable DXDY

Use DOS.frl

: SETPALETTE ( Color R G B --> )
   Regs CX c!
   Regs CX 1+ c!
   Regs DX 1+ c!
   Regs BX !
   $ 1010 Regs !
   $ 10 Regs Intr
;

: SETALLPALETTE
   CodeSegment Regs ES !
   Here Regs DX !
   0 Regs BX !
   256 Regs CX !
   $ 1012 Regs !
   $ 10 Regs Intr
;

: USAGE
   ." \r\nUsage: 256s image.256 palette.pal\r\n"
   Bye
;

: DX
   DXDY @
;

: DY
   DXDY 2+ @
;

: MAIN
   Bl Word Dup >ASCIIz 0 FOpen
   If
      Image !
      Bl Word Dup >ASCIIz 0 FOpen
      If
         Palette !
      Else
         Palette 0!
      Then
      4096 Malloc
      If
         ImageSeg !

         Image @ DXDY CodeSegment 4 FRead
         If
            4 =
            If
               DX DY UM*
               If
                  ." \r\nInvalid image file: sprite too large\r\n"
               Else
                  Drop
                  Image @ 0 ImageSeg @ DX DY UM* Drop 1+ FRead
                  If
                     DX DY UM* Drop =
                     If
                        Image @ FClose Drop

                        Palette @
                        If
                           Palette @ Here CodeSegment 769 FRead
                           If
                              768 =
                              If
                                 Palette @ FClose Drop

                                 Graph320*200*256 SetVideoMode

                                 0 ImageSeg @ 0 0 $Screen 0 0 DX 320 DX 320 Umin DY 200 UMin $Copy256

                                 256 0
                                 Do
                                    i
                                    i 3 * Here + c@
                                    i 3 * Here + 1+ c@
                                    i 3 * Here + 2+ c@
                                    SetPalette
                                 Loop


                              Else
                                 ." \r\nInvalid palette file\r\n"
                              Then
                           Else
                              ." \r\nPalette file read error\r\n"
                           Then
                        Else
                           Graph320*200*256 SetVideoMode
                           0 ImageSeg @ 0 0 $Screen 0 0 DX 320 DX 320 Umin DY 200 UMin $Copy256
                        Then
                        Key Drop
                        Text80*25 SetVideoMode
                     Else
                        ." \r\nInvalid image file\r\n"
                     Then
                  Else
                     ." \r\nImage file read error\r\n"
                  Then
               Then
            Else
               ." \r\nImage file too small\r\n"
            Then
         Else
            ." \r\nCannot read file header\r\n"
         Then
      Else
         ." \r\nNot enough memory to show picture\r\n"
      Then
   Else
      Usage
   Then
;

False Messages !
' BYE ErrorProc !

Build 256s.com
