
 100 ScreenStackSize !
 200 MemorySize !
 100 ReturnStackSize !
1000 StackSize !

Use DOS.frl
Use Crt.frl
Use KbdCodes.frl

500 Constant MAXFILES
128 Constant COMMANDLINE

Registers REGS

Variable CRSFLAG True CrsFlag !

Variable KEYBUF 0 KeyBuf !

Variable KEYCHAIN

Variable LASTKEY

: KEY
   KeyBuf @ If KeyBuf @ 0 KeyBuf ! Else KeyChain @ If
   KeyChain @ @ ?Dup If KeyChain 2+! Else 0 KeyChain ! Key Then
   Else Key Then Then
   Dup LastKey !
;

Variable PANNEL
Variable STDVRAM
Variable HELPSTRING True HelpString !

Create READALTERNATE -1 , Ctrl+R , 9 , 0 ,

: XVARIABLE
   Create 0 , 0 ,
;

: XVAR ( XVariable --> )
   Dup 2+ ExChange
;

: X2VARIABLE
   Create 0 , 0 , 0 , 0 ,
;

: X2VAR ( X2Variable --> )
   Dup >r Dup 2+ 2+ ExChange
   r> 2+ Dup 2+ 2+ ExChange
;

xVariable CURRENTDISK
xVariable FILES
xVariable CURRENTFILE
xVariable UPFILE

xVariable SELECTED
x2Variable SELECTEDLEN

xVariable PANON True True Panon 2!

Variable INSMOVEDOWN True InsMoveDown !

xVariable FILESEG

Create FILEBUFFER 44 Allot FileBuffer CodeSegment 44 0 MFill

Create CURRENTDIR++ 160 Allot CurrentDir++ CodeSegment 160 0 MFill
: CURRENTDIR CurrentDir++ 10 + Pannel @ 80 * + ;

Create CURRENTBUFF++ 40 Allot CurrentBuff++ CodeSegment 40 0 MFill
: CURRENTBUFF CurrentBuff++ 10 + ;

Variable USERSCREEN

Create XFILESPEC c" * c, c" . c, c" * c, 0 c, 0 , 0 , 0 , 0 , 0 , 0 ,
                 c" * c, c" . c, c" * c, 0 c, 0 , 0 , 0 , 0 , 0 , 0 ,
: FILESPEC Pannel @ 16 * xFileSpec + ;

Create XCURFILE 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
: CURFILE Pannel @ 12 * xCurFile + ;

Create SHELL 80 Allot Shell CodeSegment 80 0 MFill

" COMSPEC=" ASCIIz ComSpec

: SAVESCREEN
   0 StdVram @ 0 UserScreen @ 4000 ACMove
;

: LOADSCREEN
   0 UserScreen @ 0 StdVram @ 4000 ACMove
;

: SETPANNEL ( Pannel# --> )
   If 1 Else 0 Then
   Pannel @ =
   IfNot
      c" \ CurrentDir c!
      CurrentDir 1+ GetCurrentDir
      1 Pannel @ - Dup Pannel ! StdVram @ Swap
      If 5 - Then Vram !
      CurrentDisk XVar
      Panon XVar
      Files XVar
      CurrentFile XVar
      UpFile XVar
      FileSeg XVar
      Selected XVar
      SelectedLen X2Var
      14 Regs >High c!
      CurrentDisk @ Regs DX !
      Regs FDos
      CurrentDir ChangeDir
   Then
;

: BYE
   LoadScreen
   Bye
;

Variable ADDR
Variable ADDR2
Variable ADDR3

: OUTHELPSTRING
   PushState
   0 0 79 25 SetWindow
   Vram @ >r StdVram @ Vram !
   HelpString @
   If
      0 0 0 24 79 24 FillWindow
      10 0 Do
         7 0 Color
         i 8 * 24 GotoXY i 1+ .
         0 3 Color
         i 8 * 1+
         i 9 = If 1+ Then
         24 GotoXY ."       "
      Loop
   Else
      Bl 7 0 24 79 24 FillWindow
   Then
   r> Vram !
   PopState
;

: COMPARE2 ( Off1 Seg1 Off2 Seg2 Count --> EqualFlag )
   0 Do
      2Over Swap i + Swap
      2Over Swap i + Swap ac@
      Rot Rot ac@ =
      IfNot
         r> r> r> 2Drop 2Drop 2Drop Drop False Exit
      Then
   Loop
   2Drop 2Drop
   True
;

: SEARCH4COMMAND
   $ 2c @ Addr !
   0 Addr2 !
   Begin
      Addr2 @ Addr @ a@
   While
      Addr2 @ Addr @ ComSpec CodeSegment ComSpec ASCIIzLen Compare2
      If
         ComSpec ASCIIzLen Addr2 @ + Addr2 !
         Shell Addr3 !
         Begin
            Addr2 @ Addr @ ac@ Dup
         While
            Addr3 @ c!
            Addr2 1+!
            Addr3 1+!
         Repeat
         Drop
         Exit
      Else
         Begin
            Addr2 1+!
            Addr2 @ Addr @ ac@ 0=
         Until
         Addr2 @ Addr @ a@ If Addr2 1+! Then
      Then
   Repeat
;

: ENTERDOSCOMMAND ( ASCIIzCommand --> )
   >r
   [ c" c 256 * c" / + ] Literal CommandLine !
   0 CommandLine 2+ c!
   CommandLine r> CommandLine Concat*
   CommandLine ASCIIz>
   LoadScreen
   7 0 Color
   0 24 GotoXY
   Shell CommandLine 0 Exec Drop
   0 0 79 24 SetWindow
   0 24 GotoXY
   Cr SaveScreen
   Panon 2+ @
   If
      ReadAlternate KeyChain !
   Then
   OutHelpString
;

: FORMATFILENAME ( ASCIIzNameAddress --> )
   Here CodeSegment 12 Bl MFill
   Dup Addr ! a" ." 0 Pos*
   Dup -1 =
   If
      Addr @ Dup ASCIIzLen >r CodeSegment Here CodeSegment r> ACMove
   Else
      Dup
      If
         >r Addr @ CodeSegment Here CodeSegment r@ ACMove
         r> Addr @ + 1+
         Dup ASCIIzLen Dup
         If
            >r CodeSegment Here 9 + CodeSegment r> ACMove
         Else
            Drop
         Then
      Else
         Drop
         Addr @ 9 - c@ 16 And
         If
            Addr @ Dup ASCIIzLen >r CodeSegment Here CodeSegment r> ACMove
         Then
      Then
   Then
   Addr @ 9 - c@ 16 And
   IfNot
      12 0 Do
         i Here + c@ Dup c" A c" Z WithIn
         If 32 + Then i Here + c!
      Loop
   Then
   Here CodeSegment Addr @ CodeSegment 12 ACMove
;

: CLEARSELECT
   0 FileSeg @ MaxFiles 24 * 0 MFill
   0 Selected !
   0.0 SelectedLen 2!
;

: UNFORMFILENAME ( File# --> )
   24 * 9 + FileSeg @ FileBuffer CodeSegment 12 ACMove
   Here Addr !
   8 0 Do
      FileBuffer i + c@ Bl =
      If Leave Then
      FileBuffer i + c@ Addr @ c! Addr 1+!
   Loop
   Here c@ c" . = FileBuffer 9 + c@ Bl = Or
   IfNot
      c" . Addr @ c! Addr 1+!
      3 0 Do
         FileBuffer 9 + i + c@ Bl =
         If Leave Then
         FileBuffer 9 + i + c@ Addr @ c! Addr 1+!
      Loop
   Then
   0 Addr @ c!
;

: READCURRENTDIR
   c" ? CurrentDir !
   CurrentDir GetCurrentDir Drop
   CurrentDir ASCIIzLen 33 >
   If
      CurrentDir CurrentDir 0 CurrentDir ASCIIzLen 30 - Delete*
      CurrentDir CurrentDir a" ..." 0 Insert*
   Then
   a"  A:\\" CodeSegment Here CodeSegment 5 ACMove
   GetCurrentDisk c" A + Here 1+ c!
   CurrentDir CurrentDir Here 0 Insert*
   CurrentDir CurrentDir a"  " CurrentDir ASCIIzLen Insert*
;

Variable ATTR

: READGROUP ( FileSpec Attribute --> )
   Dup Attr !
   FileBuffer FindFirst
   Begin
   While
      FileBuffer 30 + @ c" . =
      IfNot
         Attr @ 16 = FileBuffer 21 + c@ 16 And 0= And
         IfNot
            FileBuffer 30 + FormatFileName
            FileBuffer 21 + CodeSegment Files @ 24 * FileSeg @ 22 ACMove
            Files 1+!
            Files @ MaxFiles >
            If
               Exit
            Then
         Then
      Then
      FileBuffer FindNext
   Repeat
;

: READDIRECTORY
   GetCurrentDisk CurrentDisk !
   0 Files !
   a" *.*" 16 ReadGroup
   FileSpec 33 ReadGroup
;

: DRAWPANNEL
   CursorOff
   40 0 79 22 SetWindow
   11 1 Color
   ClearWindow
   40 0 79 22  " ͻͼ" $ 1b Border
   40 20 79 22 " Ķͼ" $ 1b Border
   53 0 66 20  " ѳ" $ 1b Border
   14 1 Color
   3 0 Do i 13 * 45 + 1 GotoXY ." Name" Loop
;

: OUTFILECOLUMN ( StartFileNumber Count ColumnNumber --> )
    Addr ! Swap Addr2 ! 0
   Do
      0 FileSeg @ 9 Addr2 @ i + 24 Addr @ 13 * 41 + i 2+ 12 1
      Addr2 @ i + 24 * 23 + FileSeg @ ac@ If $ 1e Else $ 1b Then ShowText
   Loop
;

: OUTFILES
   Panon @
   If
      Files @ IfNot
         14 1 Color
         a" * * *   No files   * * *" 41 78 21 Center Exit
      Then
      Begin
         UpFile @ CurrentFile @ + 1+ Files @ >
      While
         UpFile @ If UpFile 1-! Else CurrentFile 1-! Then
      Repeat
      Files @ 19 <
      If
         0 Files @ 0 OutFileColumn
      Else
         Files @ 37 <
         If
            0 18 0 OutFileColumn
            18 Files @ 18 - 1 OutFileColumn
         Else
            Files @ 55 <
            If
               0 18 0 OutFileColumn
               18 18 1 OutFileColumn
               36 Files @ 36 - 2 OutFileColumn
            Else
               UpFile @ 18 0 OutFileColumn
               UpFile @ 18 + 18 1 OutFileColumn
               UpFile @ 36 + 18 2 OutFileColumn
            Then
         Then
      Then
   Then
;

: OUTDIRNAME
   Panon @
   If
      CrsFlag @
      If
         0 3
      Else
         11 1
      Then
      Color
      CurrentDir 41 78 0 Center
   Then
;

: CURSORPUT
   >r
   CurrentFile @ 18 /Mod
   13 * 41 + Swap 2+ 12 r> HighLight
;

: FILE#
   UpFile @ CurrentFile @ +
;

: PUTCURSOR
   Panon @
   If
      Files @ IfNot Exit Then
      File# 24 * 23 + FileSeg @ ac@ If $ 3e Else $ 30 Then
      CursorPut
      41 21 GotoXY
      Selected @
      If
         14 1 Color
         SelectedLen 2@ 9 d.r
         ."  bytes in " Selected @ . ."  selected files"
      Else
         0.0 SelectedLen 2!
         11 1 Color
         File# UnFormFileName Here .ASCIIz
         54 21 GotoXY
         File# 24 * FileSeg @ ac@ 16 And
         If
            File# 24 * 9 + FileSeg @ ac@ c" . =
            If
               ." \16;UP-DIR\17; "
            Else
               ." \16;SUB-DIR\17;"
            Then
         Else
            File# 24 * 5 + FileSeg @ a@
            File# 24 * 7 + FileSeg @ a@
            9 d.r
         Then
         Space
         File# 24 * 3 + FileSeg @ a@
         Dup >r 16/ u2/ 15 And 2 .r
         c" - Emit
         r@ 31 And 2 0.
         c" - Emit
         r> 16/ 16/ u2/ 1980 + 100 Mod 2 0.
         Space
         File# 24 * 1+ FileSeg @ a@
         16/ u2/ Dup >r
         16/ u2/ u2/ 31 And 12 Mod Dup IfNot Drop 12 Then 2 .r
         c" : Emit
         r@ 63 And 2 0.
         r> 16/ u2/ u2/ 11 > If c" p Else c" a Then $ 1b 78 21 PutChar
      Then
   Then
;

: REMOVECURSOR
   Panon @
   If
      Files @ IfNot Exit Then
      File# 24 * 23 + FileSeg @ ac@ If $ 1e Else $ 1b Then
      CursorPut
      0 $ 1b 41 21 78 21 FillWindow
   Then
;

: 12= ( Addr1 Addr2 --> )
   12 0 Do
      Over i + c@ Over i + c@ =
      IfNot r> r> r> Drop Drop Drop Drop Drop False Exit Then
   Loop
   2Drop True
;

: CURDIR>CURFILE
   CurrentDir Dup ASCIIzLen + Addr !
   Begin
      Addr @ c@ Bl = If 0 Addr @ c! Then
      Addr 1-!
      Addr @ c@ c" \ = Addr @ CurrentDir < Or
   Until
   Addr 1+!
   16 Addr @ 9 - c!
   Addr @ FormatFileName
   Here CodeSegment CurFile CodeSegment 12 ACMove
;

: POSHIGHPOINTER
   Files @ 0
   Do
      i 24 * 9 + FileSeg @ Here CodeSegment 12 ACMove
      Here CurFile 12=
      If
         i File# =
         IfNot
            i 54 <
            If
               i CurrentFile !
               0 UpFile !
            Else
               i UpFile !
               0 CurrentFile !
               Begin
                  UpFile @ 53 + Files @ >
               While
                  UpFile 1-!
                  CurrentFile 1+!
               Repeat
            Then
         Then
         r> r> r> Drop Drop Drop Exit
      Then
   Loop
   0 UpFile !
   0 CurrentFile !
;

: ?DIR
   File# 24 * FileSeg @ ac@ 16 And
;

Create EDSTRUCT 0 , 0 , 8 c, 7 c, 72 c, $ 30 c, 0 c, 255 c, 0 , 0 c, 2 c, 27 , 13 ,

: GETLINE ( ASXIIzSay Buffer Len --> CrFlag )
   Vram @ >r StdVram @ Vram !
   Dup 65 < If Dup 7 + Else 72 Then EdStruct 6 + c!
   >r >r >r
   3 5 76 10 MakeWindow
   0 7 Color
   ClearWindow
   5 6 74 9 SetWindow
   1 0 7 StdBorder
   7 7 GotoXY r> .ASCIIz
   7 8 72 8 SetWindow
   0 3 Color
   ClearWindow
   r> EdStruct !
   r> EdStruct 2+ !
   ['] Key EdStruct 10 + !
   CursorOn
   EdStruct EditString
   RemoveWindow
   EdStruct 12 + c@ 0= 0=
   r> Vram !
;

: HIGHFILE
   File# 24 * 9 + FileSeg @ CurFile CodeSegment 12 ACMove
   File# UnFormFileName
   Here CodeSegment CurrentBuff CodeSegment 13 ACMove
;

Create EXT 0 , 0 , 0 ,

: HIGHFILEEXT
   HighFile
   CurrentBuff Addr !
   Begin
      Addr @ c@ Dup 0= Swap c" . = Or Not
   While
      Addr 1+!
   Repeat
;

: ?EXT ( ASCIIzExtension --> EqualFlag )
   HighFileExt Addr @ Compare* 0=
;

: SETFILESPEC
   FileSpec CodeSegment CurrentBuff CodeSegment 13 ACMove
   a"  Enter file specification :" FileSpec 12 GetLine
   If
      ClearSelect
      True
   Else
      CurrentBuff CodeSegment FileSpec CodeSegment 13 ACMove
      False
   Then
;

: SETCURRENTDISK ( Disk --> SuccessFlag )
   >r
   14 Regs >High c!
   r@ Regs DX !
   Regs FDos
   GetCurrentDisk r@ = If Addr3 @ r> = IfNot ClearSelect Then True
   Else r> Drop False Then
;

: SETDISK
   Vram @ >r StdVram @ Vram !
   Pannel @ If 13 21 41 23 Else 38 21 66 23 Then MakeWindow
   8 11 3 StdBorder
   0 3 Color
   ClearWindow
   CursorOn
   ."  Enter drive letter -->  :\b\b"
   14 3 Color
   GetCurrentDisk Dup Addr3 ! c" A + Emit 8 Emit
   Begin
      Key Dup 27 = If Drop RemoveWindow False r> Vram ! Exit Then $ 5f And
      Dup c" A c" Z WithIn
      If
         Dup Emit 8 Emit
         c" A -
         SetCurrentDisk
      Else
         False
      Then
   Until
   RemoveWindow
   r> Vram !
   True
;

2Variable CURSELLEN

: PUTPANNEL
   Panon @
   If
      ClearSelect
      ReadCurrentDir
      ReadDirectory
      DrawPannel
      OutDirName
      PosHighPointer
      PutCursor
      OutFiles
   Else
      Vram @ >r
      StdVram @ Vram !
      0 UserScreen @ 1 Pannel @ - 40 * Dup >r 0 80 r> 0 40 23 Show
      r> Vram !
   Then
;

: PUTPANN
   Panon @
   IfNot
      PutPannel
   Then
;

2Variable CURPANON

: 4T
   PutPannel
   Begin
      CrsFlag @
      IfNot
         True CrsFlag !
         OutDirName
      Then
      LastKey @ -1 =
      IfNot
         Files @ If
            Begin
               UpFile @ CurrentFile @ + 1+ Files @ >
            While
               UpFile @ IfNot CurrentFile 1-! Then
            Repeat
         Then
         PutCursor
      Then
      Key
      Case
         Ctrl+R Of
            Exit
         EndOf
         Ctrl+B Of
            HelpString @ 0= HelpString !
            OutHelpString
         EndOf
         9 Of
            Panon 2+ @
            If
               Panon @
               If
                  Files @ If
                     File# 24 * 23 + FileSeg @ ac@ If $ 1e Else $ 1b Then
                     CursorPut
                  Then
                  41 0 38 $ 1b HighLight
               Then
               Pannel @ 0= SetPannel
               ReadCurrentDir
               OutDirName
            Then
         EndOf
         Alt+F2 Of
            Pannel @
            If
               False CrsFlag !
               0 SetPannel
               SetDisk
               If
                  9 KeyBuf !
                  False CurrentFile !
                  False UpFile !
                  True Panon !
                  PutPann
                  Exit
               Then
               True SetPannel
               True CrsFlag !
            Else
               SetDisk
               If
                  False CurrentFile !
                  False UpFile !
                  True Panon !
                  PutPann
                  Exit
               Then
            Then
         EndOf
         Alt+F1 Of
            Pannel @
            IfNot
               False CrsFlag !
               True SetPannel
               SetDisk
               If
                  9 KeyBuf !
                  False CurrentFile !
                  False UpFile !
                  True Panon !
                  PutPann
                  Exit
               Then
               False SetPannel
               True CrsFlag !
            Else
               SetDisk
               If
                  False CurrentFile !
                  False UpFile !
                  True Panon !
                  PutPann
                  Exit
               Then
            Then
         EndOf
         Alt+D Of
            SetDisk If True Panon ! PutPannel Exit Then
         EndOf
         Insert Of
            Panon @
            If
               ?Dir IfNot RemoveCursor
                  File# 24 * 23 + Dup >r FileSeg @ ac@
                  Dup Addr3 ! 0= r> FileSeg @ ac!
                  File# 24 * 5 + FileSeg @ a@
                  File# 24 * 7 + FileSeg @ a@
                  CurSelLen 2!
               Then
               ?Dir
               IfNot
                  Addr3 @ If Selected 1-! SelectedLen 2@ CurSelLen 2@ d-
                     SelectedLen 2!
                  Else Selected 1+! SelectedLen 2@ CurSelLen 2@ d+
                     SelectedLen 2!
                  Then
               Then
               InsMoveDown @ If
                  File# Files @ 1- =
                  IfNot
                     CurrentFile @ 53 =
                     If UpFile 1+! OutFiles
                     Else RemoveCursor CurrentFile 1+! Then
                  Then
               Then
            Then
         EndOf
         c" * Of
            SetFileSpec If Exit Then
         EndOf
         Ctrl+O Of
            Panon 2@ Or
            If
               False False CurPanon 2!
            Else
               CurPanon 2@ Or
               IfNot
                  True True CurPanon 2!
               Then
            Then
            Panon 2@
            CurPanon 2@
            Panon 2!
            CurPanon 2!
            Pannel @ 0= SetPannel
            False CrsFlag !
            PutPannel
            True CrsFlag !
            Pannel @ 0= SetPannel
            PutPannel
         EndOf
         27 Of
            Bye
         EndOf
         13 Of
            Panon @
            If
               ?Dir
               If
                  \ ४
                  CurDir>CurFile
                  File# UnFormFileName
                  Here ChangeDir Drop ClearSelect Exit
               Else
                  \ 䠩
                  a" .com" ?Ext a" .exe" ?Ext a" .bat" ?Ext Or Or
                  If HighFile CurrentBuff EnterDOSCommand Exit Then
               Then
            Then
         EndOf
         Up Of
            Panon @
            If
               CurrentFile @
               If
                  RemoveCursor
                  CurrentFile 1-!
               Else
                  UpFile @
                  If
                     RemoveCursor
                     UpFile 1-!
                     OutFiles
                  Then
               Then
            Then
         EndOf
         Down Of
            Panon @
            If
               CurrentFile @ UpFile @ + 1+ Files @ <
               If
                  CurrentFile @ 53 <
                  If
                     RemoveCursor
                     CurrentFile 1+!
                  Else
                     UpFile 1+!
                     OutFiles
                  Then
               Then
            Then
         EndOf
         Left Of
            Panon @
            If
               File#
               If
                  CurrentFile @ 18 <
                  If
                     UpFile @ 18 <
                     If
                        RemoveCursor
                        0 CurrentFile !
                        0 UpFile !
                     Else
                        RemoveCursor
                        UpFile @ 18 - UpFile !
                     Then
                     OutFiles
                  Else
                     RemoveCursor
                     CurrentFile @ 18 - CurrentFile !
                  Then
               Then
            Then
         EndOf
         Right Of
            Panon @
            If
               UpFile @ CurrentFile @ + 1+ Files @ <
               If
                  CurrentFile @ 36 <
                  If
                     RemoveCursor
                     CurrentFile @ 18 + CurrentFile !
                  Else
                     UpFile @ 71 + Files @ <
                     If
                        UpFile @ 18 + UpFile !
                     Else
                        Files @ 54 - UpFile !
                        53 CurrentFile !
                     Then
                     OutFiles
                  Then
               Else
               Then
            Then
         EndOf
         Home Of
            Panon @
            If
               File# If
                  RemoveCursor
                  0 CurrentFile !
                  0 UpFile !
                  OutFiles
               Then
            Then
         EndOf
         End Of
            Panon @
            If
               File# 1+ Files @ <
               If
                  Begin
                     File# 1+ Files @ <
                  While
                     CurrentFile @ 53 <
                     If
                        CurrentFile 1+!
                     Else
                        UpFile 1+!
                     Then
                  Repeat
                  OutFiles
               Then
            Then
         EndOf
         -1 Of
            Pannel @ 0= SetPannel
         EndOf
         Ctrl+F1 Of
            Pannel @
            If
               Panon @ 0= Panon !
               PutPannel
            Else
               Panon 2+ @ 0= Panon 2+ !
               Pannel @ 0= SetPannel
               PutPannel
               Pannel @ 0= SetPannel
            Then
            Panon @ IfNot 9 KeyBuf ! Then
         EndOf
         Ctrl+F2 Of
            Pannel @
            If
               Panon 2+ @ 0= Panon 2+ !
               Pannel @ 0= SetPannel
               PutPannel
               Pannel @ 0= SetPannel
            Else
               Panon @ 0= Panon !
               PutPannel
            Then
            Panon @ IfNot 9 KeyBuf ! Then
         EndOf
         PageUp Of
            Panon @
            If
               File# If
                  RemoveCursor
                  UpFile @ 53 >
                  If
                     UpFile @ 54 - UpFile !
                     53 CurrentFile !
                  Else
                     CurrentFile @
                     If
                        UpFile @ IfNot 0 CurrentFile ! Then
                     Then
                     0 UpFile !
                  Then
                  OutFiles
               Then
            Then
         EndOf
         PageDown Of
            Panon @
            If
               File# 1+ Files @ <
               If
                  RemoveCursor
                  UpFile @ 107 + Files @ <
                  If
                     UpFile @ 54 + UpFile !
                     0 CurrentFile !
                  Else
                     UpFile @ 54 + Files @ <
                     If
                        Files @ 54 - UpFile !
                        0 CurrentFile !
                     Else
                        Files @ UpFile @ - 1- CurrentFile @ =
                        If
                           Begin
                              File# 1+ Files @ <
                           While
                              CurrentFile 1+!
                           Repeat
                        Else
                           Files @ UpFile @ - 1- CurrentFile !
                        Then
                     Then
                  Then
                  OutFiles
               Then
            Then
         EndOf
            Drop
      EndCase
      DropAll
   Again
;

: MAIN
   Search4Command
   Vram @ StdVram !
   GetCurrentDisk Dup CurrentDisk ! CurrentDisk 2+ !
   0 SetPannel
   250 Malloc
   If
      UserScreen !
      [ MaxFiles 24 * 16 / 1 + ] Literal Malloc
      If
         FileSeg !
         ClearSelect
         SaveScreen
         OutHelpString
         1 SetPannel
         [ MaxFiles 24 * 16 / 1 + ] Literal Malloc
         If
            FileSeg !
            PutPannel
            0 SetPannel
            1 0 38 $ 1b HighLight
            Begin
               ReadCurrentDir
               ReadDirectory
               4t
            Again
         Then
      Then
   Then
   ." Not enough memory\r\n"
;

False Messages !
' BYE ErrorProc !
True Debug !

Build 4t.com 4t.map
