
Registers REGS

: VGAPRESENT ( --> PresenttFlag )
   $ 1a00 Regs !
   $ 10 Regs Intr

   Regs c@ $ 1a =
   Regs BX c@ 7 =
   Regs BX c@ * =
   Or Or
;

: VGAOUT ( --> )
   Cli
   0 $ 3c4 Out
   1 $ 3c5 Out
   23 $ 3d4 Out
   $ 3d5 In 127 And $ 3d5 Out
   17 $ 3d4 Out
   $ 3d5 In 127 And $ 3d5 Out
;

: VGAON ( --> )
   17 $ 3d4 Out
   $ 3d5 In 128 Or $ 3d5 Out
   23 $ 3d4 Out
   $ 3d5 In 128 Or $ 3d5 Out

   1 $ 3c4 Out
   1 $ 3c5 Out

   0 $ 3c4 Out
   3 $ 3c5 Out
   Sti
;

: VGA480PIX ( --> )
   $ 3cc In 192 Or $ 3c2 Out
   6 $ 3d4 Out
   11 $ 3d5 Out
   7 $ 3d4 Out
   62 $ 3d5 Out
   9 $ 3d4 Out
   79 $ 3d5 Out
   16 $ 3d4 Out
   234 $ 3d5 Out
   17 $ 3d4 Out
   140 $ 3d5 Out
   18 $ 3d4 Out
   223 $ 3d5 Out
   21 $ 3d4 Out
   231 $ 3d5 Out
   22 $ 3d4 Out
   4 $ 3d5 Out
;

: VGACHARSIZE ( Size --> )
   2 Locate 0 L!

   0 L@ $ 485 0 ac!
   9 $ 3d4 Out
   $ 3d5 In $ e0 And 0 L@ + 1- $ 3d5 Out
   10 $ 3d4 Out
   0 L@ 3 - $ 3d5 Out
   11 $ 3d4 Out
   0 L@ 2- $ 3d5 Out

   UnLocate
;

: VGAMODE ( --> )
   $ 1202 Regs !
   $ 30 Regs BX c!
   $ 10 Regs Intr
   3 Regs !
   $ 10 Regs Intr
   $ 1104 Regs !
   0 Regs BX c!
   $ 10 Regs Intr

   VGAOut

   VGA480Pix

   16 VGACharSize

   VGAOn

   80 $ 44a 0 ac!
   29 $ 484 0 ac!

;

False Messages !
' BYE ErrorProc !
True Debug !

Build emode.com
