
\ FS.FRT

\ Ŀ
\   祭  ᨨ -⥬ ⪮     
\   :                                                    
\  forth fs.frt                                                        
\ 

: S. ( --> )
   Depth
   If
      Depth 0
      Do
         Depth i - 1- Pick . Space
      Loop
   Else
      ." Stack is empty"
   Then
;

: DUMP ( Addr Bytes --> )
   16/ 1+ 0
   Do
      Dup .Hex ." : "
      16 0 Do
         Dup i + c@ .HByte Space
      Loop
      16 0 Do
         Dup i + c@ Dup Bl < If Drop c" . Then Emit
      Loop
      16 + Cr
   Loop
   Drop
;

: VLIST ( --> )
   Latest
   0 >R
   Begin
      Dup Print            ( NFA      --> )
      9 Emit
      R> 1+ >R
      Dup c@ + 2+          ( LFA      --> )
      Dup @                ( LFA Link --> )
      Dup >R + 2+ R>
      0=
   Until
   Drop
   Cr R> . ."  word(s) found\r\n"
;

: WORDS VList ; \ ...

: (PREV) ( CFA --> PrevNFA )
   >Name >R
   Latest Here 0 L!
   Begin
      Dup R@ = If R> 2Drop 0 L@ UnLocate Exit Then
      Dup 0 L!
      Dup c@ + 2+          ( LFA      --> )
      Dup @                ( LFA Link --> )
      Dup >R + 2+ R>
      0=
   Until
   Drop
   UnLocate
;

: ASCIIZLEN ( ASCIIz --> Length )
   0 >R
   Begin Dup c@ While 1+ R> 1+ >R Repeat Drop
   R>
;

: (TYPE) ( Addr Length --> )
   ?Dup
   If
      0 Do
         Dup c@
         Case
            8 Of ." \\b" EndOf
            9 Of ." \\t" EndOf
            10 Of ." \\n" EndOf
            13 Of ." \\r" EndOf
            27 Of ." \\e" EndOf
            c" \ Of ." \\\\" EndOf
               Dup Bl <
               If
                  ." \\" . ." ;"
               Else
                  Emit
               Then
         EndCase
         1+
      Loop
   Then
   Drop
;

: (PRINT) ( String --> )
   Count (Type)
;

: (.ASCIIZ) ( ASCIIzLine --> )
   Dup ASCIIzLen (Type)
;

: DECOMP ( --> )
   ' Dup 3 - c@ 1 And
   IfNot 24 Error Then
   Dup (Prev) >R
   3 + >R
   ."  Addr  Call  Word       Operands . . .\r\n"
   ." -------------------------------------------\r\n"
   Begin
      c" $ Emit R@ .Hex ." : "
      R@ @ .Hex Space Space
      R@ @ >Name Print 9 Emit
      R@ @ ['] ['] =
      If
         R@ 2+ @ >Name Print
         ." \t($" R@ 2+ @ .Hex ." )" 2
      Else
         R@ @ 3 - c@ U2/ 7 And
         Case
            1 Of R@ 2+ @ Dup . ." \t(" U. ." )" 2 EndOf
            2 Of R@ 2+ 2@ 2Dup D. ." \t(" UD. ." )" 4 EndOf
            3 Of R@ 2+ c" " Emit (Print) c" " Emit R@ 2+ c@ 1+ EndOf
            4 Of R@ 2+ c" " Emit (.ASCIIz) c" " Emit R@ 2+ ASCIIzLen 1+ EndOf
            5 Of R@ 4 + R@ 2+ @ c" " Emit (Type) c" " Emit R@ 2+ @ 2+ EndOf
            6 Of R@ 2+ c@ U. 1 EndOf
            7 Of R@ 2+ Dup @ + 2+ c" $ Emit .Hex 2 EndOf
               Drop 0
         EndCase
      Then
      R> + 2+ >R
      Cr
      1 RPick R@ =
   Until
   R> R> 2Drop
;

Smuge (PREV)
Smuge ASCIIZLEN
Smuge (TYPE)
Smuge (.ASCIIZ)
Smuge (PRINT)

: FORTHLOOP
   Begin
      ." \r\n>"
      129 78 Expect
      Span @
      If
         Cr
         Span @ 128 c!
         128 Load
         State @
         IfNot
            ."  - Ok"
         Then
      Then
   Again
;

: FORTH
   Decimal
   ." \r\n             Forth system   Version "
   $ 103 c@ . c" . Emit $ 104 c@ .
   ." \r\nCopyright (C), 1990-94 by The Golden Porcupine Software"
   ." \r\n                 * * * * * * * * * *\r\n"
   ForthLoop
;

: FORTHERR
   ErrNo @ True =
   IfNot
      Base @ >r Decimal
      ." Error #" ErrNo @ . ."    "
      r> Base !
      ?Messages
      If
         ErrNo @ ErrorMessage .ASCIIz
      Then
   Then
   0 State !
   DropAll
   RDropAll
   ForthLoop
;

' ForthErr ErrorProc !

Restart Forth
Save fs.com
