
Use VGA.frl

Variable TIMEX
Variable TIMEY
Variable TIMEZ
Variable TIMET

Registers REGS

0 $ a000 2Constant $SCREEN

: $SCROLLUP ( SpriteOffset SpriteSegment X Y SpriteSizeX DX DY Lines --> )
   TimeX ! >r >r >r TimeX @ + 2Over 2Over TimeX @ - r> Dup r> r> TimeX @ -
   $Copy256
;

: $SCROLLDOWN ( SpriteOffset SpriteSegment X Y SpriteSizeX DX DY Lines --> )
   TimeX ! >r >r >r 2Over 2Over TimeX @ + r> Dup r> r> TimeX @ - $>Copy256
;

: $SCROLLLEFT ( SpriteOffset SpriteSegment X Y SpriteSizeX DX DY Columns --> )
   TimeX ! >r >r >r Swap TimeX @ + Swap 2Over 2Over Swap TimeX @ - Swap
   r> Dup r> TimeX @ - r> $Copy256
;

: $SCROLLRIGHT ( SpriteOffset SpriteSegment X Y SpriteSizeX DX DY Columns --> )
   TimeX ! >r >r >r 2Over 2Over Swap TimeX @ + Swap r> Dup
   r> TimeX @ - r> $>Copy256
;

: $HLINE ( SpriteOffset SpriteSegment X Y SpriteSizeX Length Color --> )
   1 Swap $Fill256
;

: $VLINE  ( SpriteOffset SpriteSegment X Y SpriteSizeX Length Color --> )
   1 Rot Rot $Fill256
;

: 8DUP 8 0 Do 7 Pick Loop ;

: $BOX ( SpriteOffset SpriteSegment X Y SpriteSizeX DX DY Color --> )
   8Dup Press 1 Swap $Fill256
   8Dup Rot Drop 1 Rot Rot $Fill256
   8Dup Swap TimeX ! 1 Swap >r >r >r >r TimeX @ + 1- r> r> r> r> $Fill256
   Rot TimeX ! 1 Rot Rot >r >r >r >r >r TimeX @ + 1- r> r> r> r> r> $Fill256
;

: $SPRITE
   Base @ >r Hex
   Begin
      Lines 1+!
      Query Tib# @
   While
      Begin
         Bl Word Dup c@
      While
         Val
         If
            Drop c,
         Else
            1 Error
         Then
      Repeat
   Repeat
   r> Base !
;

: ?VGA ( --> Flag )
   $ 1a00 Regs !
   $ 10 Regs Intr
   Regs c@ $ 1a = Regs BX c@ 7 = Regs BX c@ 8 = Or And
;

: INIT ( --> )
   ." \rGP-Forth 256-colors graphics module : Loaded Ok\r\n"
   " FORGET INIT" Load
;

Smuge TIMEX
Smuge TIMEY
Smuge TIMEZ
Smuge TIMET
Smuge 8DUP
Smuge REGS

MakeUnit 256color.frl
