
                include forthasm.inc

is_mouse_:      db      6,'?MOUSE',0
                dw      0
                _is_mouse:
                xor     ax,ax
                push    bp
                push    si
                int     33h
                pop     si
                pop     bp
                push    ax
                next

buttons_:       db      7,'BUTTONS',0
                dj      is_mouse_
                _buttons:
                xor     ax,ax
                push    bp
                push    si
                int     33h
                pop     si
                pop     bp
                or      ax,ax
                jnz     _msp
                push    ax
                next
                _msp:
                push    bx
                next

dmp_:           db      15,'PUTMOUSEPOINTER',0
                dj      buttons_
                _dmp:
                mov     ax,1
                push    bp
                push    si
                int     33h
                pop     si
                pop     bp
                next

gmx_:           db      11,'WHEREMOUSEX',0
                dj      dmp_
                _gmx:
                mov     ax,3
                push    bp
                push    si
                int     33h
                pop     si
                pop     bp
;                shr     cx,1
;                shr     cx,1
;                shr     cx,1
                push    cx
                next

gmy_:           db      11,'WHEREMOUSEY',0
                dj      gmx_
                _gmy:
                mov     ax,3
                push    bp
                push    si
                int     33h
                pop     si
                pop     bp
;                shr     dx,1
;                shr     dx,1
;                shr     dx,1
                push    dx
                next

is_lb_:         db      11,'?LEFTBUTTON',0
                dj      gmy_
                _is_lb:
                mov     ax,3
                push    bp
                push    si
                int     33h
                pop     si
                pop     bp
                test    bx,1
                jz      _lbu
                mov     ax,0ffffh
                push    ax
                next
                _lbu:
                xor     ax,ax
                push    ax
                next

is_rb_:         db      12,'?RIGHTBUTTON',0
                dj      is_lb_
                _is_rb:
                mov     ax,3
                push    bp
                push    si
                int     33h
                pop     si
                pop     bp
                test    bx,2
                jz      _rbu
                mov     ax,0ffffh
                push    ax
                next
                _rbu:
                xor     ax,ax
                push    ax
                next

is_cb_:         db      13,'?CENTERBUTTON',0
                dj      is_rb_
                _is_cb:
                mov     ax,3
                push    bp
                push    si
                int     33h
                pop     si
                pop     bp
                test    bx,4
                jz      _cbu
                mov     ax,0ffffh
                push    ax
                next
                _cbu:
                xor     ax,ax
                push    ax
                next

; ( MinX MaxX --> )
sethr_:         db      9,'SETXRANGE',0
                dj      is_cb_
                _sethr:
                mov     ax,7
                pop     dx
                pop     cx
                push    bp
                push    si
                int     33h
                pop     si
                pop     bp
                next

; ( MinY MaxY --> )
setvr_:         db      9,'SETYRANGE',0
                dj      sethr_
                _setvr:
                mov     ax,8
                pop     dx
                pop     cx
                push    bp
                push    si
                int     33h
                pop     si
                pop     bp
                next

; ( AndMask XorMask --> )
stm_:           db      11,'SETTEXTMASK',0
                dj      setvr_
                _stm:
                mov     ax,10
                xor     bx,bx
                pop     dx
                pop     cx
                push    bp
                push    si
                int     33h
                pop     si
                pop     bp
                next

; ( X Y --> )
mmp_:           db      16,'MOVEMOUSEPOINTER',0
                dj      stm_
                _mmp:
                mov     ax,4
                pop     dx
                pop     cx
;                shl     cx,1
;                shl     dx,1
;                shl     cx,1
;                shl     dx,1
;                shl     cx,1
;                shl     dx,1
                push    bp
                push    si
                int     33h
                pop     si
                pop     bp
                next

hide_m_:	db	16,'HIDEMOUSEPOINTER',0
		dj	mmp_
                mov     ax,2
                push    bp
                push    si
                int     33h
                pop     si
                pop     bp
                next


init_:          db      1,' ',0
                dj      hide_m_
                _init:
                next

                dw      100h
                dw      init_-100h
                include vers.inc
                dw      1231h

end             module
