
                include forthasm.inc

; ( MaxTasks --> SuccessFlag )
init_mt_:       db      16,'INITMULTITASKING',0
                dw      0

                ; 뤥   ᯨ᮪ 
                mov     bx,word ptr [upvoc]
                mov     word ptr [task_list],bx
                pop     cx
                mov     word ptr [bx],cx
                add     bx,2
                i_m_1:
                mov     word ptr [bx],0
                add     bx,2
                loop    i_m_1

                ; 뤥 3    
                mov     byte ptr [bx],0
                add     bx,3
                mov     word ptr [upvoc],bx

                ; ⨬ 뢠
                cli

                ; ⠭   
                call    i_m_set_ai

                ;   
                cld
                dec     word ptr [calls_left]
                jz      dispatch
                lodsw
                jmp     ax

                ; ᯥ  *********************************************
                dispatch:

                ; 맮 ᯥ୮ 뢠 - ࢮ砫쭮 
                ; 뢠 㪠뢠  IRET
                int     61h

                ; ᫨  ᥣ TSB ⥪饩 
                mov     bx,word ptr [active_task] ; 쬥  ⥪饩 
                add     bx,bx
                add     bx,word ptr [task_list]
                add     bx,2
                cmp     word ptr [bx],0         ;  襭 ?
                jnz     cont_save_paras
                jmp     skip_save_paras
                cont_save_paras:
                mov     es,word ptr [bx]

                ; ES:0 -->  TSB ⥪饩 
                test    byte ptr es:[0],128
                jz      save_paras

                mov     ax,word ptr es:[5]        ; ⠭ 䫠 LOCK -
                mov     word ptr [calls_left],ax  ; 뤥  ।
                mov     word ptr [ticks_left],1   ;  ६
                next

                save_paras:
                ; ************************ ࠭ ࠬ஢ ⥪饩 
                ;   !
                ; ES:0 -->  TSB ⥪饩 
                mov     word ptr es:[11],ss
                mov     ax,word ptr [s0]
                mov     word ptr es:[13],ax
                mov     word ptr es:[15],sp
                mov     ax,word ptr [r0]
                mov     word ptr es:[17],ax
                mov     word ptr es:[19],bp
                mov     ax,word ptr [ss0]
                mov     word ptr es:[21],ax
                mov     ax,word ptr [ssp]
                mov     word ptr es:[23],ax
                mov     word ptr es:[25],si

                ; *************************************************************
                ; ४஢,  室 浪   ᯨ᪥

                mov     bx,word ptr [task_list]
                mov     di,word ptr [active_task]
                mov     cx,word ptr [bx]
                add     bx,2
                add     di,di
                mov     dx,word ptr ds:[bx+di]
                mov     word ptr ds:[bx+di],0
                mov     di,bx
                mov     ax,cs
                mov     es,ax

                order_change:
                mov     ax,word ptr [bx]
                add     bx,2
                cmp     ax,0
                jz      skip_store
                stosw
                skip_store:
                loop    order_change

                xor     ax,ax
                sub     bx,2
                mov     word ptr [bx],dx
                cmp     bx,di
                jz      skip_save_paras

                order_clear:
                stosw
                cmp     bx,di
                jnz     order_clear

                ; *************************************************************

                skip_save_paras:

                ; ஢ਬ ⮢ ᨬ  

                ; 稬   
                mov     bx,word ptr [task_list]
                mov     ax,word ptr [bx]
                add     ax,ax
                add     bx,ax
                add     bx,2

                cmp     byte ptr [bx],0
                jnz     no_keyboard_ready

                xor     ax,ax
                mov     es,ax
                mov     ax,word ptr es:[41ah]
                cmp     ax,word ptr es:[41ch]
                jz      no_keyboard_ready

                push    es
                push    bx
                mov     ah,0
                int     16h
                pop     bx
                pop     es

                or      al,al
                jz      no_clear_ah
                xor     ah,ah
                no_clear_ah:

                mov     word ptr [bx+1],ax
                mov     byte ptr [bx],1

                no_keyboard_ready:
                cld
                mov     si,word ptr [task_list] ; SI --> ᯨ᮪ 
                lodsw
                mov     cx,ax                   ; ⢮   ᯨ᪥
                xor     dx,dx                   ;    ᯨ᪥ (NULL)
                mov     bx,0ffffh               ; ਮ NULL-
                dispatch_loop:
                lodsw                           ; । 
                or      ax,ax
                jz      skip_dispatch
                ; ࠡ⠥ ।   ᯨ᪠
                mov     es,ax
                mov     al,byte ptr es:[0]

                test    al,01000000b            ; ⠭ 䫠 STOP ?
                jnz     skip_dispatch           ;  - ய⨬ 

                mov     di,word ptr es:[1]      ;   
                                                ;  ᥬ
                and     al,00011111b
                jz      compare_pl              ;  ⮢  믮

                cmp     al,1
                jnz     no_inp_wait

                ;   
                cmp     byte ptr ds:[di],0      ; -    ?
                jz      skip_dispatch           ;   -   ⮢
                jmp     compare_pl              ;  -  ࠢ ਮ⮢

                no_inp_wait:
                cmp     al,2
                jnz     no_out_wait

                ;   뢮
                cmp     byte ptr ds:[di],0
                jnz     skip_dispatch           ;   -  
                jmp     compare_pl              ;  -  ࠢ ਮ⮢

                no_out_wait:
                cmp     al,3
                jnz     no_time_wait

                ;   ⠩
                or      di,di
                jnz     skip_dispatch           ;    ६ 諮, 
                jmp     compare_pl              ;  -  ࠢ ਮ⮢

                no_time_wait:
                cmp     al,4
                jnz     no_eq_wait

                ;   ᥬ  ࠢ
                mov     ax,word ptr ds:[di]
                cmp     ax,word ptr es:[3]
                jnz     skip_dispatch           ; த 
                jmp     compare_pl              ;  -  ࠢ ਮ⮢

                no_eq_wait:
                cmp     al,8
                jnz     skip_dispatch

                compare_pl:                     ; ࠢ ਮ⮢
                                                ; ⮢ 

                mov     ax,dx                   ;  ஢塞 
                call    tn_2_pl                 ;  ਮ
                cmp     ax,bx
                jnc     skip_dispatch
                mov     bx,ax                   ; ࠭ ਮ 
                mov     word ptr [active_task],dx  ;  

                skip_dispatch:
                inc     dx                      ; 稬  
                loop    dispatch_loop

                cmp     bx,0ffffh               ; ⮢  㦥 ?
                jnz     switch_x_task           ;  - ஡㥬 ४

                int     62h                     ;  - 맮 ᯥ୮
                                                ; 뢠
                                                ; ࢮ砫쭮 --> IRET

                jmp     skip_save_paras         ;  -  横

                switch_x_task:
                mov     bx,word ptr [active_task]
                add     bx,bx
                add     bx,2
                add     bx,word ptr [task_list]
                mov     es,word ptr [bx]
                ; ES:0 --> TSB ஢塞 

                mov     al,byte ptr es:[0]
                and     al,31
                cmp     al,1
                jz      release_input
                cmp     al,2
                jnz     switch_2_task
                jmp     release_output

                ; ४稬  

                switch_2_task:
                cli
                mov     ss,word ptr es:[11]
                mov     ax,word ptr es:[13]
                mov     word ptr [s0],ax
                mov     sp,word ptr es:[15]
                mov     ax,word ptr es:[17]
                mov     word ptr [r0],ax
                mov     bp,word ptr es:[19]
                mov     ax,word ptr es:[21]
                mov     word ptr [ss0],ax
                mov     ax,word ptr es:[23]
                mov     word ptr [ssp],ax
                mov     si,word ptr es:[25]
                mov     word ptr [stack_seg],ss

                ; ᫨  ⮢  묨 묨 - 襬   ⥪
                mov     al,byte ptr es:[0]
                and     al,31
                cmp     al,8
                jnz     skip_push_data
                push    word ptr es:[3]

                skip_push_data:
                ; 䨪㥬  ﭨ  - ⮢  ࠡ
                and     byte ptr es:[0],11100000b

                ; ⠭  LOCK, ࠭   STLOCK
                and     byte ptr es:[0],127
                test    byte ptr es:[0],00100000b
                jz      skip_set_lock
                or      byte ptr es:[0],128
                and     byte ptr es:[0],10011111b

                skip_set_lock:

                mov     ax,word ptr es:[5]
                mov     word ptr [calls_left],ax  ; 뤥  ।
                mov     ax,word ptr es:[7]      ;  ६
                mov     word ptr [ticks_left],ax

                sti                             ; 訬 뢠


                next                            ; ⢥  

                release_input:
                ;    
                mov     bx,word ptr es:[1]      ; BX --> 
                mov     byte ptr [bx],0         ; ⨬ 䫠  
                mov     ax,word ptr [bx+1]      ; ⥬ 
                mov     word ptr es:[3],ax      ;  
                and     byte ptr es:[0],0e0h    ;  ﭨ
                or      byte ptr es:[0],8
                jmp     skip_save_paras         ;  横

                release_output:
                ; 뢮   
                mov     bx,word ptr es:[1]      ; BX --> 
                mov     byte ptr [bx],1         ; ⠭ 䫠 
                mov     ax,word ptr es:[3]      ; 稬 뢮 
                mov     word ptr [bx+1],ax      ; 뢥   
                and     byte ptr es:[0],0e0h    ;  ﭨ 
                jmp     skip_save_paras         ;  横

                i_m_set_ai:
                mov     bx,word ptr ds:[105h]
                pop     word ptr ds:[105h]
                mov     word ptr [bx],26ffh
                mov     word ptr [bx+2],105h

                ; 墠⨬ 뢠 61h  62h
                ; ࢮ砫쭮   㪠뢠  IRET
                call    i_m_set_6162

                iret

                i_m_set_6162:
                xor     ax,ax
                mov     es,ax
                pop     ax
                mov     word ptr es:[61h*4],ax
                mov     word ptr es:[62h*4],ax
                mov     ax,cs
                mov     word ptr es:[61h*4+2],ax
                mov     word ptr es:[62h*4+2],ax

                ;    뢠 1ch
                call    i_m_set_old

                ; 室  뢠 1ch
                exit_1c:
                db      0eah
                dw      0
                dw      0

                i_m_set_old:
                pop     bx
                xor     ax,ax
                mov     es,ax
                mov     ax,word ptr es:[1ch*4]
                mov     word ptr [bx+1],ax
                mov     ax,word ptr es:[1ch*4+2]
                mov     word ptr [bx+3],ax

                ; ⠭   뢠 1ch
                call    i_m_set_1c

                ;  ࠡ稪 뢠 1ch
                int_1c:
                pushf
                push    ds
                push    bx
                push    cx
                push    es
                push    ax

                mov     bx,cs
                mov     ds,bx

                dec     word ptr [ticks_left]
                jnz     skip_reset_task

                ; 稫 뤥 ⥪饩   ६
                mov     word ptr [ticks_left],1
                mov     word ptr [calls_left],1

                skip_reset_task:
                mov     bx,word ptr [task_list]
                mov     cx,word ptr [bx]

                dec_time_loop:
                add     bx,2
                cmp     word ptr [bx],0
                jz      no_dec_time
                mov     es,word ptr [bx]
                mov     al,byte ptr es:[0]
                and     al,31
                cmp     al,3
                jnz     no_dec_time
                cmp     word ptr es:[1],0
                jz      no_dec_time
                dec     word ptr es:[1]

                no_dec_time:
                loop    dec_time_loop

                pop     ax
                pop     es
                pop     cx
                pop     bx
                pop     ds
                popf
                jmp     exit_1c

                i_m_set_1c:
                pop     word ptr es:[1ch*4]
                mov     word ptr es:[1ch*4+2],cs

                ; ⠭ ࠬ ⥪饩 
                mov     word ptr [active_task],0        ;  ⥪饩 
                mov     word ptr [ticks_left],-1   ; ⠫ ⠪⮢ ⠩
                mov     word ptr [calls_left],2   ; ⠫ -맮

                ;   ࠧ 뢠
                sti

                ;  樠㥬 TSB ⥪饩 
                push    bp
                push    si

                mov     ah,48h
                mov     bx,2
                int     21h
                mov     es,ax
                mov     bx,word ptr [task_list]
                mov     word ptr [bx+2],ax

                pop     si
                pop     bp
                jc      i_m_no_mem

                ; ७ᥬ  TSB ⥪騥 ࠬ
                mov     byte ptr es:[0],128     ; LOCK - 
                mov     word ptr es:[5],500     ; - -맮
                mov     word ptr es:[7],1       ; - ⠪⮢ ⠩
                mov     word ptr es:[9],32767   ; ਮ
                mov     word ptr es:[11],ss
                mov     ax,word ptr [s0]
                mov     word ptr es:[13],ax
                mov     word ptr es:[15],sp
                mov     ax,word ptr [r0]
                mov     word ptr es:[17],ax
                mov     word ptr es:[19],bp
                mov     ax,word ptr [ss0]
                mov     word ptr es:[21],ax
                mov     ax,word ptr [ssp]
                mov     word ptr es:[23],ax
                mov     word ptr es:[25],si

                mov     ax,0ffffh
                push    ax

                next

                ;  墠⠥   樠樨 筮
                i_m_no_mem:
                xor     ax,ax
                push    ax
                next

                ; *********************** 祭 ਮ   
                ;  ᯨ᪥ . AX --> AX
                tn_2_pl:
                push    bx
                push    es
                mov     bx,word ptr [task_list]
                inc     ax
                add     ax,ax
                add     bx,ax
                mov     es,word ptr [bx]
                mov     ax,word ptr es:[9]
                pop     es
                pop     bx
                retn

                ; ********************** 祭    ᯨ᪥ 
                ;  ᥣ TSB ( -1, ᫨    ᯨ᪥). AX --> AX
                tsb_2_tn:
                push    bx
                push    cx
                push    dx
                mov     bx,word ptr [task_list]
                mov     cx,word ptr [bx]
                xor     dx,dx
                tsb_2_tn_1:
                add     bx,2
                cmp     word ptr [bx],ax
                jz      tsb_2_tn_2
                inc     dx
                loop    tsb_2_tn_1
                mov     dx,-1
                tsb_2_tn_2:
                mov     ax,dx
                pop     dx
                pop     cx
                pop     bx
                retn

; 筮 뢠 ⥪饩   ।砩 ࠢ ᯥ 
; ( --> )
halt_:          db      4,'HALT',0
                dj      init_mt_
                ; ᨬ ⢮ ⠢ -맮
                mov     word ptr [calls_left],1

                ; ᨬ, , ⠭ 䫠 LOCK,
                ; ।⥫쭮 ࠭  ﭨ   STLOCK
                mov     bx,word ptr [active_task]
                add     bx,bx
                add     bx,word ptr [task_list]
                add     bx,2
                mov     es,word ptr [bx]
                ; ES:0 -->  TSB ⥪饩 
                mov     al,byte ptr es:[0]      ; 쬥  ﭨ 
                shr     al,1
                shr     al,1
                and     al,00100000b            ; 뤥  LOCK
                and     byte ptr es:[0],01011111b       ; ᨬ LOCK
                or      byte ptr es:[0],al      ; ࠭   STLOCK
                ;   ⮢  믮 - ⠭ 
                ; ﭨ
                and     byte ptr es:[0],11100000b
                next

; ஢ 뢠 ⥪饩 
; ( --> )
lock_:          db      4,'LOCK',0
                dj      halt_
                mov     bx,word ptr [active_task]
                add     bx,bx
                add     bx,word ptr [task_list]
                add     bx,2
                mov     es,word ptr [bx]
                ; ES:0 -->  TSB ⥪饩 
                or      byte ptr es:[0],10000000b
                mov     word ptr [calls_left],1
                next

; ⬥ ஢ 뢠 ⥪饩 
; ( --> )
unlock_:        db      6,'UNLOCK',0
                dj      lock_
                mov     bx,word ptr [active_task]
                add     bx,bx
                add     bx,word ptr [task_list]
                add     bx,2
                mov     es,word ptr [bx]
                ; ES:0 -->  TSB ⥪饩 
                and     byte ptr es:[0],01011111b
                mov     word ptr [calls_left],1
                next

;        ⮢
; ( Channel --> Data )
get_:           db      3,'GET',0
                dj      unlock_
                ; 砫 ஢ਬ 䫠 LOCK ⥪饩 
                mov     bx,word ptr [active_task]
                add     bx,bx
                add     bx,word ptr [task_list]
                add     bx,2
                mov     es,word ptr [bx]
                ; ES:0 -->  TSB ⥪饩 
                pop     bx
                ; DS:BX -->  
                test    byte ptr es:[0],128
                jz      get_no_lock             ;  LOCK 襭
                cmp     byte ptr [bx],0         ;  LOCK ⠭,
                                                ; ஢ਬ ⮢ 
                                                ;  
                jz      get_no_lock             ;   ⮢ -  
                                                ;  뢠 ᨬ
                                                ;  祭 䫠 LOCK
                push    word ptr [bx+1]         ;  ᮤন  -
                                                ;  
                mov     byte ptr [bx],0         ; ⨬   ⮩
                next                            ; த 믮 

                get_no_lock:
                ; 뢠   ⮢   
                ; ᢥન ਮ⮢ , ᨢ ⥭ 

                ; ᨬ, , ⠭ 䫠 LOCK,
                ; ।⥫쭮 ࠭  ﭨ   STLOCK
                mov     al,byte ptr es:[0]      ; 쬥  ﭨ 
                shr     al,1
                shr     al,1
                and     al,00100000b            ; 뤥  LOCK
                and     byte ptr es:[0],01011111b       ; ᨬ LOCK
                or      byte ptr es:[0],al      ; ࠭   STLOCK
                ; ﭨ ⥪饩  -    
                and     byte ptr es:[0],11100000b
                or      byte ptr es:[0],1
                ; ࠭  
                mov     word ptr es:[1],bx
                ; ᨬ ⢮ ⠢ -맮
                mov     word ptr [calls_left],1
                next

; 뢮   
; ( Data hannel --> )
put_:           db      3,'PUT',0
                dj      get_
                ; 砫 ஢ਬ 䫠 LOCK ⥪饩 
                mov     bx,word ptr [active_task]
                add     bx,bx
                add     bx,word ptr [task_list]
                add     bx,2
                mov     es,word ptr [bx]
                ; ES:0 -->  TSB ⥪饩 
                pop     bx
                ; DS:BX -->  
                pop     dx
                ; DX = 뢮 
                test    byte ptr es:[0],128
                jz      put_no_lock             ;  LOCK 襭
                cmp     byte ptr [bx],0         ;  LOCK ⠭,
                                                ; ஢ਬ 稥 
                                                ;  
                jnz     put_no_lock             ;  
                                                ;  뢠 ᨬ
                                                ;  祭 䫠 LOCK
                mov     word ptr [bx+1],dx      ;   - 뢥 
                mov     byte ptr [bx],1         ; ⨬   
                next                            ; த 믮 

                put_no_lock:
                ; 뢠      
                ; ᢥન ਮ⮢ , ᨢ   

                ; ᨬ, , ⠭ 䫠 LOCK,
                ; ।⥫쭮 ࠭  ﭨ   STLOCK
                mov     al,byte ptr es:[0]      ; 쬥  ﭨ 
                shr     al,1
                shr     al,1
                and     al,00100000b            ; 뤥  LOCK
                and     byte ptr es:[0],01011111b       ; ᨬ LOCK
                or      byte ptr es:[0],al      ; ࠭   STLOCK
                ; ﭨ ⥪饩  -  뢮  
                and     byte ptr es:[0],11100000b
                or      byte ptr es:[0],2
                ; ࠭  
                mov     word ptr es:[1],bx
                ; ࠭ 뢮 
                mov     word ptr es:[3],dx
                ; ᨬ ⢮ ⠢ -맮
                mov     word ptr [calls_left],1
                next

;  ᥬ  ࠢ
; ( State Semaphore --> )
wait_:          db      4,'WAIT',0
                dj      put_
                pop     bx
                pop     dx
                ; DS:BX -->  ᥬ
                ; DX =  祭
                cmp     word ptr [bx],dx        ; ஢ਬ ࠢ⢮ ﭨ
                                                ; ᥬ  
                                                ; ﭨ
                jnz     wait_4_state            ; , 室 
                next                            ; ﭨ ,   -
                                                ; த 믮 
                wait_4_state:
                ; 뢠   ᮮ⢥⢨ ﭨ ᥬ
                ; 室 祭

                ; ᨬ, , ⠭ 䫠 LOCK,
                ; ।⥫쭮 ࠭  ﭨ   STLOCK
                mov     cx,bx                   ;   CX  ᥬ
                mov     bx,word ptr [active_task]
                add     bx,bx
                add     bx,word ptr [task_list]
                add     bx,2
                mov     es,word ptr [bx]
                ; ES:0 -->  TSB ⥪饩 
                mov     al,byte ptr es:[0]      ; 쬥  ﭨ 
                shr     al,1
                shr     al,1
                and     al,00100000b            ; 뤥  LOCK
                and     byte ptr es:[0],01011111b       ; ᨬ LOCK
                or      byte ptr es:[0],al      ; ࠭   STLOCK
                ; ﭨ ⥪饩  -  ﭨ ᥬ
                and     byte ptr es:[0],11100000b
                or      byte ptr es:[0],4
                ; ࠭  ᥬ
                mov     word ptr es:[1],cx
                ; ࠭  ﭨ
                mov     word ptr es:[3],dx
                ; ᨬ ⢮ ⠢ -맮
                mov     word ptr [calls_left],1
                next

; ६ প ( ⠩)
; ( Ticks --> )
delay_:         db      5,'DELAY',0
                dj      wait_
                ; 믮 뢠   室
                ; ६ প
                pop     cx                      ;   CX ⢮
                                                ; ⠪⮢
                ; ᨬ, , ⠭ 䫠 LOCK,
                ; ।⥫쭮 ࠭  ﭨ   STLOCK
                mov     bx,word ptr [active_task]
                add     bx,bx
                add     bx,word ptr [task_list]
                add     bx,2
                mov     es,word ptr [bx]
                ; ES:0 -->  TSB ⥪饩 
                mov     al,byte ptr es:[0]      ; 쬥  ﭨ 
                shr     al,1
                shr     al,1
                and     al,00100000b            ; 뤥  LOCK
                and     byte ptr es:[0],01011111b       ; ᨬ LOCK
                or      byte ptr es:[0],al      ; ࠭   STLOCK
                ; ﭨ ⥪饩  -   ⠩
                and     byte ptr es:[0],11100000b
                or      byte ptr es:[0],3
                ; ࠭ ⢮ ⠪⮢ ⠩
                mov     word ptr es:[1],cx
                ; ᨬ ⢮ ⠢ -맮
                mov     word ptr [calls_left],1
                next

; ஢ઠ ﭨ 
; ( Channel --> FullFlag )
check_:         db      5,'CHECK',0
                dj      delay_
                pop     bx
                cmp     byte ptr [bx],0
                jz      check_empty
                mov     ax,0ffffh
                check_end:
                push    ax
                next
                check_empty:
                xor     ax,ax
                jmp     short check_end

; 祭   
; ( --> Channel )
keyboard_:      db      8,'KEYBOARD',0
                dj      check_
                mov     bx,word ptr [task_list]
                mov     ax,word ptr [bx]
                add     ax,ax
                add     ax,2
                add     ax,bx
                push    ax
                next

; ⠭ ﭨ ᥬ
; ( State Semaphore --> )
set_:           db      3,'SET',0
                dj      keyboard_
                ; 襬  ᥬ  ﭨ
                pop     bx
                pop     word ptr [bx]

                ; ஢ਬ 䫠 LOCK ⥪饩 
                mov     bx,word ptr [active_task]
                add     bx,bx
                add     bx,word ptr [task_list]
                add     bx,2
                mov     es,word ptr [bx]
                ; ES:0 -->  TSB ⥪饩 
                test    byte ptr es:[0],128
                jnz     set_end                 ;  LOCK ⠭ -
                                                ;   뢠
                ; 믮 ⢨ HALT

                ; ᨬ ⢮ ⠢ -맮
                mov     word ptr [calls_left],1

                ; ᨬ, , ⠭ 䫠 LOCK,
                ; ।⥫쭮 ࠭  ﭨ   STLOCK
                mov     al,byte ptr es:[0]      ; 쬥  ﭨ 
                shr     al,1
                shr     al,1
                and     al,00100000b            ; 뤥  LOCK
                and     byte ptr es:[0],01011111b       ; ᨬ LOCK
                or      byte ptr es:[0],al      ; ࠭   STLOCK
                ;   ⮢  믮 - ⠭ 
                ; ﭨ
                and     byte ptr es:[0],11100000b
                set_end:
                next

; ਮ⠭ 믮 
; ( TaskHandle --> )
stop_:          db      4,'STOP',0
                dj      set_
                pop     es
                ; ES:0 -->  TSB ਮ⠭ 
                ; ( 易⥫쭮 ⥪饩)
                or      byte ptr es:[0],64
                mov     word ptr [calls_left],1
                next

; ⬥ ਮ⠭ 믮 
; ( TaskHandle --> )
cont_:          db      4,'CONT',0
                dj      stop_
                pop     es
                ; ES:0 -->  TSB 
                and     byte ptr es:[0],10111111b
                mov     word ptr [calls_left],1
                next

; ਭ㤨⥫쭮 襭 믮  ( ⥪饩 !!!)
; ( TaskHandle --> )
cancel_:        db      6,'CANCEL',0
                dj      cont_
                mov     word ptr [calls_left],1
                pop     es
                push    es
                mov     ah,49h
                push    bp
                push    si
                push    word ptr es:[11]
                int     21h
                pop     dx
                pop     si
                pop     bp
                jc      cant_cancel             ; 訡 -  TaskHandle
                mov     es,dx                   ; dx = ss 蠥 
                mov     ah,49h
                push    si
                push    bp
                int     21h
                pop     bp
                pop     si
                jc      cant_cancel
                pop     dx
                ;  蠥   ᯨ᪥ 
                mov     bx,word ptr [task_list]
                mov     cx,word ptr [bx]
                add     bx,2
                cancel_loop:
                cmp     word ptr [bx],dx
                jz      cancel_found
                add     bx,2
                loop    cancel_loop
                ;     ᯨ᪥ 
                next
                cant_cancel:
                pop     dx
                next
                cancel_found:
                mov     word ptr [bx],0
                next

; 樨஢ 믮 
; ( Proc StackSize ReturnStackSize LocalStackSize PL CallCount TickCount -->
;    --> TaskHandle/False )
start_:         db      5,'START',0
                dj      cancel_
                mov     bx,2
                mov     ah,48h
                push    si
                push    bp
                int     21h
                pop     bp
                pop     si
                jnc     start_tsb_ok
                ;     TSB
                add     sp,14
                xor     ax,ax
                push    ax
                next
                start_tsb_ok:
                mov     es,ax
                pop     word ptr es:[7]         ; ⢮ ⠪⮢ ⠩
                pop     word ptr es:[5]         ; ⢮ -맮
                pop     ax
                mov     word ptr es:[9],ax      ; ਮ 
                mov     word ptr [time_x],ax    ;       ?
                pop     bx                      ; LocalStackSize
                pop     dx                      ; ReturnStackSize
                pop     cx                      ; StackSize
                pop     ax                      ; ⮢ (!)-楤
                add     ax,3                    ; ய⨬ CALL CALLR
                mov     word ptr es:[25],ax     ; SI
                mov     word ptr es:[21],bx     ; L0  (SS0)
                mov     word ptr es:[23],bx     ; LSP (SSP)
                add     bx,cx
                mov     word ptr es:[13],bx     ; S0
                mov     word ptr es:[15],bx     ; SP
                add     bx,dx
                mov     word ptr es:[17],bx     ; R0
                mov     word ptr es:[19],bx     ; BP
                mov     byte ptr es:[0],0       ; ﭨ 
                add     bx,15
                shr     bx,1
                shr     bx,1
                shr     bx,1
                shr     bx,1
                mov     ah,48h
                push    si
                push    bp
                push    es
                int     21h
                pop     es
                pop     bp
                pop     si
                jnc     start_mem_ok
                ;    ⥪ ᥣ
                start_err_exit:
                xor     ax,ax
                push    ax
                next
                start_mem_ok:
                mov     word ptr es:[11],ax     ;  ⥪ ᥣ
                ; ᥬ ᥣ TSB  ᯨ᮪ 
                mov     bx,word ptr [task_list]
                mov     cx,word ptr [bx]
                st_store_loop:
                add     bx,2
                cmp     word ptr [bx],0
                jz      st_may_store
                loop    st_store_loop
                jmp     short start_err_exit
                st_may_store:
                mov     word ptr [bx],es
                push    es                      ; ⨬ ᥣ TSB
                next

; ( --> TSB )
tsb_:           db      3,'TSB',0
                dj      start_
                mov     bx,word ptr [active_task]
                add     bx,bx
                add     bx,word ptr [task_list]
                add     bx,2
                push    word ptr [bx]
                next

init_:          db      1,' ',0
                dj      tsb_
                next

                dw      100h
                dw      (offset init_)-100h
                include vers.inc
                dw      1231h

                end     module
