
; QUATTRO.ASM

                include forthasm.inc

qplus:          db      2,'Q+',0
                dw      0
                mov     word ptr [time_x],bp
                mov     bp,sp
                pop     ax
                add     word ptr [bp+8],ax
                pop     ax
                adc     word ptr [bp+10],ax
                pop     ax
                adc     word ptr [bp+12],ax
                pop     ax
                adc     word ptr [bp+14],ax
                mov     bp,word ptr [time_x]
                next
                
qmines:         db      2,'Q-',0
                dj      qplus
                mov     word ptr [time_x],bp
                mov     bp,sp
                pop     ax
                sub     word ptr [bp+8],ax
                pop     ax
                sbb     word ptr [bp+10],ax
                pop     ax
                sbb     word ptr [bp+12],ax
                pop     ax
                sbb     word ptr [bp+14],ax
                mov     bp,word ptr [time_x]
                next

qmult:          db      2,'Q*',0
                dj      qmines
                mov     word ptr [time_x],bp
                xor     bx,bx
                xor     cx,cx
                xor     dx,dx
                xor     di,di
                push    bx
                push    bx
                push    bx
                push    bx
                mov     bp,sp
                mov     al,63
                xchg    di,word ptr [bp+16]
                xchg    dx,word ptr [bp+18]
                xchg    cx,word ptr [bp+20]
                xchg    bx,word ptr [bp+22]
                mlp:
                test    byte ptr [bp+15],128
                jz      mlp1
                add     [bp+16],di
                adc     [bp+18],dx
                adc     [bp+20],cx
                adc     [bp+22],bx
                adc     word ptr [bp+0],0
                adc     word ptr [bp+2],0
                mlp1:
                shl     word ptr [bp+16],1
                rcl     word ptr [bp+18],1
                rcl     word ptr [bp+20],1
                rcl     word ptr [bp+22],1
                rcl     word ptr [bp+0],1
                rcl     word ptr [bp+2],1
                shl     word ptr [bp+8],1
                rcl     word ptr [bp+10],1
                rcl     word ptr [bp+12],1
                rcl     word ptr [bp+14],1
                dec     al
                jnz     mlp
                test    byte ptr [bp+15],128
                jz      mlp2
                add     [bp+16],di
                adc     [bp+18],dx
                adc     [bp+20],cx
                adc     [bp+22],bx
                adc     word ptr [bp+0],0
                adc     word ptr [bp+2],0
                mlp2:
                mov     ax,[bp+20]
                mov     [bp+16],ax
                mov     ax,[bp+22]
                mov     [bp+18],ax
                mov     ax,[bp+0]
                mov     [bp+20],ax
                mov     ax,[bp+2]
                mov     [bp+22],ax
                add     sp,16
                mov     bp,word ptr [time_x]
                next

uqdiv:          db      3,'UQ/',0
                dj      qmult
                mov     word ptr [time_x],bp
                mov     bp,sp
                mov     ax,[bp+0]
                or      ax,[bp+2]
                or      ax,[bp+4]
                or      ax,[bp+6]
                jnz     divide
                jmp     qdiv_exit               ; Division by zero
                divide:
                xor     bx,bx
                xor     cx,cx
                xor     dx,dx
                xor     di,di
                push    bx
                push    bx
                push    bx
                push    bx
                push    bx
                push    bx
                mov     al,96
                or      al,al
                mov     bp,sp

                dvloop:
                push    ax
                rcl     cx,1
                rcl     bx,1
                rcl     word ptr [bp+20],1
                rcl     word ptr [bp+22],1
                rcl     word ptr [bp+24],1
                rcl     word ptr [bp+26],1
                rcl     word ptr [bp+0],1
                rcl     word ptr [bp+2],1
                rcl     word ptr [bp+4],1
                rcl     word ptr [bp+6],1
                rcl     word ptr [bp+8],1
                rcl     word ptr [bp+10],1

                mov     ax,[bp+0]
                sub     ax,[bp+12]
                mov     word ptr [err_sp],ax
                mov     ax,[bp+2]
                sbb     ax,[bp+14]
                mov     word ptr [err_bp],ax
                mov     ax,[bp+4]
                sbb     ax,[bp+16]
                mov     word ptr [time_t],ax
                mov     ax,[bp+6]
                sbb     ax,[bp+18]
                mov     word ptr [time_z],ax
                mov     ax,[bp+8]
                sbb     ax,di
                mov     word ptr [time_y],ax
                mov     ax,[bp+10]
                sbb     ax,dx
                mov     word ptr [err_si],ax
                cmc
                jnc     no_drop

                mov     [bp+10],ax
                mov     ax,word ptr [time_y]
                mov     [bp+8],ax
                mov     ax,word ptr [time_z]
                mov     [bp+6],ax
                mov     ax,word ptr [time_t]
                mov     [bp+4],ax
                mov     ax,word ptr [err_bp]
                mov     [bp+2],ax
                mov     ax,word ptr [err_sp]
                mov     [bp+0],ax

                no_drop:
                pop     ax
                dec     al
                jnz     dvloop

                rcl     cx,1
                rcl     bx,1
                rcl     word ptr [bp+20],1
                rcl     word ptr [bp+22],1
                rcl     word ptr [bp+24],1
                rcl     word ptr [bp+26],1

                mov     ax,[bp+22]
                mov     [bp+26],ax
                mov     ax,[bp+20]
                mov     [bp+24],ax
                mov     [bp+22],bx
                mov     [bp+20],cx

                add     sp,20
                qdiv_exit:
                mov     bp,word ptr [time_x]
                next

q2d:            db      3,'Q>D',0
                dj      uqdiv
                pop     ax
                pop     ax
                pop     ax
                pop     bx
                push    ax
                push    bx
                next

q2s:            db      3,'Q>S',0
                dj      q2d
                pop     ax
                pop     ax
                pop     bx
                pop     ax
                push    bx
                next

qdrop:          db      5,'QDROP',0
                dj      q2s
                pop     ax
                pop     ax
                pop     ax
                pop     ax
                next

qswap:          db      5,'QSWAP',0
                dj      qdrop
                pop     ax
                pop     bx
                pop     cx
                pop     dx
                pop     di
                pop     word ptr [time_x]
                pop     word ptr [time_y]
                pop     word ptr [time_z]
                push    dx
                push    cx
                push    bx
                push    ax
                push    word ptr [time_z]
                push    word ptr [time_y]
                push    word ptr [time_x]
                push    di
                next

qpress:         db      6,'QPRESS',0
                dj      qswap
                pop     ax
                pop     bx
                pop     cx
                pop     dx
                pop     di
                pop     di
                pop     di
                pop     di
                push    dx
                push    cx
                push    bx
                push    ax
                next

qdup:           db      4,'QDUP',0
                dj      qpress
                pop     ax
                pop     bx
                pop     cx
                pop     dx
                push    dx
                push    cx
                push    bx
                push    ax
                push    dx
                push    cx
                push    bx
                push    ax
                next

qrot:           db      4,'QROT',0
                dj      qdup
                pop     ax
                pop     bx
                pop     cx
                pop     dx
                pop     di
                pop     word ptr [time_x]
                pop     word ptr [time_y]
                pop     word ptr [time_z]
                pop     word ptr [time_t]
                pop     word ptr [err_bp]
                pop     word ptr [err_sp]
                pop     word ptr [err_si]
                push    word ptr [time_z]
                push    word ptr [time_y]
                push    word ptr [time_x]
                push    di
                push    dx
                push    cx
                push    bx
                push    ax
                push    word ptr [err_si]
                push    word ptr [err_sp]
                push    word ptr [err_bp]
                push    word ptr [time_t]
                next

qover:          db      5,'QOVER',0
                dj      qrot
                pop     ax
                pop     bx
                pop     cx
                pop     dx
                pop     di
                pop     word ptr [time_x]
                pop     word ptr [time_y]
                pop     word ptr [time_z]
                push    word ptr [time_z]
                push    word ptr [time_y]
                push    word ptr [time_x]
                push    di
                push    dx
                push    cx
                push    bx
                push    ax
                push    word ptr [time_z]
                push    word ptr [time_y]
                push    word ptr [time_x]
                push    di
                next

qprisv:         db      2,'Q!',0
                dj      qover
                pop     bx
                pop     word ptr [bx]
                pop     word ptr [bx+2]
                pop     word ptr [bx+4]
                pop     word ptr [bx+6]
                next

aqprisv:        db      3,'AQ!',0
                dj      qprisv
                pop     ds
                pop     bx
                pop     word ptr [bx]
                pop     word ptr [bx+2]
                pop     word ptr [bx+4]
                pop     word ptr [bx+6]
                push    cs
                pop     ds
                next

qraz:           db      2,'Q@',0
                dj      aqprisv
                pop     bx
                push    word ptr [bx+6]
                push    word ptr [bx+4]
                push    word ptr [bx+2]
                push    word ptr [bx]
                next

aqraz:          db      3,'AQ@',0
                dj      qraz
                pop     ds
                pop     bx
                push    word ptr [bx+6]
                push    word ptr [bx+4]
                push    word ptr [bx+2]
                push    word ptr [bx]
                push    cs
                pop     ds
                next

qcomp:          db      2,'Q,',0
                dj      aqraz
                mov     bx,word ptr [upvoc]
                add     word ptr [upvoc],8
                pop     word ptr [bx]
                pop     word ptr [bx+2]
                pop     word ptr [bx+4]
                pop     word ptr [bx+6]
                next

q0eq:           db      3,'Q0=',0
                dj      qcomp
                pop     ax
                pop     bx
                or      ax,bx
                pop     bx
                or      ax,bx
                pop     bx
                or      ax,bx
                jz      q0eq_true
                xor     ax,ax
                q0eq_exit:
                push    ax
                next
                q0eq_true:
                mov     ax,0ffffh
                jmp     short q0eq_exit

q0lt:           db      3,'Q0<',0
                dj      q0eq
                pop     ax
                pop     ax
                pop     ax
                pop     ax
                test    ah,128
                jnz     q0lt_true
                xor     ax,ax
                q0lt_exit:
                push    ax
                next
                q0lt_true:
                mov     ax,0ffffh
                jmp     short q0lt_exit

q0gt:           db      3,'Q0>',0
                dj      q0lt
                pop     ax
                pop     bx
                or      ax,bx
                pop     bx
                or      ax,bx
                pop     bx
                or      ax,bx
                jnz     q0gt_test
                q0gt_false:
                xor     ax,ax
                q0gt_exit:
                push    ax
                next
                q0gt_test:
                test    bh,128
                jnz     q0gt_false
                mov     ax,0ffffh
                jmp     short q0gt_exit

qnegate:        db      7,'QNEGATE',0
                dj      q0gt
                pop     ax
                pop     bx
                pop     cx
                pop     dx
                not     ax
                not     bx
                not     cx
                not     dx
                add     ax,1
                adc     bx,0
                adc     cx,0
                adc     dx,0
                push    dx
                push    cx
                push    bx
                push    ax
                next

qabs:           db      4,'QABS',0
                dj      qnegate
                pop     ax
                pop     bx
                pop     cx
                pop     dx
                test    dh,128
                jz      qabs_pl
                not     ax
                not     bx
                not     cx
                not     dx
                add     ax,1
                adc     bx,0
                adc     cx,0
                adc     dx,0
                qabs_pl:
                push    dx
                push    cx
                push    bx
                push    ax
                next

qint:           db      4,'QINT',0
                dj      qabs
                pop     ax
                pop     ax
                xor     ax,ax
                push    ax
                push    ax
                next

q1pl_prisv:     db      4,'Q1+!',0
                dj      qint
                pop     bx
                add     word ptr [bx+4],1
                adc     word ptr [bx+6],0
                next

q1mn_prisv:     db      4,'Q1-!',0
                dj      q1pl_prisv
                pop     bx
                sub     word ptr [bx+4],1
                sbb     word ptr [bx+6],0
                next

qpl_prisv:      db      3,'Q+!',0
                dj      q1mn_prisv
                pop     bx
                pop     ax
                pop     cx
                pop     dx
                pop     di
                add     [bx],ax
                adc     [bx+2],cx
                adc     [bx+4],dx
                adc     [bx+6],di
                next

qmn_prisv:      db      3,'Q-!',0
                dj      qpl_prisv
                pop     bx
                pop     ax
                pop     cx
                pop     dx
                pop     di
                sub     [bx],ax
                sbb     [bx+2],cx
                sbb     [bx+4],dx
                sbb     [bx+6],di
                next

q1plus:         db      3,'Q1+',0
                dj      qmn_prisv
                pop     ax
                pop     bx
                pop     cx
                pop     dx
                add     cx,1
                adc     dx,0
                push    dx
                push    cx
                push    bx
                push    ax
                next

q1mines:        db      3,'Q1-',0
                dj      q1plus
                pop     ax
                pop     bx
                pop     cx
                pop     dx
                sub     cx,1
                sbb     dx,0
                push    dx
                push    cx
                push    bx
                push    ax
                next

q2mult:         db      3,'Q2*',0
                dj      q1mines
                pop     ax
                pop     bx
                pop     cx
                pop     dx
                shl     ax,1
                rcl     bx,1
                rcl     cx,1
                rcl     dx,1
                push    dx
                push    cx
                push    bx
                push    ax
                next

q2div:          db      3,'Q2/',0
                dj      q2mult
                pop     ax
                pop     bx
                pop     cx
                pop     dx
                sar     dx,1
                rcr     cx,1
                rcr     bx,1
                rcr     ax,1
                push    dx
                push    cx
                push    bx
                push    ax
                next

qsgn:           db      4,'QSGN',0
                dj      q2div
                pop     ax
                pop     bx
                pop     cx
                pop     dx
                or      ax,bx
                or      ax,cx
                or      ax,dx
                jz      qsgn_zero
                test    dh,128
                jnz     qsgn_m1
                xor     ax,ax
                push    ax
                inc     ax
                push    ax
                dec     ax
                qsgn_exit:
                push    ax
                push    ax
                next
                qsgn_zero:
                xor     ax,ax
                push    ax
                push    ax
                jmp     short qsgn_exit
                qsgn_m1:
                mov     ax,0ffffh
                push    ax
                push    ax
                inc     ax
                jmp     short qsgn_exit

s2q:            db      3,'S>Q',0
                dj      qsgn
                pop     ax
                cwd
                push    dx
                push    ax
                xor     ax,ax
                push    ax
                push    ax
                next

d2q:            db      3,'D>Q',0
                dj      s2q
                pop     ax
                pop     bx
                push    ax
                push    bx
                xor     ax,ax
                push    ax
                push    ax
                next

u2q:            db      3,'U>Q',0
                dj      d2q
                pop     ax
                xor     dx,dx
                push    dx
                push    ax
                push    dx
                push    dx
                next

init:           db      1,' ',0
                dj      u2q
                next

                dw      100h
                dw      (offset init)-100h
                include vers.inc
                dw      1231h

                end     module
