
5000 ScreenStackSize !
16000 ReturnStackSize !
20000 MemorySize !

Use Graph.frl
Use 256Color.frl
Use KbdCodes.frl
Use Crt.frl
Use DOS.frl
Use Mouse.frl
Use 256out.frl

: SHIFTPRESSED ( --> Flag )
   $ 417 0 ac@ 3 And 0= 0=
;

Registers REGS
: WHEREMOUSEXY ( --> X Y )
   3 Regs !
   $ 33 Regs Intr
   Regs CX @ Regs DX @
;

Create STANDARDPALETTE
768 LoadCode standard.pal

: SETALLPALETTE
   CodeSegment Regs ES !
   StandardPalette Regs DX !
   0 Regs BX !
   256 Regs CX !
   $ 1012 Regs !
   $ 10 Regs Intr
;

: GETPALETTE ( Color --> R G B )
   $ 1015 Regs !
   Regs BX !
   $ 10 Regs Intr
   Regs DX 1+ c@
   Regs CX 1+ c@
   Regs CX c@
;

: SETPALETTE ( Color R G B --> )
   Regs CX c!
   Regs CX 1+ c!
   Regs DX 1+ c!
   Regs BX !
   $ 1010 Regs !
   $ 10 Regs Intr
;

: WHEREMOUSEX WhereMouseXY Drop ;
: WHEREMOUSEY WhereMouseXY Press ;

: SETXRANGE ( X0 X1 --> )
   7 Regs !
   Regs DX !
   Regs CX !
   $ 33 Regs Intr
;

: SETYRANGE ( Y0 Y1 --> )
   8 Regs !
   Regs DX !
   Regs CX !
   $ 33 Regs Intr
;

Variable X1
Variable Y1
Variable X2
Variable Y2
Variable CL

Variable D
Variable DX
Variable DY
Variable AINCR
Variable BINCR
Variable YINCR

Variable WX
Variable WY

Variable RLESEG

Variable RESERVE
Variable UNDOBUFFER

Variable DUPWINFLAG

: WPUT ( --> )
   $Screen 11 45 0 UndoBuffer @ WX @ WY @ 320 320 145 145 $Copy256
;

: WGET ( --> )
   0 UndoBuffer @ WX @ WY @ $Screen 11 45 320 320 145 145 $Copy256
;

: PUTPIXEL ( X Y Color --> )
   >R
   2Dup 0 199 WithIn Swap 0 319 WithIn And R> Swap
   If
      >r >r >r 0 UndoBuffer @ 320 r> r> r> $Put
   Else
      2Drop Drop
   Then
;

: GETPIXEL ( X Y --> Color )
   2Dup 0 199 WithIn Swap 0 319 WithIn And
   If
      >r >r 0 UndoBuffer @ 320 r> r> $Get
   Else
      2Drop 255
   Then
;

: LINE ( X1 Y1 X2 Y2 Color --> )
   Cl ! Y2 ! X2 ! Y1 ! X1 !
   X1 @ X2 @ = Y1 @ Y2 @ = And If X1 @ Y1 @ Cl @ PutPixel Exit Then
   Y1 @ Y2 @ - Abs X1 @ X2 @ - Abs >
   If
      X1 Y1 Exchange
      X2 Y2 Exchange
      X1 @ X2 @ >
      If
         X1 X2 Exchange
         Y1 Y2 Exchange
      Then
      Y2 @ Y1 @ >
      If
         1
      Else
         True
      Then
      Yincr !
      X2 @ X1 @ - DX !
      Y2 @ Y1 @ - Abs DY !
      DY @ 2* DX @ - D !

      DY @ DX @ - 2* Aincr !
      DY @ 2* Bincr !

      Y1 @ X1 @ Cl @ PutPixel

      X2 @ 1+ X1 @ 1+
      Do
         D @ 0<
         If
            Bincr @ D +!
         Else
            Yincr @ Y1 +!
            Aincr @ D +!
         Then
         Y1 @ i Cl @ PutPixel
      Loop
   Else
      X1 @ X2 @ >
      If
         X1 X2 Exchange
         Y1 Y2 Exchange
      Then
      Y2 @ Y1 @ >
      If
         1
      Else
         True
      Then
      Yincr !
      X2 @ X1 @ - DX !
      Y2 @ Y1 @ - Abs DY !
      DY @ 2* DX @ - D !

      DY @ DX @ - 2* Aincr !
      DY @ 2* Bincr !

      X1 @ Y1 @ Cl @ PutPixel

      X2 @ 1+ X1 @ 1+
      Do
         D @ 0<
         If
            Bincr @ D +!
         Else
            Yincr @ Y1 +!
            Aincr @ D +!
         Then
         i Y1 @ Cl @ PutPixel
      Loop
   Then
;

Variable BV
Variable FV

: XL Here 2 - ;
: XR Here 4 - ;
: X Here 6 - ;
: Y Here 8 - ;
: D Here 10 - ;
: PREVXL Here 12 - ;
: PREVXR Here 14 - ;

: (LINEFILL) ( X Y D PREVXL PREVXR --> x )
   , , , , Dup Dup , , ,
   Y @ 0 319 WithIn
   If

      X @ XL !
      Begin
         XL @ 0< Not XL @ Y @ GetPixel BV @ = And
      While
         XL 1-!
      Repeat
      XL 1+!

      X @ XR !
      Begin
         XR @ 320 < XR @ Y @ GetPixel BV @ = And
      While
         XR 1+!
      Repeat
      XR 1-!

      XL @ Y @ XR @ Over FV @ Line

      XL @ X !
      Begin
         X @ XR @ > Not
      While
         X @ Y @ D @ + GetPixel
         BV @ =
         If
            X @ Y @ D @ + D @
            XL @ XR @
            Recurse X !
         Then
         X 1+!
      Repeat
      XL @ X !
      Begin
         X @ PREVXL @ <
      While
         X @ Y @ D @ - GetPixel
         BV @ =
         If
            X @ Y @ D @ - D @ Negate
            XL @ XR @
            Recurse X !
         Then
         X 1+!
      Repeat
      PREVXR @ X !
      Begin
         X @ XR @ <
      While
         X @ Y @ D @ - GetPixel
         BV @ =
         If
            X @ Y @ D @ -
            D @ Negate XL @ XR @
            Recurse X !
         Then
         X 1+!
      Repeat
   Then
   XR @
   -14 Allot
;

: ADJFILL ( x y FillColor BorderColor --> SuccessFlag )
   BV ! FV !
   Over Dup 1 Rot Rot
   (LineFill) Drop
;

Smuge X
Smuge Y
Smuge D
Smuge PREVXL
Smuge PREVXR
Smuge BV
Smuge FV
Smuge XL
Smuge XR

Variable DX
Variable DY
Variable X1
Variable Y1
Variable CL
Variable D

: (PLOTC)
   DX @ X1 @ + Y1 @ DY @ + Cl @ PutPixel
   DX @ X1 @ + Y1 @ DY @ - Cl @ PutPixel
   X1 @ DX @ - Y1 @ DY @ + Cl @ PutPixel
   X1 @ DX @ - Y1 @ DY @ - Cl @ PutPixel

   X1 @ DY @ + Y1 @ DX @ + Cl @ PutPixel
   X1 @ DY @ + Y1 @ DX @ - Cl @ PutPixel
   X1 @ DY @ - Y1 @ DX @ + Cl @ PutPixel
   X1 @ DY @ - Y1 @ DX @ - Cl @ PutPixel
;

: CIRCLE ( X Y Radius Color --> )
   Cl !
   Dup DY !
   2* 3 Swap - D !
   Y1 ! X1 !
   DX 0!
   Begin
      DX @ DY @ <
   While
      (PlotC)
      D @ 0<
      If
         DX @ 2* 2* 6 + D +!
      Else
         DX @ DY @ - 2* 2* 10 + D +!
         DY 1-!
      Then
      DX 1+!
   Repeat
   DY @
   If
      DY @ DX ! (PlotC)
   Then
;

Smuge DX
Smuge DY
Smuge X1
Smuge Y1
Smuge CL
Smuge D

Create LATFONT8*8 512 LoadCode lat88.fnt
.( \rGP-Forth : 8*8 Font Loaded Ok\r\n)

Variable @MOU

Variable MSX
Variable MSY

: ?M
   @Mou @
;

255 Constant 255
 21 Constant 021

Variable LINS 0 Lins !

Create EMPSPR
( Created by Alexandr Larionov )
( Sprite Size : 001 * 001 )
255 c,
1 Constant EMPXSIZE
1 Constant EMPYSIZE

Create PENSPR
( Created by GP-Forth Sprite Editor )
( Sprite Size : 26 * 26 )
$Sprite
15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15
15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 1E 1E 1F 15 15 15
15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 1E 1D 1C 1E 1F 15 15
15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 1E 1D 1C 19 17 1E 15 15
15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 1E 1D 1C 19 17 15 15 1E 15
15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 1E 1D 1C 19 17 15 15 1E 15 15
15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 1E 1D 1C 19 17 15 15 1E 15 15 15
15 15 15 15 15 15 15 15 15 15 15 15 15 15 1E 1D 1C 19 17 15 15 1E 15 15 15 15
15 15 15 15 15 15 15 15 15 15 15 15 15 1E 1D 1C 19 17 15 15 1E 15 15 15 15 15
15 15 15 15 15 15 15 15 15 15 15 15 1E 1D 1C 19 17 15 15 1E 15 15 15 15 15 15
15 15 15 15 15 15 15 15 15 15 15 1E 1D 1C 19 17 15 15 1E 15 15 15 15 15 15 15
15 15 15 15 15 15 15 15 15 15 1E 1D 1C 19 17 15 15 1E 15 15 15 15 15 15 15 15
15 15 15 15 15 15 15 15 15 1E 1D 1C 19 17 15 15 1E 15 15 15 15 15 15 15 15 15
15 15 15 15 15 15 15 15 1E 1D 1C 19 17 15 15 1E 15 15 15 15 15 15 15 15 15 15
15 15 15 15 15 15 15 1E 1D 1C 19 17 15 15 15 15 15 15 15 15 15 15 15 15 15 15
15 15 15 15 15 15 1E 1D 1C 19 17 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15
15 15 15 15 15 1E 1D 1C 19 17 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15
15 15 15 15 1E 1D 1C 19 17 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15
15 15 15 1E 1D 1C 19 17 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15
15 15 1C 1C 1C 19 17 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15
15 15 1C 1C 19 17 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15
15 1C 19 19 17 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15
15 36 17 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15
36 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15
15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15
15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15

26 Constant PENXSIZE
26 Constant PENYSIZE

Create !SPR
( Created by GP-Forth Sprite Editor )
( Sprite Size : 18 * 16 )
$Sprite
01 01 01 01 01 1B 1B 1B 1B 1B 1B 1B 1B 1B 1B 01 01 15
01 01 01 01 01 1B 1A 1A 1A 1A 1A 01 01 1A 1B 01 01 01
01 01 01 01 01 1B 1A 1A 1A 1A 1A 01 01 1A 1B 01 01 01
01 01 01 01 01 1B 1A 1A 1A 1A 1A 01 01 1A 1B 01 01 01
01 01 01 01 01 1B 1A 1A 1A 1A 1A 01 01 1A 1B 01 01 01
01 01 01 01 01 1B 1B 1B 1B 1B 1B 1B 1B 1B 1B 01 01 01
01 01 01 01 01 01 01 01 01 01 01 01 01 01 01 01 01 01
01 01 01 01 01 01 01 01 01 01 01 01 01 01 01 01 01 01
01 01 09 09 09 09 09 09 09 09 09 09 09 09 09 09 01 01
01 01 09 09 09 09 09 09 09 09 09 09 09 09 09 09 01 01
01 01 09 09 09 09 09 09 09 09 09 09 09 09 09 09 01 01
01 01 09 09 09 09 09 09 09 09 09 09 09 09 09 09 01 01
01 01 09 09 09 09 09 09 09 09 09 09 09 09 09 09 01 01
01 01 09 09 09 09 09 09 09 09 09 09 09 09 09 09 01 01
01 01 09 09 09 09 09 09 09 09 09 09 09 09 09 09 01 01
01 01 17 17 17 17 17 17 17 17 17 17 17 17 17 17 01 01

18 Constant !XSIZE
16 Constant !YSIZE

Create LOOKSPR
( Created by GP-Forth Sprite Editor )
( Sprite Size : 26 * 26 )
$Sprite
15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15
15 15 15 15 15 15 15 12 12 12 12 12 12 15 15 15 15 15 15 15 15 15 15 15 15 15
15 15 15 15 15 12 12 12 12 12 12 12 12 12 12 15 15 15 15 15 15 15 15 15 15 15
15 15 15 15 12 12 13 13 14 14 14 14 13 13 12 12 15 15 15 15 15 15 15 15 15 15
15 15 15 12 12 13 14 14 15 15 15 15 14 14 13 12 12 15 15 15 15 15 15 15 15 15
15 15 12 12 13 14 16 18 16 15 15 15 15 15 14 13 12 12 15 15 15 15 15 15 15 15
15 15 12 13 14 16 18 1B 18 16 15 15 15 15 15 14 13 12 15 15 15 15 15 15 15 15
15 12 12 13 14 18 1B 1C 1B 18 15 15 15 15 15 14 13 12 12 15 15 15 15 15 15 15
15 12 12 14 16 18 1B 1C 1B 18 15 15 15 15 15 15 14 12 12 15 15 15 15 15 15 15
15 12 12 14 15 16 18 1B 18 16 15 15 0E 0E 0E 15 14 12 12 15 15 15 15 15 15 15
15 12 12 14 15 15 16 18 16 15 15 0E 15 15 0E 15 14 12 12 15 15 15 15 15 15 15
15 12 12 14 15 15 15 16 15 15 0E 15 15 15 0E 15 14 12 12 15 15 15 15 15 15 15
15 12 12 13 14 15 15 15 15 15 0E 0E 0E 0E 0E 14 13 12 12 15 15 15 15 15 15 15
15 15 12 13 14 15 15 15 15 15 0E 15 15 15 0E 14 13 12 15 15 15 15 15 15 15 15
15 15 12 12 13 14 15 15 15 15 0E 15 15 15 14 13 12 12 15 15 15 15 15 15 15 15
15 15 15 12 12 13 14 14 15 15 15 15 14 14 13 12 12 15 12 15 15 15 15 15 15 15
15 15 15 15 12 12 13 13 14 14 14 14 13 13 12 12 14 13 12 15 15 15 15 15 15 15
15 15 15 15 15 12 12 12 12 12 12 12 12 12 12 15 13 14 13 12 15 15 15 15 15 15
15 15 15 15 15 15 15 12 12 12 12 12 15 15 15 12 12 13 14 13 12 15 15 15 15 15
15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 12 13 14 13 12 15 15 15 15
15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 12 13 14 13 12 15 15 15
15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 12 13 14 13 12 15 15
15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 12 13 14 13 12 15
15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 12 13 14 13 15
15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 12 13 15 15
15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15 15

26 Constant LOOKXSIZE
26 Constant LOOKYSIZE

Create GCURSOR
( Created by GP-Forth Sprite Editor: 8 sprites )
( Sprites Size : 8 * 8 )
$Sprite
FF FF FF 09 09 FF FF FF FF FF FF 09 09 FF FF FF
FF FF FF 09 09 FF FF FF FF FF FF 09 09 FF FF FF
FF FF FF 09 09 FF FF FF FF FF FF 09 09 FF FF FF
FF FF FF 09 09 FF FF FF FF FF FF 09 09 FF FF FF
FF FF FF FF FF 09 09 FF FF FF FF FF 09 09 FF FF
FF FF FF FF 09 09 FF FF FF FF FF 09 09 FF FF FF
FF FF FF 09 09 FF FF FF FF FF 09 09 FF FF FF FF
FF FF 09 09 FF FF FF FF FF 09 09 FF FF FF FF FF
FF FF FF FF FF FF 09 FF FF FF FF FF FF 09 09 09
FF FF FF FF 09 09 09 FF FF FF FF 09 09 09 FF FF
FF FF 09 09 09 FF FF FF FF 09 09 09 FF FF FF FF
09 09 09 FF FF FF FF FF FF 09 FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 09
FF FF FF FF FF 09 09 09 FF FF FF 09 09 09 09 FF
FF 09 09 09 09 FF FF FF 09 09 09 FF FF FF FF FF
09 FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF 09 09 09 09 09 09 09 09
09 09 09 09 09 09 09 09 FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF 09 FF FF FF FF FF FF FF
09 09 09 FF FF FF FF FF FF 09 09 09 09 FF FF FF
FF FF FF 09 09 09 09 FF FF FF FF FF FF 09 09 09
FF FF FF FF FF FF FF 09 FF FF FF FF FF FF FF FF
FF 09 FF FF FF FF FF FF 09 09 09 FF FF FF FF FF
FF 09 09 09 FF FF FF FF FF FF 09 09 09 FF FF FF
FF FF FF 09 09 09 FF FF FF FF FF FF 09 09 09 FF
FF FF FF FF FF 09 09 09 FF FF FF FF FF FF 09 FF
FF 09 09 FF FF FF FF FF FF FF 09 09 FF FF FF FF
FF FF 09 09 FF FF FF FF FF FF FF 09 09 FF FF FF
FF FF FF 09 09 FF FF FF FF FF FF FF 09 09 FF FF
FF FF FF FF 09 09 FF FF FF FF FF FF FF 09 09 FF

13 Constant HANDXSIZE
16 Constant HANDYSIZE
Create HAND
( Created by GP-Forth Sprite Editor )
( Sprite Size : 13 * 16 )
$Sprite
FF FF FF FF FF FF FF FF FF FF FF FF FF
FF FF FF FF 0F FF FF FF FF FF FF FF FF
FF FF FF 0F FF 0F FF FF FF FF FF FF FF
FF FF FF 0F FF 0F FF FF FF FF FF FF FF
FF FF FF 0F FF 0F FF FF FF FF FF FF FF
FF FF FF 0F FF 0F FF FF FF FF FF FF FF
FF FF FF 0F FF 0F 0F FF 0F FF FF FF FF
FF FF FF 0F FF 0F FF 0F FF 0F 0F FF FF
FF FF 0F 0F FF FF FF 0F FF 0F FF 0F FF
FF 0F FF 0F FF FF FF FF FF FF FF 0F FF
FF 0F FF 0F FF FF FF FF FF FF FF 0F FF
FF FF 0F FF FF FF FF FF FF FF FF 0F FF
FF FF FF 0F 0F 0F 0F 0F 0F 0F 0F FF FF
FF FF FF 0F FF FF FF FF FF FF 0F FF FF
FF FF FF 0F 0F 0F 0F 0F 0F 0F 0F FF FF
FF FF FF FF FF FF FF FF FF FF FF FF FF

 9 Constant POINTXSIZE
14 Constant POINTYSIZE
Create POINT
( Created by GP-Forth Sprite Editor )
( Sprite Size : 09 * 14 )
$Sprite
FF FF FF FF FF FF FF FF FF
FF 0F FF FF FF FF FF FF FF
FF 0F 0F FF FF FF FF FF FF
FF 0F 0F 0F FF FF FF FF FF
FF 0F 0F 0F 0F FF FF FF FF
FF 0F 0F 0F 0F 0F FF FF FF
FF 0F 0F 0F 0F 0F 0F FF FF
FF 0F 0F 0F 0F 0F 0F 0F FF
FF 0F 0F 0F 0F FF FF FF FF
FF 0F 0F FF 0F 0F FF FF FF
FF 0F FF FF 0F 0F FF FF FF
FF FF FF FF FF 0F 0F FF FF
FF FF FF FF FF 0F 0F FF FF
FF FF FF FF FF FF FF FF FF

Variable @MSB
: MSBUF @MSB @ ;

20 Constant BOXXSIZE
20 Constant BOXYSIZE
Create BOX

( Created by GP-Forth Sprite Editor )
( Sprite Size : 20 * 20 )
$Sprite
0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F
0F FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 0F
0F FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 0F
0F FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 0F
0F FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 0F
0F FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 0F
0F FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 0F
0F FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 0F
0F FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 0F
0F FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 0F
0F FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 0F
0F FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 0F
0F FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 0F
0F FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 0F
0F FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 0F
0F FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 0F
0F FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 0F
0F FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 0F
0F FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 0F
0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F 0F

29 Constant EXITXSIZE
29 Constant EXITYSIZE
Create EXITSPR
( Created by GP-Forth Sprite Editor )
( Sprite Size : 29 * 29 )
$Sprite
FF FF FF FF FF FF FF FF FF FF FF FF FF FF 00 FF FF FF FF FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF FF FF FF 00 1D 00 FF FF FF FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF FF FF 00 1D 1B 1B 00 FF FF FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF FF 00 1D 1B 1B 19 19 00 FF FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF 00 1D 1B 1B 19 19 18 18 00 FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF 00 00 00 19 19 18 00 00 00 FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF FF FF 00 18 18 18 00 FF FF FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF FF FF 00 18 18 18 00 FF FF FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF FF FF 00 00 00 00 00 FF FF FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
FF FF FF FF 00 00 FF FF FF FF FF FF FF FF 00 FF FF FF FF FF FF FF FF 00 00 FF FF FF FF
FF FF FF 00 1D 00 FF FF FF FF FF FF 00 00 1D 00 00 FF FF FF FF FF FF 00 1D 00 FF FF FF
FF FF 00 1D 1B 00 00 00 00 FF FF 00 1D 1D 1D 1B 19 00 FF FF 00 00 00 00 1D 1B 00 FF FF
FF 00 1D 1B 19 18 18 18 00 FF FF 00 1D 1B 1B 1B 19 00 FF FF 00 1D 1D 1D 1D 1B 19 00 FF
00 1D 1B 19 18 18 18 18 00 FF 00 1D 1D 1B 0E 19 19 18 00 FF 00 1B 1B 1B 1B 19 18 18 00
FF 00 1B 19 18 18 18 18 00 FF FF 00 1B 1B 19 18 18 00 FF FF 00 19 19 19 19 18 18 00 FF
FF FF 00 19 18 00 00 00 00 FF FF 00 19 19 19 18 18 00 FF FF 00 00 00 00 18 18 00 FF FF
FF FF FF 00 18 00 FF FF FF FF FF FF 00 00 18 00 00 FF FF FF FF FF FF 00 18 00 FF FF FF
FF FF FF FF 00 00 FF FF FF FF FF FF FF FF 00 FF FF FF FF FF FF FF FF 00 00 FF FF FF FF
FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF FF FF 00 00 00 00 00 FF FF FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF FF FF 00 1D 1B 19 00 FF FF FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF FF FF 00 1D 1B 19 00 FF FF FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF 00 00 00 1D 1B 19 00 00 00 FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF 00 1D 1D 1D 1B 19 18 18 00 FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF FF 00 1B 1B 1B 19 18 00 FF FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF FF FF 00 1B 19 19 00 FF FF FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF FF FF FF 00 19 00 FF FF FF FF FF FF FF FF FF FF FF FF FF
FF FF FF FF FF FF FF FF FF FF FF FF FF FF 00 FF FF FF FF FF FF FF FF FF FF FF FF FF FF

Create USEDCOLORS 255 c, 0 c, 1 c, 7 c, 8 c, 9 c, 10 c, 12 c, 14 c,
   15 c, 17 c, 18 c, 19 c, 20 c, 21 c, 22 c, 23 c, 24 c, 25 c, 28 c, 32 c,
   26 c, 27 c, 29 c, 30 c,
Here UsedColors - Constant USEDCOUNT

319 Constant GRMAXX
199 Constant GRMAXY
320 Constant 320

19 Constant GRIDCOLOR

Variable CX
Variable CY
Variable SX
Variable SY

Variable CL
Variable X0
Variable Y0
Variable X1
Variable Y1
Variable LX
Variable LY
Variable DX
Variable DY
Variable GX
Variable GY
Variable GC

Variable HANDLE

Variable PEN
Variable MODIFYFLAG

Variable TIMEX
Variable TIMEY

: ?X CX @ SX @ WX @ + + ;
: ?Y SY @ CY @ WY @ + + ;

Variable @FN
: FNAME @FN @ ;

Variable CRFLAG
Variable CRX
Variable CRY
Variable CRPOS
Create CRBUFF 64 Allot CrBuff CodeSegment 64 255 MFill
Variable LASTGR

Variable KEYBUFF
Variable CURWIND

: EXECGR
   CrFlag @
   If
      LastGr @ $ 46c 0 ac@ =
      IfNot
         $ 46c 0 ac@ LastGr !
         CrPos @ 64 * GCursor + CrBuff CodeSegment 0 0
         $Screen CRX @ CRY @ 8 320 8 8 $ExChange255
         CrPos @ 1+ 7 And CrPos !
      Then
   Then
;

Variable COLR
Variable COLG
Variable COLB
Variable COLC

: PROTECTCOLOR ( Color R G B --> )
   ColB ! ColG ! Colr ! ColC !
   ColC @ 2* Here + @
   IfNot Exit Then
   Handle 0!
\   256 1
\   Do
\      i 2* Here + @ Handle @ 2* Here + @ > 0= i ColC @ = 0= And
\      If
\         i Handle !
\      Then
\   Loop

   255 33
   Do
      i 2* Here + @ IfNot i Handle ! Then
   Loop

   Handle @ IfNot Exit Then

   0 UndoBuffer @ 0 0 320 320 200
   ColC @ Handle @ $ChColor
   Handle @ 3 *
   Dup 2+ ColB @ Swap Reserve @ ac!
   Dup 1+ ColG @ Swap Reserve @ ac!
   ColR @ Swap Reserve @ ac!
;

Variable @PROTECT

: PROTECTALL
   @Protect @ IfNot Exit Then
   Here CodeSegment 512 0 MFill
   64000 0
   Do
      i UndoBuffer @ ac@ 2* Here + 1+!
   Loop
   UsedCount 0
   Do
      i UsedColors + c@
      i UsedColors + c@ 3 *    Reserve @ ac@
      i UsedColors + c@ 3 * 1+ Reserve @ ac@
      i UsedColors + c@ 3 * 2+ Reserve @ ac@
      ProtectColor
      i UsedColors + c@ 3 *    StandardPalette + c@
      i UsedColors + c@ 3 *    Reserve @ ac!
      i UsedColors + c@ 3 * 1+ StandardPalette + c@
      i UsedColors + c@ 3 * 1+ Reserve @ ac!
      i UsedColors + c@ 3 * 2+ StandardPalette + c@
      i UsedColors + c@ 3 * 2+ Reserve @ ac!
      $ 7fff
      i UsedColors + c@ 2* Here + !
   Loop
;

: PUTGR ( X Y --> )
   CRY ! CRX !
   CrPos @ 64 * GCursor + CrBuff CodeSegment 0 0
   $Screen CRX @ CRY @ 8 320 8 8 $Put255
   True CrFlag !
   $ 46c 0 ac@ LastGr !
;

: REMOVEGR
   False CrFlag !
   CrBuff CodeSegment 0 0 $Screen CRX @ CRY @ 8 320 8 8 $Copy256
;

: STOREWIN
   DupWinFlag @
   If
      $Screen SX @ 11 + SY @ 45 +
      0 Reserve @ 0 0 320 18 18 18 $Copy256

      $Screen SX @ 11 + SY @ 45 + 320 18 18 12 $Box

      $Screen 320 SX @ CX @ + 11 + SY @ CY @ + 45 + 12 $Put
   Then
;

: RESTOREWIN
   DupWinFlag @
   If
      0 Reserve @ 0 0
      $Screen SX @ 11 + SY @ 45 +
      18 320 18 18 $Copy256
   Then
;

Variable CURSPR
Variable CURDX
Variable CURDY

: ?MIN ( X1 Y1 X2 Y2 --> Flag )
   >r Swap >r MSX @ Rot Rot WithIn r> r> MSY @ Rot Rot WithIn And
;

: PUTMS
   ?M If
      WhereMouseX MSX !
      WhereMouseY MSY !
      CurWind @
      If
         CurWind @ 1-
         If
            CurWind @ 2-
            If
               CurWind @ 1- 2-
               If
               Else
                  \ ************************************** mode #3
                  139 110 172 126 ?Min
                  If
                     Hand HandXSize HandYSize
                  Else
                     Point PointXSize PointYSize
                  Then
               Then
            Else
               \ ***************************************** mode #2
               EmpSpr EmpXSize EmpYSize
            Then
         Else
            \ ******************************************** mode #1
            93 42 222 168 ?Min
            If
               Hand HandXSize HandYSize
            Else
               Point PointXSize PointYSize
            Then
         Then
      Else
         \ *********************************************** mode #0
         10 44 137 171 ?Min
         If
            Box BoxXSize BoxYSize
         Else
            162 45 305 187 ?Min
            If
               Hand HandXSize HandYSize
            Else
               Point PointXSize PointYSize
            Then
         Then
      Then
      CurDY ! CurDX ! CurSpr !
      CurSpr @ MSBuf CodeSegment 0 0
      $Screen MSX @ MSY @
      CurDX @ 320
      CurDX @ CurDY @ $Put255
   Then
;

: REMOVEMS
   ?M If
      MSBuf CodeSegment 0 0 $Screen MSX @ MSY @ CurDX @ 320 CurDX @ CurDY @ $Copy256
   Then
;

: REMOVECURSOR
   $Screen CX @ 8 * 165 + CY @ 8 * 45 + 320 9 9 GridColor $Box
;

: PUTCRS
   $Screen LX @ 8 * 96 + LY @ 8 * 41 + 320 9 9 12 $Box
;

: REMOVECRS
   $Screen LX @ 8 * 96 + LY @ 8 * 41 + 320 9 9 0 $Box
;

: MSWAIT
   ?M If Begin ?LeftButton 0= Until Then
;

: (KEY)
   Key
;

: KEY
   Begin
      KeyBuff @
      If
         KeyBuff @ 0 KeyBuff ! Exit
      Then
      ?M
      If
         WhereMouseX MSX @ = WhereMouseY MSY @ = And
         IfNot
            RemoveMS
            PutMS
         Then
         ?LeftButton
         If
            CurWind @
            If
               CurWind @ 1-
               If
                  CurWind @ 2-
                  If
                     CurWind @ 1- 2-
                     If
                     Else
                        \ mode 3
                        139 110 172 126 ?Min
                        If 27 KeyBuff ! Then
                     Then
                  Else
                     \ mode 2
                  Then
               Else
                  93 42 222 168 ?Min
                  If
                     RemoveMS
                     RemoveCrs
                     MSX @ 93 - u2/ u2/ u2/ LX !
                     MSY @ 42 - u2/ u2/ u2/ LY !
                     PutCrs
                     13 KeyBuff !
                  Else
                     27 KeyBuff !
                  Then
               Then
            Else
               10 44 137 171 ?Min
               If
RemoveMS
 RestoreWin
                  RemoveCursor
                  MSX @ 10 - SX ! MSY @ 44 - SY !
                  8 8 CX ! CY !
                  255 KeyBuff !
 StoreWin
PutMs
               Else
                  162 45 305 187 ?Min
                  If
                     RemoveMS
                     RemoveCursor
                     MSX @ 162 - u2/ u2/ u2/ CX ! MSY @ 45 - u2/ u2/ u2/ CY !
                     254 KeyBuff !
                  Else
                     11 11 42 35 ?Min \ olor set
                     If
                        RemoveMS
                        RemoveCursor
                        253 KeyBuff !
                     Else
                        55 10 Over PenXSize + Over PenYSize + ?Min \ Look/Pen
                        If
                           MsWait
                           9 KeyBuff !
                        Else
                           228 16 Over !XSize + Over !YSize + ?Min \ Save Sprite
                           ModifyFlag @ And
                           If
                              F2 KeyBuff !
                              MsWait
                           Else
                              180 20 188 28 ?Min
                              If
                                 -8 KeyBuff !
                              Else
                                 190 10 198 18 ?Min
                                  If
                                     -9 KeyBuff !
                                  Else
                                     189 19 199 29 ?Min
                                     If
                                        -10 KeyBuff !
                                     Else
                                        200 20 208 28 ?Min
                                        If
                                           -11 KeyBuff !
                                        Else
                                           190 30 198 38 ?Min
                                           If
                                              -12 KeyBuff !
                                           Else
                                           Then
                                        Then
                                     Then
                                  Then
                              Then
                           Then
                        Then
                     Then
                  Then
               Then
            Then
         Then
      Then
      ExecGr
      ?Key
   Until
;

: GEMIT ( Char --> )
   $ 20 - 8 * LatFont8*8 + >r
   $Screen GX @ GY @ 320 r> CodeSegment 1 8 GC @ DX @ $PutChar
   GX @ 8 + GX !
;

: PUTPOINT ( Xr Yr Color --> )
   >r 8 * 46 + >r 8 * 166 + >r
   $Screen r> r> 320 7 7 r> $Fill256
;

: GETPOINT ( Xa Ya --> Color )
   45 + >r 11 + >r
   $Screen 320 r> r> $Get
;

: GPRINT ( String BackColor --> )
   DX !
   Dup 1+ Swap c@ 0
   Do
      Dup i + c@ GEmit
   Loop
   Drop
;

: G. ( N BackColor --> )
   >r
   s>d 3 0Str
   r> GPrint
;

: 2G. ( N BackColor --> )
   >r
   s>d 2 0Str
   r> GPrint
;

: MOVETEXT
   GC ! GY ! GX !
;

Variable MAXLEN
Variable LEN

: >TRANS
   Dup $ ff00 And
   If
      Dup Left = If Exit Then
      Dup Right = If Exit Then
      Drop 0
   Else
      Dup 27 = If Exit Then
      Dup 13 = If Exit Then
      Dup 8 = If Exit Then
      Dup Bl < If Drop 0 Exit Then
      Dup c" a c" z WithIn
      If $ 5f And Then
      Dup $ 126 > If Drop 0 Then
   Then
;

: MAKEASCIIZ
   FName MaxLen @ +
   Begin
      Dup FName =
      If
         0 FName c!
         Exit
      Then
      Dup c@
      Bl =
      If
         Dup 0 Swap c!
      Else
         Exit
      Then
      1-
   Again
;

: ENTERSTRING ( X Y MaxLen Color --> )
   PutMS
   GC !
   MaxLen ! 0 Len ! 2Dup >r >r GC @ MoveText
   FName ASCIIz>
   FName 19 GPrint
   FName >ASCIIz
   r> r> PutGr
   Begin
      DropAll
      CRX @ CRY @ GC @ MoveText
      Key
      >Trans
      Case
         0 Of EndOf
         13 Of
            RemoveGr
            MakeASCIIz
            RemoveMS
            True
            Exit
         EndOf
         27 Of
            RemoveGr
            MakeASCIIz
            RemoveMS
            False
            Exit
         EndOf
         8 Of
            Len @
            If
               Len 1-!
               RemoveGr
               GX @ 8 - GY @ GC @ MoveText
               GX @ GY @ PutGr
            Then
         EndOf
         Left Of
            Len @
            If
               Len 1-!
               RemoveGr
               GX @ 8 - GY @ GC @ MoveText
               GX @ GY @ PutGr
            Then
         EndOf
         Right Of
            Len @ MaxLen @ <
            If
               Len 1+!
               RemoveGr
               GX @ 8 + GY @ GC @ MoveText
               GX @ GY @ PutGr
            Then
         EndOf
            Len @ MaxLen @ =
            If
               Drop
            Else
               >r
               RemoveGr
               r@ FName Len @ + c!
               r> GEmit
               GX @ GY @ PutGr
               Len 1+!
            Then
      EndCase
   Again
;

: PLEASEWAIT
   $Screen 80 80 1000 Reserve @ 0 0 320 160 160 54 $Copy256

   $Screen 80 90 320 160 30 15 $Box
   $Screen 81 91 320 158 28 1 $Fill256

   103 100 14 MoveText
   " PLEASE, WAIT..." 1 GPrint
;

: UNWAIT
   1000 Reserve @ 0 0 $Screen 80 80 160 320 160 54 $Copy256
;

: PUTXY ( --> )
   282 14 15 MoveText
   ?X 23 G.
   282 24 15 MoveText
   ?Y 23 G.
;

: PUTDXDY
   127 14 15 MoveText
   X0 @ X1 @ - Abs 1+ 23 G.
   127 24 15 MoveText
   Y0 @ Y1 @ - Abs 1+ 23 G.
;

: PUTCURSOR
   $Screen CX @ 8 * 165 + CY @ 8 * 45 + 320 9 9 12 $Box
   PutXY
;

: PUTIMAGE
   SX @ 11 + SY @ 45 + 320 * + Out256
   PutXY
   PutCursor
;

: DRAWTITLE ( --> )
   $Screen 2 2 320 316 196 21 $Fill256
   $Screen 0 0 320 320 200 15 $Box
   $Screen 1 Dup 320 318 198 15 $Box
   $Screen 11 45 320 145 145 255 $Fill256
   $Screen 10 44 320 147 147 15 $Box
   $Screen 165 45 320 145 145 GridColor $Fill256
   $Screen 164 44 320 147 147 15 $Box
   $Screen 10 10 320 33 26 15 $Box
   $Screen 10 10 320 18 26 15 $Box
   $Screen 11 11 320 16 24 0 $Fill256
   $Screen 262 10 320 48 26 15 $Box
   $Screen 263 11 320 46 24 23 $Fill256
   $Screen  99 10 320 56 26 15 $Box
   $Screen 100 11 320 54 24 23 $Fill256
   266 14 14 MoveText
   " X=" 23 GPrint
   266 24 14 MoveText
   " Y=" 23 GPrint
   103 14 14 MoveText
   " DX=" 23 GPrint
   103 24 14 MoveText
   " DY=" 23 GPrint
   ?M
   If
      255 MSX ! 255 MSY ! PutMS  5 308 SetXRange 3 187 SetYRange
   Then
   ExitSpr CodeSegment 0 0 $Screen 180 10 ExitXSize 320
   ExitXSize ExitYSize $Copy255
;

: PUTMODIFY
   ModifyFlag @
   If
      !Spr CodeSegment 0 0 $Screen 228 16 !XSize 320 !XSize !YSize $Copy256
   Else
      $Screen 228 16 320 !XSize !YSize 21 $Fill256
   Then
;

: ENTERCOLOR ( --> )
   $Screen 320 ?X WX @ - 11 + ?Y WY @ - 45 + $Get Cl @ =
   IfNot
      True ModifyFlag !
      PutModify
   Then
   $Screen 320 ?X WX @ - 11 + ?Y WY @ - 45 + Cl @ $Put
   CX @ CY @ Cl @ PutPoint
;

: PUTCOLOR
   $Screen 28 11 320 14 24 Cl @ $Fill256
   Cl @ GetPalette >r >r >r
   11 11 12 MoveText
   r> 0 2g.
   11 19 10 MoveText
   r> 0 2g.
   11 27 9 MoveText
   r> 0 2g.
;

: PUTPEN
   Pen @
   If
      PenSpr CodeSegment 0 0 $Screen 58 10 PenXSize 320
      PenXSize PenYSize $Copy256
   Else
      LookSpr CodeSegment 0 0 $Screen 58 10 LookXSize 320
      LookXSize LookYSize $Copy256
   Then
;

: READCOLOR ( --> )
   $Screen 320 ?X WX @ - 11 + ?Y WY @ - 45 + $Get Cl !
   PutColor
;

: ERRWINDOW ( LenStrMessage --> )
   Dup >r
   $Screen 80 80 0 Reserve @ 0 0 320 160 160 54 $Copy256

   $Screen 80 80 320 160 54 15 $Box
   $Screen 81 81 320 158 52 1 $Fill256

   $Screen 143 110 320 34 17 15 $Box
   $Screen 144 111 320 32 15 7 $Fill256
   151 114 14 MoveText
   " OK" 7 GPrint

   r@ c@ 2* 2* 2* 160 Swap - u2/ 80 + 95 11 MoveText
   r> 1 GPrint

   3 CurWind !

   PutMS
   Begin
      Key Dup 27 = Swap 13 = Or
   Until
   RemoveMS

   0 CurWind !
   0 Reserve @ 0 0 $Screen 80 80 160 320 160 54 $Copy256
   ?M
   If
      Begin
         ?LeftButton 0=
      Until
   Then
;

Variable #COLOR1
Variable #COLOR2

: CHOOSECOLOR
   PutCrs
   Begin
      172 30 15 MoveText
      LY @ 16 * LX @ + 21 g.
      Key
      Case
         Alt+F7 Of
            LY @ 16 * LX @ + #Color1 !
         EndOf
         Alt+F8 Of
            LY @ 16 * LX @ + #Color2 !
         EndOf
         13 Of
            LY @ 16 * LX @ + Cl !
            Exit
         EndOf
         27 Of
            Exit
         EndOf
         Up Of
            LY @
            If
               RemoveMS
               RemoveCrs
               LY 1-!
               PutCrs
               PutMS
            Then
         EndOf
         Down Of
            LY @ 15 <
            If
               RemoveMS
               RemoveCrs
               LY 1+!
               PutCrs
               PutMS
            Then
         EndOf
         Left Of
            LX @
            If
               RemoveMS
               RemoveCrs
               LX 1-!
               PutCrs
               PutMS
            Then
         EndOf
         Right Of
            LX @ 15 <
            If
               RemoveMS
               RemoveCrs
               LX 1+!
               PutCrs
               PutMS
            Then
         EndOf
            Drop
      EndCase
   Again
;

: SELECTCOLOR ( --> )
   1 CurWind !
   MsWait
   $Screen 90 25 0 Reserve @ 0 0 320 141 141 151 $Copy256
   $Screen 90 25 320 141 151 28 $Box
   $Screen 91 26 320 139 149 21 $Fill256
   $Screen 96 41 320 129 129 0 $Fill256
   16 0
   Do
      16 0
      Do
         $Screen i 8 * 97 + j 8 * 42 + 320 7 7 j 16 * i + $Fill256
      Loop
   Loop
   124 30 14 MoveText

   " COLOR" 21 GPrint
   Cl @ 16/ LY ! Cl @ 15 And LX !
   PutMS
   ChooseColor
   RemoveMS
   PutColor
   0 Reserve @ 0 0 $Screen 90 25 141 320 141 151 $Copy256
   0 CurWind !
   MsWait
;

: FILLAREA
   WPUT
   0 UndoBuffer @ X0 @ X1 @ UMin Y0 @ Y1 @ UMin 320
   X1 @ X0 @ - Abs 1+ Y1 @ Y0 @ - Abs 1+ CL @ $Fill256
   True ModifyFlag !
   PutModify
   WGET
;

: DRAWRECTANGLE
   WPUT
   0 UndoBuffer @ X0 @ X1 @ UMin Y0 @ Y1 @ UMin 320
   X1 @ X0 @ - Abs 1+ Y1 @ Y0 @ - Abs 1+ CL @ $Box
   True ModifyFlag !
   PutModify
   WGET
;

: DRAWRECTANGLE2
   DrawRectangle
   X0 @ X1 @ < If X0 1+! X1 1-! Else X0 1-! X1 1+! Then
   Y0 @ Y1 @ < If Y0 1+! Y1 1-! Else Y0 1-! Y1 1+! Then
;

: SETDXDY
   X1 @ X0 @ - Abs GrMaxX ?X - UMin 1+ DX !
   Y1 @ Y0 @ - Abs GrMaxY ?Y - UMin 1+ DY !
;

: SETDXDY2
   X1 @ X0 @ - Abs 1+ DX !
   Y1 @ Y0 @ - Abs 1+ DY !
;

: SAVEBL
   SetDXDY

   0 UndoBuffer @ X0 @ X1 @ UMin Y0 @ Y1 @ UMin
   0 Reserve @ 0 0 320 DX @ Dup DY @ $Copy256
;

: SAVEBL2
   SetDXDY2
   0 UndoBuffer @ X0 @ X1 @ UMin Y0 @ Y1 @ UMin
   0 Reserve @ 0 0 320 DX @ Dup DY @ $Copy256
;

: SAVEBL3
   SetDXDY2
   0 UndoBuffer @ X0 @ X1 @ UMin Y0 @ Y1 @ UMin
   4 Reserve @ 0 0 320 DX @ Dup DY @ $Copy256
   DX @ 0 Reserve @ a!
   DY @ 2 Reserve @ a!
;

: COPYAREA
   WPUT
   SaveBl
   0 Reserve @ 0 0 0 UndoBuffer @ ?X ?Y DX @ 320 Over DY @ $Copy256
   True ModifyFlag !
   PutModify
   WGET
;

: XCOPYAREA
   WPUT
   SaveBl
   0 Reserve @ 0 0 0 UndoBuffer @ ?X ?Y DX @ 320 Over DY @ $Copy255
   True ModifyFlag !
   PutModify
   WGET
;

: WSTR ( String --> )
   Handle @ Swap Dup c@ >r 1+ CodeSegment r> FWrite
;

: WNUM ( N --> )
   s>d 2 0Str WStr
;

: WLINE ( AddrOnScreen Length --> )
   Base @ >r Hex
   TimeY ! TimeX !
   Begin
      TimeY @ 0>
   While
      TimeY @ 16 UMin
      TimeY @ Over - TimeY ! 0
      Do
         TimeX @ $ a000 ac@ WNum "  " WStr
         TimeX 1+!
      Loop
      " \r\n" WStr
   Repeat
   r> Base !
;

: SAVEAREA
   " \r\n( Created by GP-Forth Sprite Editor )" WStr
   " \r\n( Sprite Size : " WStr
   X1 @ X0 @ - Abs 1+ WNum
   "  * " WStr
   Y1 @ Y0 @ - Abs 1+ WNum
   "  )\r\n$Sprite\r\n" WStr
   Y1 @ Y0 @ - Abs 1+ 0
   Do
      i 45 + Y0 @ + 320 * X0 @ + 11 + X1 @ X0 @ - Abs 1+ WLine
   Loop
   0 ModifyFlag !
   PutModify
;

" INVALID FILE NAME" String INVALIDFILE
" DISK WRITE ERROR"  String FILEWRITEERR
" FILE NOT FOUND"    String FILENOTFOUND
" INVALID PALETTE"   String INVALIDPALETTE
" INVALID SPRITE"    String INVALIDSPRITE
" DISK FULL"         String DISKFULL
" BLOCK NOT SQUARE"  String BLOCKNOTSQUARE
" NOT ENOUGH MEMORY" String NOROOM
" BAD RLE ENCODING"  String BADRLE
" DRIVER NOT FOUND"  String NODRIVER

: MIRRORAREA
   WPUT
   SaveBl2

   DX @ DY @ =
   IfNot
      BlockNotSquare ErrWindow
      Exit
   Then

   DX @ 0
   Do
      DX @ 0
      Do
          j DX @ * i + Reserve @ ac@

          i Y0 @ Y1 @ Umin + 320 *
          DX @ j - 1- X0 @ X1 @ Umin + +
          UndoBuffer @ ac!
      Loop
   Loop

   True ModifyFlag !
   PutModify
   WGET
;

: SAVEBLOCK
   WPUT
   2 CurWind !
   PutDXDY
   $Screen 16 65 0 Reserve @ 0 0 320 288 288 40 $Copy256
   $Screen 16 65 320 288 40 28 $Box
   $Screen 17 66 320 286 38 21 $Fill256
   76 73 14 MoveText
   " SAVE SPRITE TO A FILE" 21 GPrint
   $Screen 28 85 320 264 16 19 $Fill256
   19 DX !
   32 89 30 15 EnterString >r
   0 Reserve @ 0 0 $Screen 16 65 288 320 288 40 $Copy256
   r>
   If
      FName 0 FCreate
      If
         Handle !
         SaveBl2
         Handle @ DX CodeSegment 2 FWrite 2Drop
         Handle @ DY CodeSegment 2 FWrite 2Drop
         Handle @ 0 Reserve @ DX @ DY @ * FWrite
         If
            DX @ DY @ * =
            IfNot
               FName FDelete Drop
               DiskFull ErrWindow
               0 CurWind !
               Exit
            Then
         Else
            FileWriteErr ErrWindow
         Then
         Handle @ FClose Drop
      Else
         InvalidFile ErrWindow
      Then
   Then
   0 CurWind !
;

: RLEFREE
   RLESeg @ MFree Drop
;

: SAVERLEBLOCK
   WPUT
   4096 Malloc If RLESeg ! Else NoRoom ErrWindow Exit Then
   2 CurWind !
   PutDXDY
   $Screen 16 65 0 Reserve @ 0 0 320 288 288 40 $Copy256
   $Screen 16 65 320 288 40 28 $Box
   $Screen 17 66 320 286 38 21 $Fill256
   56 73 14 MoveText
   " SAVE SPRITE TO [.RLE] FILE" 21 GPrint
   $Screen 28 85 320 264 16 19 $Fill256
   19 DX !
   32 89 30 15 EnterString >r
   0 Reserve @ 0 0 $Screen 16 65 288 320 288 40 $Copy256
   r>
   If
      FName 0 FCreate
      If
         Handle !
         SaveBl3
         Handle @ a" \255;\255;" CodeSegment 2 FWrite 2Drop
         0 Reserve @ 0 RLESeg @ DX @ DY @ * 4 + RLECompress Dup >R Here !
         Handle @ Here CodeSegment 2 FWrite 2Drop
         Handle @ 0 RLESeg @ R@ FWrite
         If
            R> =
            IfNot
               RLEFree
               FName FDelete Drop
               DiskFull ErrWindow
               0 CurWind !
               Exit
            Then
         Else
            FileWriteErr ErrWindow
         Then
         Handle @ FClose Drop
      Else
         InvalidFile ErrWindow
      Then
   Then
   RLEFree
   0 CurWind !
;

: SAVEPALETTE
   2 CurWind !
   PutDXDY
   $Screen 16 65 0 Reserve @ 0 0 320 288 288 40 $Copy256
   $Screen 16 65 320 288 40 28 $Box
   $Screen 17 66 320 286 38 21 $Fill256
   72 73 14 MoveText
   " SAVE PALETTE TO A FILE" 21 GPrint
   $Screen 28 85 320 264 16 19 $Fill256
   19 DX !
   32 89 30 15 EnterString >r
   0 Reserve @ 0 0 $Screen 16 65 288 320 288 40 $Copy256
   r>
   If
      FName 0 FCreate
      If
         Handle !
         PleaseWait
         256 0
         Do
            i GetPalette
            i 3 * 2+ Reserve @ ac!
            i 3 * 1+ Reserve @ ac!
            i 3 *    Reserve @ ac!
         Loop
         Handle @ 0 Reserve @ 768 FWrite
         UnWait
         If
            768 =
            IfNot
               FName FDelete Drop
               DiskFull ErrWindow
               0 CurWind !
               Exit
            Then
         Else
            FileWriteErr ErrWindow
         Then
         Handle @ FClose Drop
      Else
         InvalidFile ErrWindow
      Then
   Then
   0 CurWind !
;

: LOADPL
   2 CurWind !
   PutDXDY
   $Screen 16 65 0 Reserve @ 0 0 320 288 288 40 $Copy256
   $Screen 16 65 320 288 40 28 $Box
   $Screen 17 66 320 286 38 21 $Fill256
   72 73 14 MoveText
   " LOAD PALETTE FROM FILE" 21 GPrint
   $Screen 28 85 320 264 16 19 $Fill256
   19 DX !
   32 89 30 15 EnterString >r
   0 Reserve @ 0 0 $Screen 16 65 288 320 288 40 $Copy256
   r>
   If
      FName 0 FOpen
      If
         Handle !
         PleaseWait
         Handle @ 0 Reserve @ 769 FRead
         If
            768 =
            IfNot
               UnWait
               InvalidPalette ErrWindow
               0 CurWind !
               Exit
            Then
         Else
            UnWait FileWriteErr ErrWindow
         Then
         Handle @ FClose Drop
         ProtectAll
         256 0
         Do
            i
            i 3 *    Reserve @ ac@
            i 3 * 1+ Reserve @ ac@
            i 3 * 2+ Reserve @ ac@
            SetPalette
         Loop
         UnWait
      Else
         FileNotFound ErrWindow
      Then
   Then
   0 CurWind !
;

: LOADPALETTE
   True @Protect !
   LoadPl
;

: LOADPALETTE2
   False @Protect !
   LoadPl
;

: SAVEFORTH
   WPUT
   2 CurWind !
   PutDXDY
   $Screen 16 65 0 Reserve @ 0 0 320 288 288 40 $Copy256
   $Screen 16 65 320 288 40 28 $Box
   $Screen 17 66 320 286 38 21 $Fill256
   52 73 14 MoveText
   " SAVE SPRITE IN FORTH FORMAT" 21 GPrint
   $Screen 28 85 320 264 16 19 $Fill256
   19 DX !
   32 89 30 15 EnterString >r
   0 Reserve @ 0 0 $Screen 16 65 288 320 288 40 $Copy256
   r>
   If
      FName 0 FCreate
      If
         Handle !
         SaveArea
         Handle @ FClose Drop
      Else
         InvalidFile ErrWindow
      Then
   Then
   0 CurWind !
;

: SHOWPIC
   WPUT
   RemoveMS
   $Screen 0 0 0 Reserve @ 0 0 320 320 320 200 $Copy256
   0 UndoBuffer @ 0 0 $Screen 0 0 320 320 320 200 $Copy256
   MsWait
   Begin
      ?Key If True Else False Then
      ?M
      If
         ?LeftButton If Drop True Then
      Then
   Until
   MsWait
   PutMS
   0 Reserve @ 0 0 $Screen 0 0 320 320 320 200 $Copy256
;

: LOADBLOCK
   2 CurWind !
   $Screen 16 65 0 Reserve @ 0 0 320 288 288 40 $Copy256
   $Screen 16 65 320 288 40 28 $Box
   $Screen 17 66 320 286 38 21 $Fill256
   76 73 14 MoveText
   " LOAD SPRITE FROM FILE" 21 GPrint
   $Screen 28 85 320 264 16 19 $Fill256
   19 DX !
   32 89 30 15 EnterString >r
   0 Reserve @ 0 0 $Screen 16 65 288 320 288 40 $Copy256
   r>
   If
      FName 0 FOpen
      If
         Handle !
         Handle @ DX CodeSegment 2 FRead 2Drop
         Handle @ DY CodeSegment 2 FRead 2Drop
         DX @ True =
         If
            4096 Malloc
            If
               RLESeg !
            Else
               NoRoom ErrWindow
               Handle @ FClose Drop
               CurWind 0!
               Exit
            Then
            Handle @ 0 RLESeg @ DY @ 1+ FRead
            If
               DY @ =
               If
                  0 RLESeg @ 0 Reserve @ RLEDecompress
                  0 Reserve @ a@ DX !
                  2 Reserve @ a@ DY !
                  DX @ DY @ * 4 + =
                  IfNot
                     RLEFree
                     BadRLE ErrWindow
                     Handle @ FClose Drop
                     CurWind 0!
                     Exit
                  Then
                  4 Reserve @ 0 Over DX @ DY @ * ACMove
               Else
                  RLEFree
                  InvalidSprite ErrWindow
                  Handle @ FClose Drop
                  CurWind 0!
                  Exit
               Then
            Else
               FileWriteErr ErrWindow
            Then
            RLEFree
         Else
            Handle @ 0 Reserve @ DX @ DY @ * 1+ FRead
            If
               DX @ DY @ * =
               IfNot
                  InvalidSprite ErrWindow
                  0 CurWind !
                  Exit
               Then
            Else
               FileWriteErr ErrWindow
            Then
         Then
         Handle @ FClose Drop

         WPUT

         0 Reserve @ 0 0

         DX @ >r
         DX @ GrMaxX ?X - 1+ UMin DX !
         DY @ GrMaxY ?Y - 1+ UMin DY !

         0 UndoBuffer @ ?X ?Y
         r> 320 DX @ DY @ $Copy256

         WGET

         255 KeyBuff !
      Else
         FileNotFound ErrWindow
      Then
   Then
   0 CurWind !
;

: DRAWLINE
   WPUT
   X0 @ Y0 @ X1 @ Y1 @ CL @ Line
   True ModifyFlag !
   PutModify
   WGET
;

: DRAWCIRCLE
   WPUT
   X0 @ Y0 @ X1 @ X0 @ - Abs Dup M* Y1 @ Y0 @ - Abs Dup M* D+ DSqrt CL @ Circle
   True ModifyFlag !
   PutModify
   WGET
;

: DRAWPAINT
   WPUT
   PleaseWait
   ?X ?Y 2Dup GetPixel CL @ Swap AdjFill
   UnWait
   True ModifyFlag !
   PutModify
   WGET
;

: GP ( rX rY --> Color )
   R> DY !
   j + Swap i + Swap >R >R
   0 Reserve @ 320 R> R> $Get
   DY @ >R
;

: DRAWAVERAGE
   8 Locate
   X0 @ X1 @ Umin 0 L!
   X0 @ X1 @ Umax 4 L!
   Y0 @ Y1 @ Umin 2 L!
   Y0 @ Y1 @ Umax 6 L!

   4 L@ 0 L@ - 2 > 6 L@ 2 L@ - 2 > And
   If
      WPUT
\      PleaseWait

      0 UndoBuffer @ 0 L@ 2 L@ 0 Reserve @ 0 0
      320 320 4 L@ 0 L@ - 1+ 6 L@ 2 L@ - 1+ $Copy256

      6 L@ 2 L@ - 1
      Do
         4 L@ 0 L@ - 1
         Do
            0 0 GP 4 *
            0 1 GP
            1 0 GP
            0 -1 GP
            -1 0 GP
            1 1 GP
            1 -1 GP
            -1 1 GP
            -1 -1 GP
            + + + + + + + + 12 / DX !
            0 UndoBuffer @ 320 0 L@ i + 2 L@ j + DX @ $Put
         Loop
      Loop

\      UnWait
      True ModifyFlag !
      PutModify
      WGET
   Then
   UnLocate
;

: ?1-
   Dup
   If
      1-
   Then
;

: ?1+ ( A --> B )
   Dup 63 <
   If
      1+
   Then
;

Variable RTL

: SHADEPALETTE ( --> )
   #Color1 @ #Color2 @ - Abs 2 < If Exit Then
   #Color1 @ #Color2 @ > If #Color1 #Color2 ExChange Then

   a" vpalette.rtl" RTL InstallRTL
   If
      PleaseWait
      #Color1 @
      256 0
      Do
         i GetPalette
         i 3 * 2+ StandardPalette + c!
         i 3 * 1+ StandardPalette + c!
         i 3 *    StandardPalette + c!
      Loop
      StandardPalette #Color1 @ 3 * + CodeSegment
      #Color2 @ #Color1 @ - 1+
      #Color1 @ GetPalette
      #Color2 @ GetPalette
      RTL @ 10 ExecRTL
      RTL @ CloseRTL
      SetAllPalette
      UnWait
   Else
      NoDriver ErrWindow
      CurWind 0!
   Then
;

: EDIT ( --> )
   PutPen
   PutModify
   PutColor
   PutDXDY
   255 KeyBuff !
   Begin
      PEN @ If RemoveMS EnterColor PutMS Then

      162 45 305 187 ?Min IfNot RemoveMS Then
      StoreWin
      162 45 305 187 ?Min IfNot PutMS Then

      Key

      162 45 305 187 ?Min IfNot RemoveMS Then
      RestoreWin
      162 45 305 187 ?Min IfNot PutMS Then

      Case
         -8 Of
            WX @
            If
               RemoveMS
               WPUT
               WX @ 5 - WX !
               WGET
               PutImage
               PutMS
            Then
         EndOf
         -9 Of
            WY @
            If
               RemoveMS
               WPUT
               WY @ 5 - WY !
               WGET
               PutImage
               PutMS
            Then
         EndOf
         -10 Of
            Alt+S KeyBuff !
         EndOf
         -11 Of
            WX @ 175 <
            If
               RemoveMS
               WPUT
               WX @ 5 + WX !
               WGET
               PutImage
               PutMS
            Then
         EndOf
         -12 Of
            WY @ 55 <
            If
               RemoveMS
               WPUT
               WY @ 5 + WY !
               WGET
               PutImage
               PutMS
            Then
         EndOf
         253 Of
            RemoveMS
            SelectColor
            PutCursor
            PutMS
         EndOf
         255 Of
            RemoveMS
            PutImage
            PutCursor
            PutMS
         EndOf
         254 Of
            PutCursor
            EnterColor
            PutMS
         EndOf
         Up Of
            RemoveMS
            CY @
            If
               RemoveMS
               RemoveCursor
               CY 1-!
               PutCursor
            Else
               SY @
               If
                  SY 1-!
                  PutImage
               Else
                  WY @
                  If
                     WPUT
                     WY @ 5 - WY !
                     WGET
                     PutImage
                  Then
               Then
            Then
            PutMs
         EndOf
         Down Of
            RemoveMS
            CY @ 17 <
            If
               RemoveCursor
               CY 1+!
               PutCursor
            Else
               SY @ 127 <
               If
                  SY 1+!
                  PutImage
               Else
                  WY @ 55 <
                  If
                     WPUT
                     WY @ 5 + WY !
                     WGET
                     PutImage
                  Then
               Then
            Then
            PutMs
         EndOf
         Left Of
            RemoveMS
            CX @
            If
               RemoveCursor
               CX 1-!
               PutCursor
            Else
               SX @
               If
                  SX 1-!
                  PutImage
               Else
                  WX @
                  If
                     WPUT
                     WX @ 5 - WX !
                     WGET
                     PutImage
                  Then
               Then
            Then
            PutMS
         EndOf
         Right Of
            RemoveMS
            CX @ 17 <
            If
               RemoveCursor
               CX 1+!
               PutCursor
            Else
               SX @ 127 <
               If
                  SX 1+!
                  PutImage
               Else
                  WX @ 175 <
                  If
                     WPUT
                     WX @ 5 + WX !
                     WGET
                     PutImage
                  Then
               Then
            Then
            PutMS
         EndOf
         Bl Of
            RemoveMS
            EnterColor
            PutMS
         EndOf
         13 Of
            RemoveMS
            RemoveCursor
            SelectColor
            PutCursor
            PutMS
         EndOf
         27 Of
            RemoveMS
            255 Cl !
            PutColor
            PutMS
         EndOf
         10 Of
            RemoveMS
            ReadColor
            PutMS
         EndOf
         9 Of
            RemoveMS
            PEN @ 0= PEN !
            PEN @ If EnterColor Then
            PutPen
            PutMS
         EndOf
         F5 Of \ Copy Block
            RemoveMS
            CopyArea
            PutImage
            PutMS
         EndOf
         Ctrl+F5 Of \ Copy Block ( 255 colors )
            RemoveMS
            XCopyArea
            PutImage
            PutMS
         EndOf
         Alt+M Of \ Copy Block with FLIP
            RemoveMS
            MirrorArea
            PutImage
            PutMS
         EndOf
         Alt+S Of
            RemoveMS
            ShowPic
            PutMs
         EndOf
         F7 Of \ Begin Of Block
            RemoveMS
            ?X X0 ! ?Y Y0 !
            PutDXDY
            PutMS
         EndOf
         Ctrl+F7 Of
            RemoveMS
            0 X0 ! 0 Y0 !
            PutDXDY
            PutMS
         EndOf
         Ctrl+F8 Of
            RemoveMS
            GrMaxX X1 ! GrMaxY Y1 !
            PutDXDY
            PutMS
         EndOf
         F8 Of \ End Of Block
            RemoveMS
            ?X X1 ! ?Y Y1 !
            PutDXDY
            PutMS
         EndOf
         F9 Of \ Block Fill
            RemoveMS
            FillArea
            PutImage
            PutMS
         EndOf
         Ctrl+F9 Of \ Rectangle
            RemoveMS
            DrawRectangle
            PutImage
            PutMS
         EndOf
         Alt+F9 Of \ Rectangle
            RemoveMS
            DrawRectangle2
            PutDXDY
            PutImage
            PutMS
         EndOf
         F10 Of \ Quit
            Exit
         EndOf
         c" + Of
            RemoveMS
            Cl @ 1+ 255 And Cl !
            PutColor
            PutMS
         EndOf
         c" - Of
            RemoveMS
            Cl @ 1- 255 And Cl !
            PutColor
            PutMS
         EndOf
         Ctrl+F2 Of
            RemoveMS
            SaveForth
            PutMS
         EndOf
         F2 Of
            RemoveMS
            SaveBlock
            PutMS
         EndOf
         Shift+F2 Of
            RemoveMS
            SaveRLEBlock
            PutMS
         EndOf
         F3 Of
            RemoveMS
            LoadBlock
            PutMS
         EndOf
         F4 Of
            RemoveMS
            DrawLine
            PutImage
            PutMS
         EndOf
         Alt+L Of
            RemoveMS
            DrawLine
            PutImage
            PutMS
         EndOf
         Alt+C Of
            RemoveMS
            DrawCircle
            PutImage
            PutMS
         EndOf
         Alt+W Of
            RemoveMS
            SavePalette
            PutMS
         EndOf
         Alt+R Of
            RemoveMS
            LoadPalette
            PutMS
         EndOf
         Alt+P Of
            RemoveMS
            LoadPalette2
            PutMS
         EndOf
         c" 1 Of
            Cl @ GetPalette >r >r ?1- >r Cl @ r> r> r> SetPalette PutColor
         EndOf
         c" 2 Of
            Cl @ GetPalette >r ?1- >r >r Cl @ r> r> r> SetPalette PutColor
         EndOf
         c" 3 Of
            Cl @ GetPalette ?1- >r >r >r Cl @ r> r> r> SetPalette PutColor
         EndOf
         c" 4 Of
            Cl @ GetPalette >r >r ?1+ >r Cl @ r> r> r> SetPalette PutColor
         EndOf
         c" 5 Of
            Cl @ GetPalette >r ?1+ >r >r Cl @ r> r> r> SetPalette PutColor
         EndOf
         c" 6 Of
            Cl @ GetPalette ?1+ >r >r >r Cl @ r> r> r> SetPalette PutColor
         EndOf
         Shift+Tab Of
            DupWinFlag @ 0= DupWinFlag !
         EndOf
         Alt+F Of \ Paint
            RemoveMS
            DrawPaint
            PutImage
            PutMS
         EndOf
         Alt+Y Of \ ""
            RemoveMS
            DrawAverage
            PutImage
            PutMS
         EndOf
         Alt+F7 Of
            Cl @ #Color1 !
         EndOf
         Alt+F8 Of
            Cl @ #Color2 !
         EndOf
         Alt+H Of
            RemoveMS
            ShadePalette
            PutMS
         EndOf
            Drop
      EndCase
   Again
;

Registers REGS

: ?VGA ( --> Flag )
   $ 1a00 Regs !
   $ 10 Regs Intr
   Regs c@ $ 1a = Regs BX c@ 7 = Regs BX c@ 8 = Or And
;

: MAIN ( --> )
   ." \r\n   GP-Forth 256-colors Sprite Editor. Version "
   $ 103 c@ . c" . Emit $ 104 c@ . ." \r\n"
   ." Copyright (C), 1992 by The Golden Porcupine Software\r\n"
   ."                 * * * * * * * * * *\r\n\r\n"
   ?VGA
   IfNot
      ." \r\nSorry, Video Graphics Array not detected\r\n"
      Bye
   Then
   16 #Color1 ! 31 #Color2 !
   0 0 79 24 MakeWindow
   Here @MSB !
   410 Allot
   True DupWinFlag !
   ?Mouse @Mou !
   Here @FN !
   50 Allot
   FName CodeSegment 50 0 MFill
   Bl FName c!
   4096 Malloc
   If
      UndoBuffer !
      4096 Malloc
      If
         Reserve !
         0 CurWind !
         2 UndoBuffer @ 65534 255 MFill
         $ ffff 0 UndoBuffer @ a!
         Graph320*200*256 SetVideoMode
         0 SX ! 0 CX ! 0 SY ! 0 CY ! 9 CL !
         WX 0! WY 0!
         False PEN ! False ModifyFlag !
         DrawTitle
         255 0 0 0 SetPalette
         SetAllPalette
         Edit
         Text80*25 SetVideoMode
         Reserve @ MFree Drop
      Then
      UndoBuffer @ MFree Drop
      RemoveWindow
   Else
      ." Not enough memory\r\n"
   Then
;

False Messages !
' BYE ErrorProc !
True Debug !

Build 256.com 256.map
