
use dos.frl
use crt.frl
use edit.frl
use music.frl
use kbdcodes.frl

Variable USERSCREEN
Variable USERSTATE
Variable ONLINE
Variable VRAM2
Variable EXITFLAG

Variable SPEED
Variable TEXTSEG
Variable OPERSEG
Variable UPPNT
Variable DOWNPNT
Variable STRUP
Variable STRDOWN
Variable INSFLAG
Variable INDENTFLAG
Variable SX
Variable X
Variable Y
Variable STARTBLOCK
Variable ENDBLOCK
Variable CHANGEFLAG
Variable TABSPACE
Variable COMPFLAG
Variable LOADFLAG

Variable LOCFLAG

Variable LASTSECONDS

Variable HANDLE

Variable KEYTIME

Variable BLOCKFLAG
Variable STB
Variable ENB

Registers REGS

Create FINDBUFFER 44 Allot

Variable ADDR
Variable ADDR2
Variable ADDR3

" COMSPEC=" ASCIIz COMSPEC

Create SHELL 80 Allot Shell CodeSegment 80 0 MFill
128 Constant COMMANDLINE

: COMPARE2 ( Off1 Seg1 Off2 Seg2 Count --> EqualFlag )
   0 Do
      2Over Swap i + Swap
      2Over Swap i + Swap ac@
      Rot Rot ac@ =
      IfNot
         r> r> r> 2Drop 2Drop 2Drop Drop False Exit
      Then
   Loop
   2Drop 2Drop
   True
;

: SEARCH4COMMAND
   $ 2c @ Addr !
   0 Addr2 !
   Begin
      Addr2 @ Addr @ a@
   While
      Addr2 @ Addr @ ComSpec CodeSegment ComSpec ASCIIzLen Compare2
      If
         ComSpec ASCIIzLen Addr2 @ + Addr2 !
         Shell Addr3 !
         Begin
            Addr2 @ Addr @ ac@ Dup
         While
            Addr3 @ c!
            Addr2 1+!
            Addr3 1+!
         Repeat
         Drop
         Exit
      Else
         Begin
            Addr2 1+!
            Addr2 @ Addr @ ac@ 0=
         Until
         Addr2 @ Addr @ a@ If Addr2 1+! Then
      Then
   Repeat
;

: ENTERDOSCOMMAND ( ASCIIzCommand --> )
   >r
   [ c" c 256 * c" / + ] Literal CommandLine !
   0 CommandLine 2+ c!
   CommandLine r> CommandLine Concat*
   CommandLine ASCIIz>
   7 0 Color
   0 24 GotoXY
   Shell CommandLine 0 Exec Drop
   0 0 79 24 SetWindow
;

" \\" Asciiz ROOTDIR

" noname.txt" Asciiz STRINGBUFFER 70 Allot

: CONSTANT
   Create , Does> @
;

c" H 256 * Constant UP
c" P 256 * Constant DOWN
c" K 256 * Constant LEFT
c" M 256 * Constant RIGHT
c" S 256 * Constant DELETE
c" R 256 * Constant INSKEY
c" G 256 * Constant HOMEKEY
c" O 256 * Constant ENDKEY
c" I 256 * Constant PAGEUP
c" Q 256 * Constant PAGEDOWN

: GOTOXY
   GetWindow 2Drop d+ GotoXY
;

: BEEP
   a" *o\4;t\1;cpbpdpapepgpfpepgpfff" Play
;

: CHVRAM
   Vram Vram2 ExChange
;

: MAKECOPY
   $ 46c 0 ac@
   Begin
      Dup $ 46c 0 ac@ = Not
   Until
   Drop
   False Vram @ False Vram2 @ 4000 ACMove
;

Variable $$$
: SETXSX
   Dup $$$ ! 77 >
   If
      $$$ @ 77 - Dup SX ! $$$ @ Swap - X !
      Begin
         SX @ 176 >
      While
         SX 1-!
         77 X !
      Repeat
   Else
      SX 0!
      $$$ @ X !
   Then
;

: .W ( Sets a White on Black )
   15 False Color
;

: .G ( Sets a Gray on Black )
   7 False Color
;

: OUTKEYS
    PushState
    False False 79 24 SetWindow
   .W ." \eg\2;\23;   F1-" .G ." Help   "
   .W ." F2-" .G ." Save   "
   .W ." F3-" .G ." Load   "
   .W ." F5-" .G ." UserScreen   "
   .W ." F9-" .G ." DOSCommand   "
   .W ." F10-" .G ." Quit"
   PopState
;

: OUTTIME
   $ 2c Regs AX >High c!
   Regs FDOS
   Regs DX >High c@ Dup LastSeconds @ =
   If
      Drop
   Else
      LastSeconds !
      PushState
      False False 79 29 SetWindow
      CursorOff
      ." \ea\3;\eg\65;\2;"
      Regs CX >High c@ 12 Mod
      False Over =
      If Drop 12 Then
      2 .r
      c" : Emit
      Regs CX c@ 2 0.
      c" : Emit
      Regs DX >High c@ 2 0.
      Regs CX >High c@ 11 >
      If
         ." pm"
      Else
         ." am"
      Then
      PopState
   Then
;

: OUTFILE
   PushState
   False False 79 24 SetWindow
   3 False Color
   48 2 GotoXY
   StringBuffer
   Begin
      Dup c@
   While
      1+
   Repeat
   Begin
      Dup c@ Dup c" : = Swap c" \ = Or Over StringBuffer = Or 0=
   While
      1-
   Repeat
   StringBuffer 14 + 0!
   .ASCIIz ."             "
   100 LastSeconds ! OutTime
   PopState
;

: PUTMESSAGE ( MessageString --> )
   1 2 78 2 MakeWindow 15 False Color
   ClearWindow 12 Emit
   39 Over c@ u2/ - Spaces Print
;

: CLEARSTRING ( Line# --> )
   256 * OperSeg @ 256 Bl MFill
;

: ?KEY ( --> Key True )
       ( --> False )
   $ 100 Regs !
   $ 16 Regs Intr
   Regs Flags @ 64 And
   If
      False
   Else
      Key
      True
   Then
;

: GETKEY
   Begin
      OutTime
      ?Key
   Until
;

: ERROR ( Message --> )
   PushState
   CursorOff
   Dup c@ 6 + >r 1 21 r> 23 MakeWindow
   8 12 4 StdBorder
   14 4 Color
   ClearWindow
   ." \12;  "
   Print
   Beep
   Begin
      GetKey 27 =
   Until
   RemoveWindow
   PopState
;

Variable INS2
Variable INTX
Variable MAX2

: TIT1
   Max2 ! IntX !
   Max2 @ Dup 28 + Swap
   Do
      IntX @ Dup 80 + Swap
      Do
         i j GetChar
         Vram Vram2 Exchange
         i j PutChar
         Vram Vram2 Exchange
      4 +Loop
   4 +Loop
;

: TIT2
   0 0 Tit1
   2 2 Tit1
   2 0 Tit1
   0 2 Tit1
   1 1 Tit1
   3 3 Tit1
   3 1 Tit1
   1 3 Tit1
   1 0 Tit1
   3 2 Tit1
   3 0 Tit1
   1 2 Tit1
   0 1 Tit1
   2 3 Tit1
   0 3 Tit1
   2 1 Tit1
;

Create FILESTRUCT
0 , 75 , 12 c, 6 c, 73 c, 48 c, 0 c, 255 c, 0 , 0 c, 2 c, 13 , 27 ,

: GETFILE
   MakeCopy
   False 7 Color
   2 9 77 14 MakeWindow
   PushState
   ChVram
   False False 7 StdBorder
   1 False 7 StdBorder
   ClearWindow Space Space Print
   5 12 74 12 SetWindow
   False 3 Color ClearWindow
   StringBuffer FileStruct !
   ['] GETKEY FileStruct 10 + !
   Tit2
   ChVram
   FileStruct EditString
   PopState
   FileStruct 12 + c@ 0= OnLine !
;

: *>UP
   OperSeg @ UpPnt @  TextSeg @
   False OperSeg @ ?Len >Up UpPnt !
   StrUp 1+!
;

: *>DOWN
   OperSeg @ DownPnt @  TextSeg @
   [ 256 17 * ] Literal OperSeg @ ?Len >Down DownPnt !
   StrDown 1+!
;

: *UP>
   StrUp @ If OperSeg @ UpPnt @ TextSeg @ Up> UpPnt !
   StrUp 1-! Then
;

: *DOWN>
   StrDown @ If OperSeg @ DownPnt @ TextSeg @ Down> DownPnt !
   Strdown 1-! Then
;

: *OPERUP
   Y @ 17 < If Y @ Else False Then Operseg @ OperUp
;

: *OPERDOWN
   Y @ OperSeg @ OperDown
;

: SAVEUSER
   PushState
   SSP @ UserState !
   PushState PushState PushState PushState
   False False 79 24 PushWindow
   SSP @ UserScreen !
;

: CLEAROPER
   False OperSeg @ [ 256 18 * ] Literal Bl MFill
;

: OUTINSERT
   PushState
   CurSorOff
   InsFlag @
   If
      ." \ea\3;\eg\26;\2; Insert  "
   Else
      ." \ea\3;\eg\26;\2;Overwrite"
   Then
   PopState
;

: OUTINDENT
   PushState
   CurSorOff
   IndentFlag @ InsFlag @ And
   If
      ." \ea\3;\eg\39;\2;Indent"
   Else
      ." \ea\3;\eg\39;\2;      "
   Then
   PopState
;

: OUTXY
   PushState
   CurSorOff
   ." \ea\3;\eg\7;\2;"
   Y @ 1+ StrUp @ + . ."     "
   ." \eg\20;\2;"
   X @ SX @ + 1+ . ."   "
   PopState
;

: RESTOREUSER
   ChVram
   UserScreen @ SSP !
   False False PopWindow
   Tit2
   ChVram
   UserState @ SSP !
   PopState
;

: TITLE
   CursorOff
   SaveUser
   Vram Vram2 Exchange
   False False 79 24 SetWindow
   3 False Color
   ClearWindow
   False 1 79 24 SetWindow
   3 14 False StdBorder
   False 3 79 22 SetWindow
   3 14 False StdBorder
   10 9 69 15 MakeWindow
   1 15 3 StdBorder
   " \7; \7;  \7; \7;" False 3 MakeBorder
   14 3 Color
   ClearWindow
   ." \12;      Text Corrector    Version 1.0   20-June-1991"
   ." \r\n  Copyright (C), 1991 by the Golden Porcupine Software"
   ." \r\n                   * * * * * * * * * *"
   False False 79 24 SetWindow
   OutKeys
   ." \eg\2;\2;\ea\3;Line 1        Col 1     "
   OutIndent
   OutInsert
   OutXY
   OutFile
   3 False Color
   Tit2
   RemoveWindow
   Vram Vram2 Exchange
   GetKey Drop
   Vram Vram2 Exchange
   False False 79 False SetWindow
   ." \ea\15;\12;   Text Corrector v1.0  Copyright (C), 1991 by The Golden Porcupine Software"
   Tit2
   Vram Vram2 Exchange
;

: LOCATE
   LocFlag @
   If
      False OperSeg @ SX @ False 256 1 4 78 18 2 ShowText
   Then
;

: GETINDENT
   X @
   If
      False OnLine !
      Begin
         OnLine @ 256 = If False OnLine ! Exit Then
         Y @ 256 * OnLine @ + OperSeg @ ac@ Bl =
         IfNot Exit Then OnLine 1+!
      Again
   Else
      False OnLine !
   Then
;

: ENTER
   True ChangeFlag !
   InsFlag @
   If
      IndentFlag @ If GetIndent Else False OnLine ! Then
      Y @ 17 <
      If
         Y 1+!
         *>Down
         *OperDown
      Else
         *>Up
         *OperUp
         Y @ ClearString
      Then
      Y @ 1- 256 * X @ + SX @ +
      OperSeg @ Y @ 256 * OnLine @ +
      Over
      256 X @ - 256 OnLine @ - UMin
      ACMove
      Y @ 1- 256 * X @ + SX @ +
      OperSeg @
      256 X @ - SX @ -
      Bl
      MFill
      OnLine @ SetXSX
   Else
      Y @ 17 <
      If
         X 0!
         SX 0!
         Y 1+!
      Else
         *>Up
         *OperUp
         StrDown @ If *Down> Else 17 ClearString Then
         X 0! SX 0!
      Then
   Then
   Locate
;

: ONUP
            Y @
            If
               ." \ehu"
               Y 1-!
            Else
               StrUp @
               If
                  *>Down
                  *OperDown
                  *Up>
                  Locate
               Then
            Then
;

: ONDOWN
            Y @ 17 <
            If
               ." \ehd"
               Y 1+!
            Else
               StrDown @
               If
                  *>Up
                  *OperUp
                  *Down>
                  Locate
               Then
            Then
;

: ONLEFT
            X @
            If
               ." \ehl"
               X 1-!
            Else
               SX @
               If
                  SX 1-!
                  Locate
               Then
            Then
;

: ONRIGHT
            X @ 77 <
            If
               ." \ehr"
               X 1+!
            Else
               SX @ 176 <
               If
                  SX 1+!
                  Locate
               Then
            Then
;

: DELSTRING
   True ChangeFlag !
   Y @ 17 < If *OperUp Then
   StrDown @
   If
      *Down>
   Else
      Y @ >r
      Y 0!
      StrUp @
      If
         *OperDown
         *Up>
      Else
         17 ClearString
      Then
      r> Y !
   Then
   X 0!
   Locate
;

: DEL
   Y @ 256 * OperSeg @ ?Len X @ SX @ + > 0=
   If
      Y @ 17 =
      If
         StrDown @
         If
            OnDown
            OnUp
         Else
            Exit
         Then
      Then
      Y @ 1+ 256 * OperSeg @ Y @ 256 * X @ SX @ + + 1+ Over 256
      Y @ 256 * OperSeg @ ?Len - ACMove
      OnDown
      X @ >r SX @ >r
      DelString
      r> SX ! r> X !
      OnUp
   Else
      Y @ 256 * SX @ + X @ + 1+ OperSeg @ Over 1- Over 255 X @ - ACMove
      Bl Y @ 1+ 256 * 1- OperSeg @ ac!
   Then
   Locate
   True ChangeFlag !
;

: BACK
   X @
   If
      X 1-!
      Del
   Else
      SX @
      If
         SX 1-!
         Del
         Locate
      Then
   Then
;

: INSERT
   InsFlag @ 0= InsFlag !
   OutInsert
;

: INDENT
   IndentFlag @ 0= IndentFlag !
   OutIndent
;

: NEWPOS ( --> Flag )
   Locate
   10 Speed @ Abs - 1500 * False Do Loop
   Speed @ 0<
   If
      17 Y !
      X 0!
      OnDown
   Else
      Speed @ 0>
      If
         Y 0!
         X 0!
         OnUp
      Then
   Then
   ?Key
   Dup If Drop Key Then
   Case
      Up Of
         Speed 1+!
         True
      EndOf
      Down Of
         Speed 1-!
         True
      EndOf
      27 Of
         False
      EndOf
      13 Of
         False
     EndOf
         Drop
         True
   EndCase
   Speed @ 0<
   If
      Speed @ -9 < If -9 Speed ! Then
   Else
      Speed @ 9 > If 9 Speed ! Then
   Then
   StrUp @ 0= 0= StrDown @ 0= 0= And IfNot Speed @ Negate Speed ! Then
;

: >BEGINNING
            False LocFlag !
            Begin
               StrUp @
            While
               OnUp
            Repeat
            True LocFlag !
            Y 0! X 0!
;

: FTEXT
            " Formating text... Please, wait..."
            PushState CursorOff
            PutMessage
            >Beginning
            18 False
            Do
               *>Down
               *OperDown
            Loop
            RemoveWindow
            PopState
;

: ?OVERWRITE
   ChangeFlag @
   If
      13 10 66 16 MakeWindow
      CursorOff
      8 12 4 StdBorder
      15 4 Color
      ClearWindow
      a" This file already exists" 13 66 12 Center
      a" Do you wish to write over the old file ?" 13 66 13 Center
      14 4 Color
      a" ^Overwrite^  ^Enter^new^name^" ['] GetKey $ 70 13 66 14 HMenu
      RemoveWindow
      If
         Case
            0 Of
               True
            EndOf
            1 Of
               False
            EndOf
               Drop False
         EndCase
      Else
         False
      Then
   Then
;

: SAVE
   " Enter file name to save editor text to :"
   GetFile
   OnLine @
   If
      StringBuffer 32 Here FindFirst
      If
         ?OverWrite
         IfNot
            RemoveWindow
            Recurse Exit
         Then
      Then
      OutFile
      StringBuffer False FCreate
      IfNot
         " Invalid file name or Path not found. Press ESC" Error
         RemoveWindow OnLine 0!
         Recurse
         Exit
      Then
      Handle !
      PushState CursorOff
      FText
      " Saving editor file..." PutMessage
      TextSeg @ DownPnt @ UnFormat
      >r Handle @ False TextSeg @ r@ FWrite
      False ChangeFlag !
      IfNot
      " Disk write error. Press ESC" Error
      Drop r@
      True ChangeFlag !
      Then
      r@ =
      IfNot
         " Disk full. Press ESC" Error
         True ChangeFlag !
      Then
      Handle @ FClose Drop
      TextSeg @ r> Format StrDown ! DownPnt !
      18 False
      Do
         *OperUp
         *Down>
      Loop
      RemoveWindow
      PopState
      Locate
      ChangeFlag 0!
   Else
      RemoveWindow
   Then
;

: ?SAVE
   ChangeFlag @
   If
      13 10 66 15 MakeWindow
      CursorOff
      8 12 4 StdBorder
      15 4 Color
      ClearWindow
      a" You've made changes since the last save" 13 66 12 Center
      14 4 Color
      a" ^Save^   ^Don't^save^  ^Continue^editing^" ['] GetKey $ 70 13 66 13 HMenu
      RemoveWindow
      If
         Case
            0 Of
               Save
               True
            EndOf
            1 Of
               True
            EndOf
            2 Of
               False
            EndOf
               Drop False
         EndCase
      Else
         False
      Then
   Then
   ExitFlag !
;

: LOAD
   ?Save
   ExitFlag @
   IfNot
      Exit
   Then
   " Enter file name to load to editor buffer :"
   GetFile
   OnLine @
   If
      StringBuffer False FOpen
      If
         Handle !
         OutFile
         X 0! Y 0!
         RemoveWindow
         PushState CursorOff
         " Loading editor file..." PutMessage
         Handle @ False TextSeg @ 65535 FRead
         IfNot
            " Disk read error. Press ESC" Error
            Handle @ FClose Drop
            Exit
         Then
         Dup
         65535 =
         If
            " File is larger than 64 Kb. Loading aborted. Press ESC" Error
            Handle @ FClose Drop
            Exit
         Then
         OnLine !
         Handle @ FClose Drop
         TextSeg @ OnLine @ Format StrDown ! DownPnt !
         False StrUp ! False UpPnt !
         ClearOper
         18 False
         Do
            *OperUp
            StrDown @ If *Down> Else 17 ClearString Then
         Loop
         X 0! SX 0!
         RemoveWindow
         PopState
         Locate
         False ChangeFlag !
      Else
         " File not found in current directory. Press ESC" Error
         RemoveWindow OnLine 0!
         Recurse
      Then
   Else
      RemoveWindow
   Then
;

: .B
   11 False Color
;

: .D
   3 False Color
;

: EDITHELP
   PushState
   CursorOff
   MakeCopy
   ChVram
   10 8 69 18 MakeWindow
   4 15 False StdBorder
   3 False Color
   ClearWindow
   21 False GotoXY
   .B ." Editor Help\r\n\r\n"
      ." Cursor Moverment :         Delete :\r\n"
   .B ."   '\24;'      " .D ." - Line Up" .B ."          <Del>  " .D ." - Char under cursor\r\n"
   .B ."   '\25;'      " .D ." - Line Down" .B ."        <BS>   " .D ." - Char left\r\n"
   .B ."   '\26;'      " .D ." - Char Right" .B ."       Alt+K or\r\n"
   .B ."   '\ef\27;'      " .D ." - Char Left" .B ."        Ctrl+Y" .D ."  - Line under cursor\r\n"
   .B ."   <End>       " .D ." - To end of line\r\n"
   .B ."   <Home>      " .D ." - To start of line"
   Tit2
   ChVram
   GetKey Drop
   ChVram
   ClearWindow
   21 0 GotoXY
   .B ." Editor Help\r\n\r\n                  Other functions :\r\n"
   .B ."       Ctrl+Enter" .D ."  - Quick view mode\r\n"
   .B ."       Ctrl+PgUp " .D ."  - Scrolling to file beginning\r\n"
   .B ."       Ctrl+PgDn " .D ."  - Scrolling to file end\r\n"
   .B ."       Ctrl+Home " .D ."  - Moving to file beginning\r\n"
   .B ."       Ctrl+End  " .D ."  - Moving to file end"
   Tit2
   ChVram
   GetKey Drop
   ChVram
   RemoveWindow
   Tit2
   ChVram
   PopState
;

: DOSSHELL
   0 24 GotoXY
   14 0 Color
   ." \r\nType EXIT to return Text Corrector\r\n"
   7 0 Color Cr
   Shell NullString 0 Exec Drop
   (InitCrt)
;

: SHELL
   SSP @ >r
   UserScreen @ SSP !
   MakeCopy
   ChVram
   False False ExchangeWindow
   Tit2
   ChVram
   UserState @ SSP !
   PopState

\   a" \\command.com" " "
\   False Exec
   DOSShell

   True
   PushState
   SSP @ UserState !
   UserScreen @ SSP !
   ChVram
   False False ExchangeWindow
   Tit2
   ChVram
   r> SSP !
;

: USERSCREEN
   SSP @ >r
   UserScreen @ SSP !
   MakeCopy
   ChVram
   False False ExchangeWindow
   Tit2
   ChVram
   UserState @ SSP !
   PopState
   Key Drop
   PushState
   SSP @ UserState !
   UserScreen @ SSP !
   ChVram
   False False ExchangeWindow
   Tit2
   ChVram
   r> SSP !
;

: BLOCKMENU ( --> )
   1 23 78 23 MakeWindow
   15 0 Color ClearWindow
   CursorOff
   .W ."  B-" .G ." Start "
   .W ." K-" .G ." End "
   .W ." H-" .G ." Hide "
   .W ." R-" .G ." Read "
   .W ." W-" .G ." Write "
   .W ." C-" .G ." Copy "
   .W ." V-" .G ." Move "
   .W ." Y-" .G ." Delete "
   .W ." P-" .G ." Print"
   GetKey Drop
   RemoveWindow
;

: PRINTER
   beep
;

: EDIT
   True LocFlag !
   Locate
   128 SetStream
   Bl Word
   Dup c@
   If
      Dup >ASCIIz
      StringBuffer 0 78 Copy*
      11 13 SetCursorLines
      Load
   Then
   Begin
      DropAll
      11 13 SetCursorLines
      1 4 78 21 SetWindow
      ChangeFlag @ If c" * Else Bl Then 3 77 2 PutChar
      X @ Y @ GotoXY
      OutXY
      GetKey
      Case
         13 Of
            Enter
         EndOf
         8 Of
            Back
         EndOf
         9 Of
            X @ SX @ + OnLine !
            OnLine @ TabSpace @ + 253 <
            If
               Begin
                  OnLine 1+!
                  OnLine @ TabSpace @ Mod 0=
               Until
               OnLine @ SetXSX
            Then
            Locate
         EndOf
         27 Of
            ChangeFlag @
            IfNot
               Exit
            Then
            ?Save
            ExitFlag @
            If
               Exit
            Then
         EndOf
         11 Of
            BlockMenu
         EndOf
         F10 Of
            Exit
         EndOf
         22 Of
            Indent
         EndOf
         Delete Of
            Del
         EndOf
         InsKey Of
            Insert
            OutIndent
         EndOf
         HomeKey Of
            X 0!
            SX 0!
            Locate
         EndOf
         EndKey Of
            Y @ 256 * OperSeg @ ?Len SetXSX
            Locate
         EndOf
         PageUp Of
            StrUp @
            If
               Y @ >r False Y !
               False LocFlag !
               18 False Do OnUp Loop Locate
               True LocFlag !
               r> Y !
               Locate
            Else
               Y 0!
            Then
         EndOf
         PageDown Of
            StrDown @
            If
               Y @ >r 17 Y !
               False LocFlag !
               18 False Do OnDown Loop Locate
               True LocFlag !
               r> Y !
               Locate
            Else
               17 Y !
            Then
         EndOf
         Up Of
            OnUp
         EndOf
         Down Of
            OnDown
         EndOf
         Left Of
            OnLeft
         EndOf
         Right Of
            OnRight
         EndOf
         Alt+K Of
            DelString
         EndOf
         Ctrl+Y Of
            DelString
         EndOf
         Ctrl+Home Of
            " Moving to file beginning... Please, wait..."
            PushState CursorOff
            PutMessage
            >Beginning
            RemoveWindow
            PopState
            Locate
         EndOf
         Ctrl+End Of
            " Moving to file end... Please, wait..."
            PushState CursorOff
            PutMessage
            False LocFlag !
            Begin
               StrDown @
            While
               OnDown
            Repeat
            True LocFlag !
            17 Y ! X 0!
            RemoveWindow
            PopState
            Locate
         EndOf
         Ctrl+PageUp Of
            " Moving to file beginning... Press any key to interrupt..."
            PushState CursorOff
            PutMessage
            Begin
               StrUp @ ?Key 0= And
            While
               OnUp
            Repeat
            ?Key If Key Drop Then
            Y 0! X 0!
            RemoveWindow
            PopState
            Locate
         EndOf
         Ctrl+PageDown Of
            " Moving to file end... Press any key to interrupt..."
            PushState CursorOff
            PutMessage
            Begin
               StrDown @ ?Key 0= And
            While
               OnDown
            Repeat
            ?Key If Key Drop Then
            17 Y ! X 0!
            RemoveWindow
            PopState
            Locate
         EndOf
         10 Of
            " Quick view mode... Use '\24;' and '\25;' to change scroll speed..."
            PushState CursorOff
            PutMessage
            Begin
               NewPos
            While
            Repeat
            ?Key If Key Drop Then
            17 Y ! X 0!
            RemoveWindow
            PopState
            Locate
         EndOf
         F4 Of
            Printer
         EndOf
         F9 Of
            Shell
         EndOf
         F5 Of
            UserScreen
         EndOf
         F3 Of
            Load
         EndOf
         F1 Of
            EditHelp
         EndOf
         F2 Of
            Save
         EndOf
            Dup Bl <
            IfNot
               ." \ea\2;"
               InsFlag @ X @ SX @ + 255 < And
               If
                  Y @ 256 * OperSeg @ X @ SX @ + InsChar
               Then
               X @ 77 <
               If
                  Dup Y @ 256 * X @ + SX @ + OperSeg @ ac!
                  Emit X 1+!
               Else
                  SX @ 176 <
                  If
                     Dup Y @ 256 * X @ + SX @ + OperSeg @ ac!
                     SX 1+! Locate
                  Else
                     Drop
                  Then
               Then
               InsFlag @ If Locate Then
               True ChangeFlag !
            Then
      EndCase
   Again
;


: MAIN
   Search4Command
   250 Malloc
   IfNot ." Out of memory\r\n" Bye Then
   Vram2 !
   300 Malloc
   IfNot ." No room for buffer\r\n" Bye Then
   OperSeg !
   4200 Malloc
   IfNot ." No room for text\r\n" Bye Then
   TextSeg !
   $ 3301 Regs ! False Regs DX !
   Regs FDOS
   3 TabSpace !
   5 KeyTime !
   False X !
   False Y !
   False SX !
   False StrUp !
   False StrDown !
   False UpPnt !
   True DownPnt !
   True InsFlag !
   True IndentFlag !
   BlockFlag 0!
   ClearOper
   Title
   Edit
   Vram2 @ MFree Drop
   OperSeg @ MFree Drop
   TextSeg @ MFree Drop
   RestoreUser
;

False Messages !
' BYE ErrorProc !
True Debug !

build tc.com tc.map
