
;******************************************************************************
;*       ͻ   ɻ            Ŀ  Ŀ  Ŀ                          *
;*           ɼȻ                                                    *
;*            ͹        Ŀ  Ŀ   Ŀ  Ŀ ڿ   *
;*   Ȼɼ  ͻ                                          Ŀ  *
;*    ȼ   ͼ                              *
;******************************************************************************

                include forthasm.inc

; Copy Image Block Between Sprites ( 256 colors )
; ( SourceSpriteOffset SourceSpriteSegment SourceX SourceY
;   DestSpriteOffset DestSpriteSegment DestX DestY
;   SourceSizeX DestSizeX BlockSizeX BlockSizeY --> )
copy256_:       db      8,'$COPY256',0
                dw      0
                _copy256:
                pop     word ptr [time_y]
                pop     ax
                mov     word ptr [time_x],ax
                pop     bx
                pop     cx
                mov     word ptr [time_t],bx
                mov     word ptr [time_z],cx
                sub     word ptr [time_t],ax
                sub     word ptr [time_z],ax
                pop     ax
                mul     bx
                pop     di
                add     di,ax
                pop     es
                pop     ax
                add     di,ax
                pop     ax
                mul     cx
                pop     dx
                add     dx,ax
                pop     ds
                pop     ax
                push    si
                push    bp
                add     ax,dx
                mov     si,ax
                mov     dx,word ptr cs:[time_t]
                mov     bx,word ptr cs:[time_z]
                mov     bp,word ptr cs:[time_x]
                copy1:
                mov     cx,bp
                rep     movsb
                add     si,bx
                add     di,dx
                dec     word ptr cs:[time_y]
                jnz     copy1
                pop     bp
                pop     si
                push    cs
                pop     ds
                next

; Copy Image Block Between Sprites ( 255 colors )
; ( SourceSpriteOffset SourceSpriteSegment SourceX SourceY
;   DestSpriteOffset DestSpriteSegment DestX DestY
;   SourceSizeX DestSizeX BlockSizeX BlockSizeY --> )
copy255_:       db      8,'$COPY255',0
                dj      copy256_
                _copy255:
                pop     word ptr [time_y]
                pop     ax
                mov     word ptr [time_x],ax
                pop     bx
                pop     cx
                mov     word ptr [time_t],bx
                mov     word ptr [time_z],cx
                sub     word ptr [time_t],ax
                sub     word ptr [time_z],ax
                pop     ax
                mul     bx
                pop     di
                add     di,ax
                pop     es
                pop     ax
                add     di,ax
                pop     ax
                mul     cx
                pop     dx
                add     dx,ax
                pop     ds
                pop     ax
                push    si
                push    bp
                add     ax,dx
                mov     si,ax
                mov     dx,word ptr cs:[time_t]
                mov     bx,word ptr cs:[time_z]
                mov     bp,word ptr cs:[time_x]
                copy2:
                mov     cx,bp
                copy3:
                lodsb
                cmp     al,255
                jz      copy4
                stosb
                loop    copy3
                jmp     short copy5
                copy4:
                inc     di
                loop    copy3
                copy5:
                add     si,bx
                add     di,dx
                dec     word ptr cs:[time_y]
                jnz     copy2
                pop     bp
                pop     si
                push    cs
                pop     ds
                next

; Copy Image Block Between Sprites from higher addresses ( 256 colors )
; ( SourceSpriteOffset SourceSpriteSegment SourceX SourceY
;   DestSpriteOffset DestSpriteSegment DestX DestY
;   SourceSizeX DestSizeX BlockSizeX BlockSizeY --> )
copy256h_:      db      9,'$>COPY256',0
                dj      copy255_
                _copy256h:
                pop     word ptr [time_y]
                pop     ax
                mov     word ptr [time_x],ax
                pop     bx
                pop     cx
                mov     word ptr [time_t],bx
                mov     word ptr [time_z],cx
                sub     word ptr [time_t],ax
                sub     word ptr [time_z],ax
                pop     ax
                add     ax,word ptr [time_y]
                mul     bx
                pop     di
                add     di,ax
                pop     es
                pop     ax
                add     di,ax
                pop     ax
                add     ax,word ptr [time_y]
                mul     cx
                pop     dx
                add     dx,ax
                pop     ds
                pop     ax
                push    si
                push    bp
                add     ax,dx
                mov     si,ax
                mov     dx,word ptr cs:[time_t]
                mov     bx,word ptr cs:[time_z]
                mov     bp,word ptr cs:[time_x]
                dec     si
                dec     di
                std
                copy12:
                mov     cx,bp
                sub     si,bx
                sub     di,dx
                rep     movsb
                dec     word ptr cs:[time_y]
                jnz     copy12
                pop     bp
                pop     si
                push    cs
                pop     ds
                next

; ( SpriteOffset SpriteSegment X Y SpriteSizeX DX DY Color --> )
fill256_:       db      8,'$FILL256',0
                dj      copy256h_
                _fill256:
                pop     word ptr [time_t]
                pop     word ptr [time_y]
                pop     ax
                mov     word ptr [time_x],ax
                pop     bx
                mov     cx,bx
                sub     bx,ax
                pop     ax
                mul     cx
                pop     di
                add     di,ax
                pop     es
                pop     ax
                add     di,ax
                mov     dx,word ptr [time_x]
                mov     al,byte ptr [time_t]
                fill1:
                mov     cx,dx
                rep     stosb
                add     di,bx
                dec     word ptr [time_y]
                jnz     fill1
                next

; Copy Image Block Between Sprites ( 255 colors )
; ( SourceSpriteOffset BufferOffset SourceSpriteSegment SourceX SourceY
;   DestSpriteOffset DestSpriteSegment DestX DestY
;   SourceSizeX DestSizeX BlockSizeX BlockSizeY --> )
put255_:        db      7,'$PUT255',0
                dj      fill256_
                _put255:
                pop     word ptr [time_y]
                pop     ax
                mov     word ptr [time_x],ax
                pop     bx
                pop     cx
                mov     word ptr [time_t],bx
                mov     word ptr [time_z],cx
                sub     word ptr [time_t],ax
                sub     word ptr [time_z],ax
                pop     ax
                mul     bx
                pop     di
                add     di,ax
                pop     es
                pop     ax
                add     di,ax
                pop     ax
                mul     cx
                pop     dx
                add     dx,ax
                pop     ds
                pop     bx
                pop     ax
                push    si
                push    bp
                add     ax,dx
                add     bx,dx
                mov     si,ax
                mov     dx,word ptr cs:[time_t]
                mov     bp,word ptr cs:[time_z]
                copy8:
                mov     cx,word ptr cs:[time_x]
                copy9:
                mov     al,byte ptr es:[di]
                mov     byte ptr [bx],al
                inc     bx
                lodsb
                cmp     al,255
                jz      copy10
                stosb
                loop    copy9
                jmp     short copy11
                copy10:
                inc     di
                loop    copy9
                copy11:
                add     si,bp
                add     bx,bp
                add     di,dx
                dec     word ptr cs:[time_y]
                jnz     copy8
                pop     bp
                pop     si
                push    cs
                pop     ds
                next

; Copy Image Block Between Sprites ( 256 colors )
; ( SourceSpriteOffset BufferOffset SourceSpriteSegment SourceX SourceY
;   DestSpriteOffset DestSpriteSegment DestX DestY
;   SourceSizeX DestSizeX BlockSizeX BlockSizeY --> )
put256_:        db      7,'$PUT256',0
                dj      put255_
                _put256:
                pop     word ptr [time_y]
                pop     ax
                mov     word ptr [time_x],ax
                pop     bx
                pop     cx
                mov     word ptr [time_t],bx
                mov     word ptr [time_z],cx
                sub     word ptr [time_t],ax
                sub     word ptr [time_z],ax
                pop     ax
                mul     bx
                pop     di
                add     di,ax
                pop     es
                pop     ax
                add     di,ax
                pop     ax
                mul     cx
                pop     dx
                add     dx,ax
                pop     ds
                pop     bx
                pop     ax
                push    si
                push    bp
                add     ax,dx
                add     bx,dx
                mov     si,ax
                mov     dx,word ptr cs:[time_t]
                mov     bp,word ptr cs:[time_z]
                copy6:
                mov     cx,word ptr cs:[time_x]
                copy7:
                mov     al,byte ptr es:[di]
                mov     byte ptr [bx],al
                inc     bx
                movsb
                loop    copy7
                add     si,bp
                add     bx,bp
                add     di,dx
                dec     word ptr cs:[time_y]
                jnz     copy6
                pop     bp
                pop     si
                push    cs
                pop     ds
                next

; Exchange Image Blocks Between Sprites ( 255 colors )
; ( NewSpriteOffset OldBufferOffset NewSpriteSegment SpriteX SpriteY
;   DestSpriteOffset DestSpriteSegment DestX DestY
;   SourceSizeX DestSizeX BlockSizeX BlockSizeY --> )
exc255_:        db      12,'$EXCHANGE255',0
                dj      put256_
                _exc255:
                pop     word ptr [time_y]
                pop     ax
                mov     word ptr [time_x],ax
                pop     bx
                pop     cx
                mov     word ptr [time_t],bx
                mov     word ptr [time_z],cx
                sub     word ptr [time_t],ax
                sub     word ptr [time_z],ax
                pop     ax
                mul     bx
                pop     di
                add     di,ax
                pop     es
                pop     ax
                add     di,ax
                pop     ax
                mul     cx
                pop     dx
                add     dx,ax
                pop     ds
                pop     bx
                pop     ax
                push    si
                push    bp
                add     ax,dx
                add     bx,dx
                mov     si,ax
                mov     dx,word ptr cs:[time_t]
                mov     bp,word ptr cs:[time_z]
                exc1:
                mov     cx,word ptr cs:[time_x]
                exc2:
                lodsb
                cmp     al,255
                jz      exc3
                stosb
                inc     bx
                loop    exc2
                jmp     short exc4
                exc3:
                mov     al,byte ptr [bx]
                inc     bx
                stosb
                loop    exc2
                exc4:
                add     si,bp
                add     bx,bp
                add     di,dx
                dec     word ptr cs:[time_y]
                jnz     exc1
                pop     bp
                pop     si
                push    cs
                pop     ds
                next

; Read a Pixell
; ( SpriteOffset SpriteSegment SpriteSizeX X Y --> Color )
get_:           db      4,'$GET',0
                dj      exc255_
                _get:
                pop     ax
                pop     bx
                pop     di
                mul     di
                add     ax,bx
                pop     es
                pop     di
                add     di,ax
                mov     ah,0
                mov     al,byte ptr es:[di]
                push    ax
                next

; Set a Pixell
; ( SpriteOffset SpriteSegment SpriteSizeX X Y Color --> )
put_:           db      4,'$PUT',0
                dj      get_
                _put:
                pop     cx
                pop     ax
                pop     bx
                pop     di
                mul     di
                add     ax,bx
                pop     es
                pop     di
                add     di,ax
                mov     byte ptr es:[di],cl
                next

; Draw a Character
; ( SpriteOffset SrpriteSegment X Y SpriteXSize
;   CharOffset CharSegment CharXSize CharYSize CharColor BackColor --> )
putchr_:        db      8,'$PUTCHAR',0
                dj      put_
                _putchr:
                pop     ax
                pop     word ptr [time_t]               ; BackColor
                mov     byte ptr [time_t+1],al          ; CharColor
                pop     word ptr [time_z]               ; Lines (Char YSize)
                pop     word ptr [time_x]               ; Char XSize
                pop     ds                              ; Char Segment
                pop     bx                              ; Char Offset
                pop     ax
                mov     word ptr cs:[time_y],ax         ; Sprite XSize
                pop     dx                              ; Y
                mul     dx
                pop     di                              ; X
                add     di,ax
                pop     es                              ; Sprite Segment
                pop     ax
                add     di,ax                           ; Sprite Offset
                push    si
                push    bp
                mov     si,bx
                mov     dx,word ptr cs:[time_t]
                mov     bp,word ptr cs:[time_y]
                mov     cx,8
                pcx:
                sub     bp,word ptr cs:[time_x]
                loop    pcx
                ; bp = Increment DI
                mov     bx,word ptr cs:[time_z]
                pc0:
                lodsb
                mov     cx,word ptr cs:[time_x]
                pc1:
                call    putbyte_
                loop    pc1
                add     di,bp
                dec     bx
                jnz     pc0
                pop     bp
                pop     si
                push    cs
                pop     ds
                next
                putbyte_:
                ; al = byte
                ; ed:di ==> Sprite
                ; dl - color
                ; dh - back color
                push    cx
                mov     cx,8
                pb0:
                add     al,al
                jc      put_cl_
                cmp     dh,255
                jz      pb1
                mov     byte ptr es:[di],dh
                pb1:
                inc     di
                loop    pb0
                pop     cx
                ret
                put_cl_:
                mov     byte ptr es:[di],dl
                jmp     short pb1

; Changes Sprite Color
; ( SourceSpriteOffset SourceSpriteSegment SourceX SourceY
;   SourceSizeX BlockSizeX BlockSizeY ColorSrc ColorDest--> )
exch_cl_:       db      8,'$CHCOLOR',0
                dj      putchr_
                _exch_cl:
                pop     ax
                pop     word ptr [time_t]
                mov     byte ptr [time_t+1],al
                pop     word ptr [time_y]       ; Block Size Y
                pop     ax                      ;
                mov     word ptr [time_x],ax    ; Block Size X
                pop     cx                      ; Src Size X
                mov     word ptr [time_z],cx    ; INC
                sub     word ptr [time_z],ax
                pop     ax
                mul     cx
                pop     dx
                add     dx,ax
                pop     ds
                pop     ax
                push    si
                push    bp
                add     ax,dx
                mov     si,ax
                mov     dx,word ptr cs:[time_t]
                mov     bx,word ptr cs:[time_z]
                mov     bp,word ptr cs:[time_x]
                copyz1:
                mov     cx,bp
                mov     ax,word ptr cs:[time_t]
                copyz2:
                cmp     byte ptr [si],al
                jnz     copyz3
                mov     byte ptr [si],ah
                copyz3:
                inc     si
                loop    copyz2
                add     si,bx
                dec     word ptr cs:[time_y]
                jnz     copyz1
                pop     bp
                pop     si
                push    cs
                pop     ds
                next

; Copy Image Block Between Sprites ( 256 colors )
; ( SourceSpriteOffset SourceSpriteSegment SourceX SourceY
;   SourceSizeX BlockSizeX BlockSizeY TableOffset TableSegment --> )
decode_spr_:    db      10,'$TRANSLATE',0
                dj      exch_cl_
                _decode_spr_:
                pop     word ptr [err_bp]       ; Table segment
                pop     word ptr [err_sp]       ; Table offset
                pop     word ptr [time_y]       ; Block Size Y
                pop     ax                      ;
                mov     word ptr [time_x],ax    ; Block Size X
                pop     cx                      ; Src Size X
                mov     word ptr [time_z],cx    ; INC
                sub     word ptr [time_z],ax
                pop     ax
                mul     cx
                pop     dx
                add     dx,ax
                pop     es
                pop     ax
                push    si
                push    bp
                add     ax,dx
                mov     di,ax
                mov     dx,word ptr cs:[time_t]
                mov     si,word ptr cs:[time_z]
                mov     bp,word ptr cs:[time_x]
                mov     ds,word ptr cs:[err_bp]
                mov     bx,word ptr cs:[err_sp]
                copyz111:
                mov     cx,bp
                copyz211:
                mov     al,byte ptr es:[di]
                xlat
                mov     byte ptr es:[di],al
                inc     di
                loop    copyz211
                add     di,si
                dec     word ptr cs:[time_y]
                jnz     copyz111
                pop     bp
                pop     si
                push    cs
                pop     ds
                next

init_:          db      1,' ',0
                dj      decode_spr_
                next

                dw      100h
                dw      init_-100h
                include vers.inc
                dw      1231h

                end     module
